<?php
/**
 * @package WordPress
 * @subpackage Jessica_Fletcher_Redux
 */
load_theme_textdomain('jfr_theme');
$themename = "Jessica-Fletcher-Redux";
$shortname = "jfr";
$options = array (

array(    "name" => __("Options Panel.", "jfr_theme"),
        "type" => "title"),

array(    "type" => "open"),

array(    "name" => __("Accent Color", "jfr_theme"),
        "desc" => __("Default: #F90.", "jfr_theme"),
        "id" => $shortname."_accent_color",
        "std" => "#F90",
		"id2" => "1",
        "type" => "color"),
array(    "name" => __("Tag Cloud Color", "jfr_theme"),
        "desc" => __("The tag cloud color determines the color of the tag with the most topics. Works only with the tag cloud in the sidebar box. Doesn't work in ie. Default: #333.", "jfr_theme"),
        "id" => $shortname."_tag_color",
        "std" => "#333",
		"id2" => "2",
        "type" => "color"),
array(    "name" => __("Top Background Color", "jfr_theme"),
        "desc" => __("The tag cloud color determines the color of the tag with the most topics. Works only with the tag cloud in the sidebar box. Default: #FFF.", "jfr_theme"),
        "id" => $shortname."_top_color",
        "std" => "#FFF",
		"id2" => "3",
        "type" => "color"),
array(    "name" => __("Font Replacement", "jfr_theme"),
        "desc" => __("The title font is automatically rendered in Museo(by Jos Buivenga -> www.exljbris.com). Disabling it reverts the title to Arial/Helvetica.<br>Default: on", "jfr_theme"),
        "id" => $shortname."_font_replacement",
		"std" => "on",
        "type" => "select",
		"options" => array("on", "off")),

array(    "name" => __("Extra Links", "jfr_theme"),
        "desc" => __("In order to add extra links to the navigation bar at the top enter a url (without http://) and a title separated by a semicolon and a space. You can add as many links as you like. Just make sure to separate everything with a semicolon and a space.<br><em>Example: twitter.com/ueberleben; Le Twitter; www.spaceperson.net; Spaceperson</em><br>Default is blank ", "jfr_theme"),
        "id" => $shortname."_extra_link",
		"std" => "",
        "type" => "textarea"),

array(    "name" => __("Description", "jfr_theme"),
        "desc" => __("This allows you to toggle the description in the title. <br>Default: off", "jfr_theme"),
        "id" => $shortname."_description",
		"std" => "off",
        "type" => "select",
		"options" => array("off", "on")),

array(    "name" => __("Sidebox Widget Title", "jfr_theme"),
        "desc" => __("This allows you to toggle the widget title in the sidebar box. <br>Default: on", "jfr_theme"),
        "id" => $shortname."_sidebox_title",
		"std" => "on",
        "type" => "select",
		"options" => array("on", "off")),

array(    "name" => __("Show Author", "jfr_theme"),
        "desc" => __("This allows you to toggle the author name. <br>Default: off", "jfr_theme"),
        "id" => $shortname."_show_author",
		"std" => "off",
        "type" => "select",
		"options" => array("off", "on")),

array(    "name" => __("Color last word in title", "jfr_theme"),
        "desc" => __("The last word in the title is automatically rendered in the accent color. Disabling it reverts it to dark grey. <br>Default: on", "jfr_theme"),
        "id" => $shortname."_orange",
		"std" => "on",
        "type" => "select",
		"options" => array("on", "off")),

array(    "name" => __("Sidebar Box Widgets", "jfr_theme"),
        "desc" => __("Select which widgets you want to appear in the sidebar box. The topmost entries will be rendered first. If nothing is selected the default selection of Twitter, Recent Comments, Recent Posts, Tag Cloud and Archives will be shown. Hold down ctrl to select multiple entries<br>Default: blank", "jfr_theme"),
        "id" => $shortname."_nav_box",
		"std" => "Default",
        "type" => "multiselect",
		"options" => array("Twitter", "Recent Comments", "Recent Posts", "Calendar", "Popular Posts", "Tag Cloud", "Categories", "Search", "Archives")),

array(    "name" => __("Sidebar Box Widget Order", "jfr_theme"),
        "desc" => __("This allows you to override the default order of widgets in the sidebar box. Enter the first three letters of each widget you'd like to see and separate them with a comma and a space. If a widget title consists of two words append the first three letters of the first word with the first three letters of the second. Widget title can be found in the list above. Example: <em>TagClo, Twi, PopPos, Sea, Arc</em> outputs the tag cloud, the Twitter widget, the most popular posts, the search widget and the archives list. <br>Default: blank", "jfr_theme"),
        "id" => $shortname."_sidebox_order",
		"std" => "",
        "type" => "text"),

array(    "name" => __("Pages", "jfr_theme"),
        "desc" => __("Select the pages you don't want to appear in the navigation at the top. Hold down ctrl to select multiple entries. <br>Default: blank", "jfr_theme"),
        "id" => $shortname."_page_box",
		"std" => "",
        "type" => "multiselect",
		"options" => formatted_page_array()),

array(    "name" => __("Twitter Username", "jfr_theme"),
        "desc" => __("Enter your Twitter username here. <strong> Enter a blank space to toggle the icon's visibility </strong>.<br>Default: wordpress", "jfr_theme"),
        "id" => $shortname."_twitter",
		"std" => "",
        "type" => "text"),
array(    "name" => __("Facebook Link", "jfr_theme"),
        "desc" => __("Enter your Facebook link here. <strong> Enter a blank space to toggle the icon's visibility </strong>.<br>Default: http://www.facebook.com/", "jfr_theme"),
        "id" => $shortname."_facebook",
		"std" => "http://www.facebook.com/",
        "type" => "text"),
array(    "name" => __("YouTube Link", "jfr_theme"),
        "desc" => __("Enter your YouTube link here. <strong> Enter a blank space to toggle the icon's visibility </strong>. <br>Default: http://www.youtube.com", "jfr_theme"),
        "id" => $shortname."_youtube",
		"std" => "http://www.youtube.com",
        "type" => "text"),
array(    "type" => "close")

);
function formatted_page_array() {
	$pages = get_pages('parent=0');
	$ret = array();
	foreach ($pages as $page) {
		$ret[] = $page->post_title;
		}
	return  $ret;
	}
function page_navigation($raw_pages) {
	$thepages = explode(",", $raw_pages);
	
for ($i = 0; $i < count($thepages); $i++){ // Gets page-id of excluded pages by page-title
	$page = get_page_by_title($thepages[$i]);
	$page_list .= $page->ID;
	if ($i != count($thepages)-1){
		$page_list .= ', ';
		}
	}
return wp_list_pages('exclude='.$page_list.'&depth=1&title_li='); // Constructs nav bar on top
	}
	
function mytheme_add_admin() {

    global $themename, $shortname, $options;

    if ( $_GET['page'] == basename(__FILE__) ) {
    
        if ( 'save' == $_REQUEST['action'] ) {

                foreach ($options as $value) {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

                foreach ($options as $value) {
					if(($value['type'] === "checkbox" or $value['type'] === "multiselect" ) and is_array($_REQUEST[ $value['id'] ])){$_REQUEST[ $value['id'] ]=implode(',',$_REQUEST[ $value['id'] ]);}
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
				
                header("Location: themes.php?page=functions.php&saved=true");
                die;

        } else if( 'reset' == $_REQUEST['action'] ) {

            foreach ($options as $value) {
                delete_option( $value['id'] ); 
				update_option( $value['id'], $value['std'] );}

            header("Location: themes.php?page=functions.php&reset=true");
            die;

        }
    }

    add_theme_page($themename." Options", "".$themename." Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}

add_filter('gallery_style', create_function('$a', 'return "
<div class=\'gallery\'>";'));

define('HEADER_TEXTCOLOR', 'ffffff');
define('HEADER_IMAGE', ''); // %s is the template dir uri
define('HEADER_IMAGE_WIDTH', 900); // use width and height appropriate for your theme
define('HEADER_IMAGE_HEIGHT', 150);


function create_tag_cloud(){
	$tag = wp_tag_cloud('format=string&echo=0' );
	$topic_count = explode("title='", $tag);
	$tag_name = explode(";'>", $tag);
	$tag_style = explode("style='", $tag);
	$topicnr = count($topic_count)-1;
	$topic_numbers = array();
	for ($i = 1; $i < $topicnr; $i++){
				$topic_counter = explode(" topic", $topic_count[$i]);
		array_push($topic_numbers, "$topic_counter[0]");
	}
	$maxtopic = max($topic_numbers);
	for ($i = 1; $i < $topicnr+1; $i++){
				$topic_counter = explode(" topic", $topic_count[$i]);
				$tag_namer = explode("</a>", $tag_name[$i]);
				$tag_namer = explode(" ", $tag_namer[0]);
				$tag_styler = explode("'>", $tag_style[$i]);
				$color = round($topic_counter[0]/$maxtopic, 1);
				$color = str_replace(".", "", $color );
		echo '<a href="'.get_bloginfo('home').'/tag/'.$tag_namer[0];
		for ($h=1; $h < count($tag_namer); $h++){
			echo '-'.$tag_namer[$h];
			}
		echo '" class="tag'.$color.'" title="'.$topic_counter[0].' topic';
		if ($topic_counter[0]>1){ echo 's';}
		echo '" style="'.$tag_styler[0].'">';
		for ($h=0; $h < count($tag_namer); $h++){
			echo ' '.$tag_namer[$h];
			}
		echo '</a> ';
	}
	}
function generatetwitter($twittername){
	
$username = $twittername; // Your twitter username. 
if ($username == ""){
	$username = "wordpress";
	}


$limit = "5"; // Number of tweets to pull in.  
/* These prefixes and suffixes will display before and after the entire block of tweets. */  
$prefix = ""; // Prefix - some text you want displayed before all your tweets.  
$suffix = ""; // Suffix - some text you want displayed after all your tweets.  
$tweetprefix = "<li>"; // Tweet Prefix - some text you want displayed before each tweet.  
$tweetsuffix = "</li>"; // Tweet Suffix - some text you want displayed after each tweet.  
  
$feed = "http://search.twitter.com/search.atom?q=from:" . $username . "&rpp=" . $limit;  

function parse_feed($feed, $prefix, $tweetprefix, $tweetsuffix, $suffix, $username) {  
	$feed = str_replace("&lt;", "<", $feed);  
	$feed = str_replace("&gt;", ">", $feed);  
	$clean = explode("<content type=\"html\">", $feed);  
	$link = explode("search.twitter.com,2005:", $feed);  
	$amount = count($clean) - 1;  
	echo $prefix;  
		for ($i = 1; $i <= $amount; $i++) {  
			$cleaner = explode("</content>", $clean[$i]);
			$linker = explode("</id>", $link[$i+1]);
			$this_tweets = str_replace("&amp;apos;", "'", $cleaner[0]);
			$this_tweets = str_replace("&amp;gt;", ">", $this_tweets);  
			$this_tweets = preg_replace('!<a href.*?>!', '', $this_tweets); 
			$this_tweets = preg_replace('!</a>!', '', $this_tweets); 
			echo $tweetprefix.'<a href="http://twitter.com/'.$username.'/status/';  
			echo $linker[0];
			echo '" target="_blank">'.$this_tweets.'</a>';  
			echo $tweetsuffix;  
		}  
	echo $suffix; 
}  

$twitter_cache_file = get_theme_root().'/jessica-fletcher-redux/cache/twittercache.xml';

$mtime= null;

if($mtime== null ||(time()-$mtime)>(9*60)){// 9 minutes or older?
    $content=@file_get_contents($feed);
    if(strlen($content)>0){
        $cache_static=@fopen($twitter_cache_file,'wb');
        @fwrite($cache_static,$content);
        @fclose($cache_static);
    }
}
else {
	
	$mtime=filemtime($twitter_cache_file);
	}

if (!@file_get_contents($twitter_cache_file)){
	  echo __('Oops, something went wrong. Did you rename the cache folder? The cache file? You shouldn\'t have done that...', 'jfr_theme');
	  }
  else {
	  $twitterFeed = @file_get_contents($twitter_cache_file); 
	  }
 
parse_feed($twitterFeed, $prefix, $tweetprefix, $tweetsuffix, $suffix, $username);  


}


function construct_recent_comments() {

$comments = get_comments('number=5');
  
if ($comments) {
    echo '<ul>';
    foreach ($comments as $comment) {
        $url = ' <a href="'. get_permalink($comment->comment_post_ID).'#comment-'.$comment->comment_ID .'" title="'.$comment->comment_author .' | '.get_the_title($comment->comment_post_ID).'">';
        echo '<li>';
		echo '<h4 class="light"><em>'.$comment->comment_author.'</em> on</h4>';
		echo '<a href="#" style="display:none"></a>';
		 echo $url;
        echo get_the_title($comment->comment_post_ID);
        echo '</a>';
        echo '</li>';
    }
    echo '</ul>';
}
}


function generate_sidebar_box($jfr_twitter, $jfr_sidebox_order, $jfr_nav_box, $jfr_sidebox_title){
$active_tabs = array();
if ($jfr_sidebox_order == "" && $jfr_nav_box != "Default"){
	$selected_tabs = explode(',', $jfr_nav_box);
		for ($i = 0; $i < count($selected_tabs); $i++ ){
			$active_tabs_w = explode(' ', $selected_tabs[$i]);
			$active_tabs[] = substr($active_tabs_w[0], 0, 3);
			$active_tabs[$i] .= substr($active_tabs_w[1], 0, 3);
		}
	}
else if ($jfr_sidebox_order == "" && $jfr_nav_box == "Default") {
	$active_tabs[0] = "Twi";
	$active_tabs[1] = "RecCom";
	$active_tabs[2] = "RecPos";
	$active_tabs[3] = "PopPos";
	$active_tabs[4] = "TagClo";
	
	}
else {
	$active_tabs = explode(', ', $jfr_sidebox_order);
	}
	echo '<ul id="sidebar_tabs">';
for ($i = 0; $i < count($active_tabs); $i++ ){
	switch ($active_tabs[$i]) {
		case "Twi":
			echo '<li><h5 id="icon_twitter" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_twitter"  style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;"  title="'.__('Latest Tweets', 'jfr_theme').'"></a></li>';
			break;
		case "RecCom":
			 echo '<li><h5 id="icon_recent-comments" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_recent_comments"  style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;" title="'.__('Recent Comments', 'jfr_theme').'"></a></li>';
			break;
		case "RecPos":
			echo '<li><h5 id="icon_recent-posts" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_recent_posts" style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;" title="'.__('Recent Posts', 'jfr_theme').'"></a></li>';
			break;
		case "Cal":
			echo '<li><h5 id="icon_calendar" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_calendar" style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;" title="'.__('Calendar', 'jfr_theme').'"></a></li>';
			break;
		case "PopPos":
			echo '<li><h5 id="icon_popular-posts" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_popular_posts" style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;" title="'.__('Popular Posts', 'jfr_theme').'"></a></li>';
			break;
		case "TagClo":
			 echo '<li><h5 id="icon_tags" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_tag_cloud" style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;" title="'.__('Tags', 'jfr_theme').'"></a></li>';
			break;
		case "Cat":
			echo '<li><h5 id="icon_categories" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_categories" style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;" title="'.__('Categories', 'jfr_theme').'"></a></li>';
			break;
		case "Sea":
			  echo '<li><h5 id="icon_search" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_search" style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;" title="'.__('Search', 'jfr_theme').'"></a></li>';
			break;
		case "Arc":
			echo '<li><h5 id="icon_archives" ';
			echo 'style="left:' . $i*52 . 'px;"';
			echo '></h5><a href="#sb_widget_archive" style="
			width:51px;
			height:34px;
			display:block;
			position:absolute;';
			echo 'left:' . $i*52 . 'px;';
			echo 'z-index:10;" title="'.__('Archives', 'jfr_theme').'"></a></li>';
			break;
		default;
	}
}
echo '</ul><div id="sidebar_box" class="ui-tabs"><div class="sb_corner_tl"></div><div class="corner_tr"></div>';
for ($i = 0; $i < count($active_tabs); $i++ ){
	switch ($active_tabs[$i]) {
		case "Twi":
			echo '<div id="sb_widget_twitter">';
			
			if ($jfr_sidebox_title == "on"){  
				echo '<hr/><h2>'.__('Latest Tweets', 'jfr_theme').'</h2>';
			} 
			else { echo '<br>';}
			echo '<ul>';
			generatetwitter($jfr_twitter); 
			echo '</ul></div>';
		break;
		case "RecCom":
			 echo '<div id="sb_widget_recent_comments">';
			 if ($jfr_sidebox_title == "on"){ 
			 	echo '<hr/><h2>'.__('Recent Comments', 'jfr_theme').'</h2>';
			} 
			else { echo '<br>';}
			construct_recent_comments(); 
			echo '</div>';
			break;
		case "RecPos":
			echo '<div id="sb_widget_recent_posts" >';
			if ($jfr_sidebox_title == "on"){  
         	   echo '<hr/><h2>'.__('Recent Posts', 'jfr_theme').'</h2>';
			} 
			else { echo '<br>';}
            the_widget('WP_Widget_Recent_Posts', 'title= &number=5', '');
            echo '</div>';
			break;
		case "Cal":
			echo '<div id="sb_widget_calendar" >';
			if ($jfr_sidebox_title == "on"){  
			echo '<hr/><h2>'.__('Calendar', 'jfr_theme').'</h2>';
			} 
			else { echo '<br>';}
			the_widget('WP_Widget_Calendar', 'title= ', '');
			echo '</div>';
			break;
		case "PopPos":
			echo '<div id="sb_widget_popular_posts" >';
			if ($jfr_sidebox_title == "on"){  
            echo '<hr/><h2>'.__('Popular Posts', 'jfr_theme').'</h2>';
			} 
			else { echo '<br>';}
            echo '<ul>';
			most_popular_posts(); 
			echo '</ul></div>';
			break;
		case "TagClo":
			 echo '<div id="sb_widget_tag_cloud"  >';
			 if ($jfr_sidebox_title == "on"){  
			 echo '<hr/><h2>'.__('Tags', 'jfr_theme').'</h2>';
			 } 
			 else { echo '<br>';}
			 create_tag_cloud();
             echo '</div>';
			break;
		case "Cat":
			echo '<div id="sb_widget_categories" >';
			if (jfr_sidebox_title == "on"){  
            echo '<hr/><h2>'.__('Categories', 'jfr_theme').'</h2>';
			} 
			else { echo '<br>';}
			the_widget('WP_Widget_Categories', 'title=', '');
            echo '</div>';
			break;
		case "Sea":
			  echo '<div id="sb_widget_search" >';
			  if ($jfr_sidebox_title == "on"){  
              echo '<hr/><h2>'.__('Search', 'jfr_theme').'</h2>';
			  } 
			  else { echo '<br>';}
			  the_widget('WP_Widget_Search', 'title=', '');
              echo '</div>';
			break;
		case "Arc":
			echo '<div id="sb_widget_archive" >';
			if ($jfr_sidebox_title == "on"){  
            	echo '<hr/><h2>'.__('Archives', 'jfr_theme').'</h2>';
				} 
				else { echo '<br>';}
				the_widget('WP_Widget_Archives', 'title= ', '');
                echo '</div>';
			break;
	}
}
echo '<div class="corner_bl"></div>
	<div class="corner_br"></div>
	<div class="sidebar_bottom"></div>';
}


// gets included in the site header
function header_style() {
    ?><style type="text/css">
        #header {
            background: url(<?php header_image(); ?>) no-repeat;
		}
		
	
	<?php 
	$headerimage = get_header_image();
	if ($headerimage != ""){ ?>
	#header h1,#header h1 a,#header h1 a:visited {
			color:#<?php header_textcolor(); ?>;
        }
	
	.description {
		color: #<?php header_textcolor(); ?>;
	}
	<?php } ?>
    </style><?php
}


// gets included in the admin header
function admin_header_style() {
    ?><style type="text/css">
        #headimg {
            width: <?php echo HEADER_IMAGE_WIDTH; ?>px;
            height: <?php echo HEADER_IMAGE_HEIGHT; ?>px;
        }
    </style><?php
}

add_custom_image_header('header_style', 'admin_header_style');

	function add_new_var_to_wp($public_query_vars) {
		$public_query_vars[] = 'css';
		return $public_query_vars;
	}
	function dynamic_css_display(){
		$css = get_query_var('css');
		if ($css == 'css'){
			include_once (TEMPLATEPATH . '/dynamic-css.php');
			exit;
		}
	}

	add_filter('query_vars', 'add_new_var_to_wp');
	add_action('template_redirect', 'dynamic_css_display');


function mytheme_comment($comment, $args, $depth) {
   $GLOBALS['comment'] = $comment; ?> 
   <li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>" style="width:<?php 
   echo 570-$depth*20; ?>px">
  <div class="comment-author vcard">
             <?php echo get_avatar($comment,$size='48' ); ?>
          </div><!--.comment-author vcard-->
     <div id="comment-<?php comment_ID(); ?>" class="commentbox">
          <?php if ($comment->comment_approved == '0') : ?>
             <em><?php _e('Your comment is waiting for approval.','jfr_theme') ?></em>
             <br />
          <?php endif; ?>
    
          <div class="comment-meta commentmetadata"><cite><?php echo get_comment_author_link() ?></cite><br /><a href="<?php echo htmlspecialchars( get_comment_link( $comment->comment_ID ) ) ?>"><?php printf(__('%1$s at %2$s', 'jfr_theme'), get_comment_date(), get_comment_time()) ?></a><?php edit_comment_link(__('(Edit)', 'jfr_theme'),'  ','') ?></div><!--.comment-meta-->
	<div class="comment_body">
      <?php comment_text();?>

      <div class="reply">
         <?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
      </div><!--.reply-->
      </div><!--.commentbody-->
     </div><!--#comment-<?php comment_ID(); ?>-->
<?php
        }
function my_init_method() {
	if (!is_admin())
	{
	
wp_deregister_script( 'jquery' );
wp_register_script(   'jquery'
    , get_bloginfo('template_directory') . '/js/jquery-1.4.2.min.js');
wp_deregister_script( 'cufon' );
wp_register_script(   'cufon' ,  get_bloginfo('template_directory') . '/js/cufon-yui.js');
wp_deregister_script( 'cufon_museo' );
wp_register_script(   'cufon_museo' ,  get_bloginfo('template_directory') . '/js/Bitstream_Vera_Sans_400.font.js');
wp_deregister_script( 'cufon_init' );
wp_register_script(   'cufon_init' ,  get_bloginfo('template_directory') . '/js/initializer.js');
wp_deregister_script( 'jqutabs' );
wp_register_script(   'jqutabs' ,  get_bloginfo('template_directory') . '/js/jquery.idTabs.min.js');
}    
}
add_action('init', 'my_init_method');

function most_popular_posts($no_posts = 5, $before = '<li>', $after = '</li>') {
global $wpdb;

$request = "SELECT ID, post_title, COUNT($wpdb->comments.comment_post_ID) AS %s FROM $wpdb->posts, $wpdb->comments";
$request .= " WHERE comment_approved = %s AND $wpdb->posts.ID=$wpdb->comments.comment_post_ID AND post_status = %s";
$request .= " GROUP BY $wpdb->comments.comment_post_ID ORDER BY comment_count DESC LIMIT $no_posts";

$posts = $wpdb->get_results( $wpdb->prepare( $request, 'comment_count', '1', 'publish' ) );
$output = '';
if ($posts) {
foreach ($posts as $post) {
$post_title = stripslashes($post->post_title);
$comment_count = $post->comment_count;
$permalink = get_permalink($post->ID);
$output .= $before . '<a href="' . $permalink . '" title="' . $post_title.'">' . $post_title . ' (' . $comment_count.')</a>' . $after;
}
} else {
$output .= $before . "None found" . $after;
}
echo $output;
} 

function custom_pings($comment, $args, $depth) {
   $GLOBALS['comment'] = $comment; ?> 
  
   <li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
        <div id="comment-<?php comment_ID(); ?>" class="commentbox">
     
    
          <?php if ($comment->comment_approved == '0') : ?>
             <em><?php _e('Your comment is waiting for approval.', 'jfr_theme') ?></em>
             <br />
          <?php endif; ?>
    
          <div class="comment-meta commentmetadata"><cite class="fn"><?php echo get_comment_author_link() ?></cite><br /><a href="<?php echo htmlspecialchars( get_comment_link( $comment->comment_ID ) ) ?>"><?php printf(__('%1$s at %2$s', 'jfr_theme'), get_comment_date(),  get_comment_time()) ?></a><?php edit_comment_link(__('(Edit)', 'jfr_theme'),'  ','') ?></div><!--.comment-meta-->
     </div><!--#comment-<?php comment_ID(); ?>-->
<?php
        }

function mytheme_admin() {

    global $themename, $shortname, $options;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';

?>
<div class="wrap">
<h2><?php echo $themename; ?> settings</h2>

<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_donations">
<input type="hidden" name="business" value="marcuseckert@gmail.com">
<input type="hidden" name="lc" value="US">
<input type="hidden" name="item_name" value="spaceperson.net">
<input type="hidden" name="currency_code" value="USD">
<input type="hidden" name="bn" value="PP-DonationsBF:paypal_btn.png:NonHostedGuest">
<input type="image" src="<?php bloginfo('template_directory')?>/images/paypal_btn.png" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
<form method="post">
<input name="save" type="submit" value="<?php _e('Save changes', 'jfr_theme')?>" />
<input type="hidden" name="action" value="save" />
<?php foreach ($options as $value) {

switch ( $value['type'] ) {

case "open":
?>
<table width="100%" border="0" style="padding:10px">

<?php break;

case "close":
?>

</table><br />

<?php break;

case "title":
?>
<table width="100%" border="0" style="padding:5px 10px; border-bottom:2px dotted #ccc"><tr>
    <td colspan="2"><h3 style="font-family:Georgia,'Times New Roman',Times,serif; letter-spacing:-1px; font-size:20px"><?php echo $value['name']; ?></h3></td>
</tr>

<?php break;

case 'text':
?>

<tr>
    <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
    <td width="80%"><input style="width:400px;" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" /></td>
</tr>

<tr>
    <td><small><?php echo $value['desc']; ?></small></td>
</tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #ccc;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>

<?php
break;

case 'color':
?>
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js" type="text/javascript"></script>
<script type="text/javascript" src="<?php bloginfo('template_directory') ?>/js/farbtastic.js"></script>
<link rel="stylesheet" href="<?php bloginfo('template_directory') ?>/js/farbtastic.css" type="text/css" />
<tr>
    <td width="20%" rowspan="3" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
</tr>
<tr>
    <td width="40%" id="colorpicker<?php echo $value['id2']; ?>"></td>
    <script type="text/javascript">
  $(document).ready(function() {
    $('#colorpicker<?php echo $value['id2']; ?>').farbtastic('#<?php echo $value['id']; ?>');
  });
</script>
</tr>
<tr>
    <td><input style="width:200px;" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" /><br><small><?php echo $value['desc']; ?></small></td>
</tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #ccc;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>

<?php
break;

case 'textarea':
?>

<tr>
    <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
    <td width="80%"><textarea name="<?php echo $value['id']; ?>" style="width:400px; height:100px;" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?></textarea></td>

</tr>

<tr>
    <td><small><?php echo $value['desc']; ?></small></td>
</tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #ccc;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>

<?php
break;

case 'select':
?>
<tr>
    <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
    <td width="80%"><select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
<?php foreach ($value['options'] as $option) { ?>
		<option <?php if (get_settings( $value['id'] ) == $option) { echo 'selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?>
</select></td>
</tr>

<tr>
    <td><small><?php echo $value['desc']; ?></small></td>
</tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #ccc;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>



<?php
break;

case 'multiselect':
?>
<tr valign="middle"> 
        <th scope="top" style="text-align:left;"><?php echo $value['name']; ?>:</th>
	
        <td>		
            <select  multiple="multiple" size="3" name="<?php echo $value['id']; ?>[]" id="<?php echo $value['id']; ?>" style="height:250px;">
                <?php $ch_values=explode(',',get_settings( $value['id'] )); 
			 
				 foreach ($value['options'] as $option) { ?>
                <option<?php if ( in_array($option,$ch_values)) { echo ' selected="selected"'; }?> value="<?php echo $option; ?>"><?php echo $option; ?></option>
                <?php } ?>
            </select>		
        </td>
    </tr>
	<?php if(isset($value['desc'])){?>
	<tr>
	<th scope="top" style="text-align:left;"></th>
		<td><small><?php echo $value['desc']?></small></td></tr>
	<?php } ?>
<tr><td colspan=2><hr /></td></tr>
<?php
break;

case "checkbox":
?>
    <tr>
    <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
        <td width="80%"><?php if ( get_settings($value['id']))
		{ $checked = "checked=\"checked\""; }
			else{ $checked = ""; } ?>
                <input type="checkbox" value="1" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" <?php echo $checked; ?> />
                </td>
    </tr>

    <tr>
        <td><small><?php echo $value['desc']; ?></small></td>
   </tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #ccc;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>
<div class="rm_input rm_checkbox">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>

<?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "checked=\"unchecked\"";} ?>
<input value="1" type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>"<?php echo $checked; ?> />

	<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
 </div>
<?php         break;

}
}
?>
<table width="50%"><tr>
<td width="20%">
<input name="save" type="submit" value="<?php _e('Save changes', 'jfr_theme')?>" />
<input type="hidden" name="action" value="save" />

</form></td><td width="20%">
<form method="post">

<input name="reset" type="submit" value="<?php _e('Reset', 'jfr_theme')?>" />
<input type="hidden" name="action" value="reset" />

</form></td><td>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_donations">
<input type="hidden" name="business" value="marcuseckert@gmail.com">
<input type="hidden" name="lc" value="US">
<input type="hidden" name="item_name" value="spaceperson.net">
<input type="hidden" name="currency_code" value="USD">
<input type="hidden" name="bn" value="PP-DonationsBF:paypal_btn.png:NonHostedGuest">
<input type="image" src="<?php bloginfo('template_directory')?>/images/paypal_btn.png" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form></td></tr></table>
<?php
}

global $widget_count;
add_action('admin_menu', 'mytheme_add_admin'); 

automatic_feed_links();

if ( function_exists('register_sidebar') )
	register_sidebar(array(
			'name' => 'sidebar',			   
		'before_widget' => '<div class="sidebar_widget"><div class="sb_corner_tl"></div><div class="corner_tr"></div><div class="sidebar_top"></div><div id="%2$s" class="widget %1$s">',
		'after_widget' => '</div><div class="corner_bl"></div><div class="corner_br"></div>
     <div class="sidebar_bottom"></div></div>',
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	));
register_sidebar(array(
			'name' => 'footercell-left',			   
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div><div class="divider"></div>',
		'before_title' => '<h2>',
		'after_title' => '</h2><div class="line"></div>',
	));
register_sidebar(array(
			'name' => 'footercell-middle',			   
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div><div class="divider"></div>',
		'before_title' => '<h2>',
		'after_title' => '</h2><div class="line"></div>',
	));
register_sidebar(array(
			'name' => 'footercell-right',			   
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div><div class="divider"></div>',
		'before_title' => '<h2>',
		'after_title' => '</h2><div class="line"></div>',
	));
?>
