<?php
/**
 * @package WordPress
 * @subpackage Jessica_Fletcher_Redux
 */

get_header();
?>
<div class="content_container">
<?php get_sidebar(); ?>
	<div id="content" class="singlepage">
  <?php if (have_posts()) : while (have_posts()) : the_post(); ?>
<div class="navigation"><?php previous_post_link('%link', __('back to %title', 'jfr_theme')) ?></div><!--.navigation-->
		<div class="post" id="post-<?php the_ID(); ?>">
    	    <div class="corner_tl"></div>
			<div class="corner_tr"></div>
            <div class="post_top"></div>
			<h2><a href="<?php echo get_permalink($post->post_parent); ?>" rev="attachment"><?php echo get_the_title($post->post_parent); ?></a> &raquo; <?php the_title(); ?></h2>
			<div class="entry">
				<div class="centered"><a href="<?php echo wp_get_attachment_url($post->ID); ?>"><?php echo wp_get_attachment_image( $post->ID, 'large' ); ?></a></div>
				<div class="caption"><?php if ( !empty($post->post_excerpt) ) the_excerpt(); // this is the "caption" ?></div>
				<?php the_content(__('<span class="read_more">read more &raquo;</span>', 'jfr_theme')); ?>
				<br class="clear" />
					<div class="alignleft"><?php previous_image_link() ?></div>
					<div class="alignright"><?php next_image_link() ?></div>
				<br class="clear" />
				<p class="postmetadata">
					<small>
                   <?php printf(__('<img src="'.get_bloginfo('template_directory').'/images/clock.gif" alt="Time" /> %1$s, %2$s', 'jfr_theme'), get_the_time('l, F jS, Y'), get_the_time()); ?>
                  &nbsp;&nbsp;&#124;&nbsp;&nbsp; <img src="<?php bloginfo('template_directory'); ?>/images/folder.gif" alt="<?php _e('Category', 'jfr_theme') ?>" /><?php the_category(', ') ?>&nbsp;&nbsp;&#124;&nbsp;&nbsp;<img src="<?php bloginfo('template_directory')?>/images/transmission.gif" alt="<?php _e('RSS', 'jfr_theme') ?>" /><?php post_comments_feed_link(__('RSS feed', 'jfr_theme')); ?>

						<?php if ( comments_open() && pings_open() ) {
							// Both Comments and Pings are open ?>
							&#124;&nbsp;&nbsp;<img src="<?php bloginfo('template_directory'); ?>/images/comment.gif" alt="<?php _e('Comment', 'jfr_theme') ?>" /><a href="#respond"><?php _e('Respond','jfr_theme') ?></a>&nbsp;&nbsp;&#124;&nbsp;&nbsp;<img src="<?php bloginfo('template_directory'); ?>/images/globe.gif" alt="<?php _e('Trackback', 'jfr_theme') ?>" /><a href="<?php trackback_url(); ?>" rel="trackback"><?php _e('Trackback','jfr_theme')?></a> 
						<?php } elseif ( !comments_open() && pings_open() ) {
							// Only Pings are Open ?>
							<?php _e('Comments are currently closed, but you can', 'jfr_theme')?> <img src="<?php bloginfo('template_directory'); ?>/images/globe.gif" alt="<?php _e('Trackback', 'jfr_theme') ?>" /><a href="<?php trackback_url(); ?> " rel="trackback"><?php _e('trackback','jfr_theme')?></a><?php _e(' from your own site.','jfr_theme')?>
						<?php } elseif ( comments_open() && !pings_open() ) {
							// Comments are open, Pings are not ?>
                            <?php _e('Pinging is disabled. But you can skip to the end and leave a ', 'jfr_theme')?><img src="<?php bloginfo('template_directory'); ?>/images/comment.gif" alt="<?php _e('Comment', 'jfr_theme') ?>" /><a href="#respond"><?php _e('response.','jfr_theme')?></a>
						<?php } elseif ( !comments_open() && !pings_open() ) {
							// Neither Comments, nor Pings are open ?>
                            <?php _e('Comments and pings are currently closed.', 'jfr_theme')?>
						<?php }?><?php edit_post_link(__('| <img src="'.get_bloginfo('template_directory').'/images/copy.gif" alt="Edit" /> Edit', 'jfr_theme'),'','.'); ?>
					</small>
				</p>
                <div class="tags">
               		<?php the_tags(__('Tags: ', 'jfr_theme'), '  ', '<br />'); ?>
                </div><!--.tags-->
			</div><!--.entry-->
<?php comments_template(); ?>
				<div class="post_bottom"></div>
            <div class="corner_bl"></div>
            <div class="corner_br"></div>
		</div><!--.post-->
	<?php endwhile; else: ?>
		<p><?php _e('Sorry, no attachments matched your criteria.', 'jfr_theme')?></p>
<?php endif; ?>
</div><!--#content-->
</div><!--#content_container-->

<?php get_footer(); ?>
