<?php

// Path constants
define('THEMELIB', TEMPLATEPATH . '/library');

// Create Theme Options Page
require_once (THEMELIB . '/functions/theme-options.php');

// Filter the Excerpts
include(THEMELIB . '/functions/filter-excerpts.php');

// Get Post Thumbnails and Images
include(THEMELIB . '/functions/post-images.php');

// Load widgets
include(THEMELIB . '/functions/widgets.php');

// Produces an avatar image with the hCard-compliant photo class for author info
include(THEMELIB . '/functions/author-info-avatar.php');

// Remove the WordPress Generator – via http://blog.ftwr.co.uk/archives/2007/10/06/improving-the-wordpress-generator/
function modularity_remove_generators() { return ''; }  
add_filter('the_generator','modularity_remove_generators');

// Add post thumbnail theme support
add_theme_support( 'post-thumbnails' );
set_post_thumbnail_size( 150, 150, true );

// Load Custom Styles
if ( get_option('T_css') == 'Enabled' ) {
function custom_styles() { ?><link href="<?php bloginfo('template_directory'); ?>/library/functions/styles.php" rel="stylesheet" type="text/css" /><?php } 
add_action('wp_head', 'custom_styles'); }

// Load Base Javascripts

if (!is_admin()) add_action( 'init', 'load_base_js' );
function load_base_js( ) {
	
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquerynav', get_bloginfo('template_directory').'/js/nav.js', array('jquery'));
	wp_enqueue_script('cycle', get_bloginfo('template_directory').'/js/jquery.cycle.js', array('jquery'));
	wp_enqueue_script('search', get_bloginfo('template_directory').'/js/search.js', array( 'jquery' ) );

}

// Load Dom Ready Javascripts

function load_dom_ready_js() { ?>

	<script type="text/javascript">
		jQuery(document).ready(function(){
			jQuery(navigationArrow("<?php bloginfo('template_directory'); ?>/images/arrow.png"));
			jQuery(function() {
			    jQuery("#slideshow").cycle({
			        speed: '2500',
			        timeout: '500',
					pause: 1
			    });
			});
		});
	</script>
  	
<?php }
add_action('wp_head', 'load_dom_ready_js');
?>