<?php
/**
 * Lists out all the options in "Suffusion Theme Options".
 * This file is included in functions.php
 *
 * @package Suffusion
 * @subpackage Admin
 */

$font_faces = array (
	"Arial, Helvetica, sans-serif" => "<font face=\"Arial, Helvetica, sans-serif\">Arial, <span class='mac'>Arial, Helvetica,</span> <i>sans-serif</i></font>",
	"'Arial Black', Gadget, sans-serif" => "<font face=\"'Arial Black', Gadget, sans-serif\">Arial Black, <span class='mac'>Arial Black, Gadget,</span> <i>sans-serif</i></font>",
	"'Comic Sans MS', cursive" => "<font face=\"'Comic Sans MS', cursive\">Comic Sans MS, <span class='mac'>Comic Sans MS,</span> <i>cursive</i></font>",
	"'Courier New', Courier, monospace " => "<font face=\"'Courier New', Courier, monospace\">Courier New, <span class='mac'>Courier New, Courier,</span> <i>monospace</i></font>",
	"Georgia, serif" => "<font face=\"Georgia, serif\">Georgia, <span class='mac'>Georgia,</span> <i>serif</i></font>",
	"Impact, Charcoal, sans-serif" => "<font face=\"Impact, Charcoal, sans-serif\">Impact, <span class='mac'>Impact, Charcoal,</span> <i>sans-serif</i></font>",
	"'Lucida Console', Monaco, monospace" => "<font face=\"'Lucida Console', Monaco, monospace\">Lucida Console, <span class='mac'>Monaco,</span> <i>monospace</i></font>",
	"'Lucida Sans Unicode', 'Lucida Grande', sans-serif" => "<font face=\"'Lucida Sans Unicode', 'Lucida Grande', sans-serif\">Lucida Sans Unicode, <span class='mac'>Lucida Grande,</span> <i>sans-serif</i></font>",
	"'Palatino Linotype', 'Book Antiqua', Palatino, serif" => "<font face=\"'Palatino Linotype', 'Book Antiqua', Palatino, serif\">Palatino Linotype, Book Antiqua, <span class='mac'>Palatino,</span> <i>serif</i></font>",
	"Tahoma, Geneva, sans-serif" => "<font face=\"Tahoma, Geneva, sans-serif\">Tahoma, <span class='mac'>Geneva,</span> <i>sans-serif</i></font>",
	"'Times New Roman', Times, serif" => "<font face=\"'Times New Roman', Times, serif\">Times New Roman, <span class='mac'>Times,</span> <i>serif</i></font>",
	"'Trebuchet MS', Helvetica, sans-serif" => "<font face=\"'Trebuchet MS', Helvetica, sans-serif\">Trebuchet MS, <span class='mac'>Helvetica,</span> <i>sans-serif</i></font>",
	"Verdana, Geneva, sans-serif" => "<font face=\"Verdana, Geneva, sans-serif\">Verdana, <span class='mac'>Verdana, Geneva,</span> <i>sans-serif</i></font>",
	"Symbol" => "<font face=\"Symbol\">Symbol, <span class='mac'>Symbol</span></font> (\"Symbol\" works in IE and Chrome on Windows and in Safari on Mac)",
	"Webdings" => "<font face=\"Webdings\">Webdings, <span class='mac'>Webdings</span></font> (\"Webdings\" works in IE and Chrome on Windows and in Safari on Mac)",
	"Wingdings, 'Zapf Dingbats'" => "<font face=\"Wingdings, 'Zapf Dingbats'\">Wingdings, <span class='mac'>Zapf Dingbats</span></font> (\"Wingdings\" works in IE and Chrome on Windows and in Safari on Mac)",
	"'MS Sans Serif', Geneva, sans-serif" => "<font face=\"'MS Sans Serif', Geneva, sans-serif\">MS Sans Serif, <span class='mac'>Geneva,</span> <i>sans-serif</i></font>",
	"'MS Serif', 'New York', serif" => "<font face=\"'MS Serif', 'New York', serif\">MS Serif, <span class='mac'>New York,</span> <i>serif</i></font>",
);

global $category_array, $sidebar_tabs, $social_networks, $suffusion_404_title, $suffusion_404_content;
$all_page_ids = get_all_page_ids();
$all_page_ids = implode(',',$all_page_ids);
$all_category_ids = get_all_category_ids();
$all_category_ids = implode(',',$all_category_ids);

$options = array (
	// Main Header - this has no options directly associated with it
	array("name" => "Configuration Options",
			"type" => "title",
			"category" => "root"
	),

	array("name" => "Introduction",
			"type" => "sub-section-2",
			"category" => "intro-pages",
			"parent" => "root"
	),

	array("name" => "Welcome",
			"type" => "sub-section-3",
			"category" => "welcome",
			"buttons" => 'no-buttons',
			"parent" => "intro-pages"
	),

	array("name" => "Don't Panic!!",
				"desc" => "Welcome to Suffusion! But first...<br/>
					<div class='centered'><img src='". get_stylesheet_directory_uri(). "/admin/images/dont-panic.jpg' alt=\"Don't Panic!\" title=\"Don't Panic!\" /><br/>
					<i>(This picture is from Buena Vista Pictures Distributions' promo of, obviously, \"Hitchhiker's Guide to the Galaxy\".)</i></div>
					<p>At first the number of options in Suffusion might alarm you, but don't panic, everything is organized well enough for you to find your way.
					You begin with the basic aspects of look-and-feel, then make your way into the more complex and innovative aspects of the theme.</p>",
			"parent" => "welcome",
			"type" => "blurb"),

	array("name" => "Are you upgrading?",
				"desc" => "If you are upgrading from an older version of the theme (3.4.3 or lower) you should first look into the \"Upgrades\" section and perform a migration.
					Otherwise your site might not work as you expect it to. But if this is your first installation of the theme, jump right into the customizations.",
			"parent" => "welcome",
			"type" => "blurb"),

	array("name" => "Upgrades",
			"type" => "sub-section-3",
			"category" => "upgrade-patches",
			"buttons" => 'special-buttons',
			"parent" => "intro-pages"
	),

	array("name" => "Migrate settings from version 3.0.2 or lower",
			"desc" => "Heavy code optimization was done on the theme in version 3.0.5.
				This caused a change in the way some of the settings operate and your theme might not work as you expect. E.g. the navigation bars might not be displayed etc.
				Click on the button below if you upgraded from Version 3.0.2 or lower. DON'T CLICK the button if:
				<ul class='margin-100'>
					<li>You are trying out the theme for the first time</li>
					<li>Or you are upgrading from version 3.0.5 or higher</li>
				</ul>",
			"id" => $shortname."_up_migrate_302",
			"parent" => "upgrade-patches",
			"type" => "button",
			"action" => "",
			"std" => "Migrate"),

	array("name" => "Migrate settings from version 3.4.3 or lower",
		"desc" => "In version 3.4.3 and older Suffusion used to store each option separately in the database.
			While this is not much of an issue with PHP and MySQL, both of which are superfast,
			it is still a better practice to move it all to one single option array and then store that single array as an option.
			IF YOU ARE MIGRATING FROM A VERSION LOWER THAN 3.0.5, MAKE SURE YOU RUN THE PREVIOUS STEP FIRST!
			Click on the button below if you upgraded from Version 3.4.3 or lower. DON'T CLICK the button if:
			<ul class='margin-100'>
				<li>You are trying out the theme for the first time</li>
				<li>Or you are upgrading from version 3.4.5 or higher</li>
			</ul>",
		"id" => $shortname."_up_migrate_343",
		"parent" => "upgrade-patches",
		"type" => "button",
			"action" => "",
			"std" => "Migrate"),

	array("name" => "Export / Import",
			"type" => "sub-section-3",
			"category" => "export-import",
			"buttons" => 'special-buttons',
			"parent" => "intro-pages"
	),

	array("name" => "Export options for use in other installations",
			"desc" => "You can export the options you have set in the theme. The options will be stored in a PHP file that you can save to your local disk.",
			"id" => $shortname."_export_options",
			"parent" => "export-import",
			"type" => "button",
			"action" => "",
			"std" => "Export to a file"),

	array("name" => "Import options from another installation",
			"desc" => "You can import options that you have exported from another installation. This is a two-step process:
			 	<ol class='margin-100'>
					<li>Copy the file 'suffusion-options.php' into the import folder in your Suffusion theme's admin directory on this installation</li>
					<li>Click on the Import button below. <b>This process is not reversible. So use it with care!!</b></li>
				</ol>",
			"id" => $shortname."_import_options",
			"parent" => "export-import",
			"type" => "button",
			"action" => "",
			"std" => "Import options"),

	array("name" => "FAQs",
			"type" => "sub-section-3",
			"category" => "help-faqs",
			"buttons" => 'no-buttons',
			"parent" => "intro-pages"
	),

	array("name" => "Answers to some frequently asked questions",
			"type" => "blurb",
			"parent" => "help-faqs",
			"desc" => "<ol class='faq-list'>
			<li><b>Where do I start with customizations?</b><br/>
			Open the section for \"Theme Selection\". If you see a color combination that you like, select it and you are set.</li>
			<li><b>What if I don't like any of the default color combinations?</b><br/>
			You can perform customizations within certain limits:
			<ul class='margin-100'>
			<li>To modify things like the overall background color and the background image, look at \"Theme Skinning\".</li>
			<li>For font colors used, colors of hyperlinks etc. look at \"Body Font Settings\".</li>
			<li>To customize the colors used for the blog title and blog description see \"Header Customization\".</li>
			<li>For the sidebar widgets you can select styled or unstyled headers in the \"Widget Styles\" section.</li>
			</ul>
			<li><b>Can I use my own background image for the page?</b><br/>
			Absolutely! You can use any image that you like, tile/repeat it, align it, make it fixed etc. See the \"Theme Skinning\" section.</li>
			<li><b>Can I use a custom header image?</b><br/>
			Yes. See the \"Header Customization\" section.</li>
			<li><b>Can I switch the sidebar to the left?</b><br/>
			Of course. See the \"Sidebar Setup\" section.</li>
			<li><b>Can I define more sidebars?</b><br/>
			Yes. See the \"Sidebar Setup\" section. You can define 2 sidebars and have them positioned either on the same side or on opposite sides of the content.</li>
			<li><b>The theme's screenshots show navigation menus at the top. Why don't I see any navigation menu?</b><br/>
			There are two possible reasons. First, in the \"Navigation Bar Setup\" section, you may have chosen \"Hidden\" for displaying the navigation bar.
			Second, by default no pages are selected for display. So even if you have not chosen to hide the navigation bar, you will have to manually select the pages to display.</li>
			<li><b>Can I define what should show up on the drop-down menus at the top?</b><br/>
			Yes. See the \"Navigation Bar Setup\" section. Only pages that you include there will be shown. New pages that you create will have to be manually added.</li>
			<li><b>What other features are enabled?</b><br/>
			You can hook up your Google Analytics account to your blog. If you have your blog set up with OpenID, the requisite tags will be added to the header</li>
			<li><b>Are there any plans to enhance any features?</b><br/>
			Yes. Features that are in consideration are - more default themes and better control over the colors in a post.
			I have de-scoped some features, like advertising support and support for custom feeds. This is because of the availability of plugins to do these tasks.</li>
			<li><b>Where can I report bugs or request for features?</b><br/>
			You can visit the <a href='http://www.aquoid.com/news/themes/suffusion/'>theme's page</a> and leave a comment, or you could drop a comment on
			   <a href='http://mynethome.net/blog/contact'>the author's contact page</a>.</li>
			</ol>"
		),

	// Main category for Look and Feel settings
	array("name" => "Visual Effects",
			"type" => "sub-section-2",
			"category" => "visual-effects",
			"parent" => "root"
		),

	array("name" => "Theme selection",
			"type" => "sub-section-3",
			"category" => "theme-selection",
			"parent" => "visual-effects"
		),

	array("name" => "Color Scheme",
			"desc" => "Choose from one of the pre-defined color schemes. You can customize the colors further, if you wish.",
			"id" => $color_scheme,
			"parent" => "theme-selection",
			"type" => "radio",
			"options" => array(
							"light-theme-green" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Light-theme-green.jpg' alt='Green on a light theme'/><p>Green on a light theme</p></div>",
							"dark-theme-green" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Dark-theme-green.jpg' alt='Green on a dark theme'/><p>Green on a dark theme (Default)</p></div>",
							"light-theme-pale-blue" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Light-theme-pale-blue.jpg' alt='Pale Blue on a light theme'/><p>Pale Blue on a light theme</p></div>",
							"dark-theme-pale-blue" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Dark-theme-pale-blue.jpg' alt='Pale Blue on a dark theme'/><p>Pale Blue on a dark theme</p></div>",
							"light-theme-royal-blue" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Light-theme-royal-blue.jpg' alt='Royal Blue on a light theme'/><p>Royal Blue on a light theme</p></div>",
							"dark-theme-royal-blue" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Dark-theme-royal-blue.jpg' alt='Royal Blue on a dark theme'/><p>Royal Blue on a dark theme</p></div>",
							"light-theme-gray-1" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Light-theme-gray-1.jpg' alt='Gray Shade 1 on a light theme'/><p>Gray Shade 1 on a light theme</p></div>",
							"dark-theme-gray-1" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Dark-theme-gray-1.jpg' alt='Gray Shade 1 on a dark theme'/><p>Gray Shade 1 on a dark theme</p></div>",
							"light-theme-gray-2" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Light-theme-gray-2.jpg' alt='Gray Shade 2 on a light theme'/><p>Gray Shade 2 on a light theme</p></div>",
							"dark-theme-gray-2" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Dark-theme-gray-2.jpg' alt='Gray Shade 2 on a dark theme'/><p>Gray Shade 2 on a dark theme</p></div>",
							"light-theme-red" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Light-theme-red.jpg' alt='Red on a light theme'/><p>Red on a light theme</p></div>",
							"dark-theme-red" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Dark-theme-red.jpg' alt='Red on a dark theme'/><p>Red on a dark theme</p></div>",
							"light-theme-orange" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Light-theme-orange.jpg' alt='Orange on a light theme'/><p>Orange on a light theme</p></div>",
							"dark-theme-orange" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Dark-theme-orange.jpg' alt='Orange on a dark theme'/><p>Orange on a dark theme</p></div>",
							"light-theme-purple" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Light-theme-purple.jpg' alt='Purple on a light theme'/><p>Purple on a light theme</p></div>",
							"dark-theme-purple" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/Dark-theme-purple.jpg' alt='Purple on a dark theme'/><p>Purple on a dark theme</p></div>",
						),
			"std" => "dark-theme-green"),

	array("name" => "Favicon setup",
			"type" => "sub-section-3",
			"category" => "favicon-setup",
			"parent" => "visual-effects"
	),

	array("name" => "Favicons",
			"desc" => "As such you don't need the support of your theme to add a Favicon for your site.
				You can drop a file called favicon.ico in your root directory for it to be effective, though that method has its limitations.
				E.g. Your file has to be in an ICO format and must be called favicon.ico.",
			"parent" => "favicon-setup",
			"type" => "blurb",),

	array("name" => "Favicon Path",
			"desc" => "Set the image to be used as your Favicon. You can use a PNG, GIF, ICO or JPG file that is 16x16, 32x32 or 64x64 px in size.
				Note that older versions of Internet Explorer do not support PNG.
				See <a href='http://perishablepress.com/press/2007/10/17/everything-you-ever-wanted-to-know-about-favicons/'>this article</a> for a very comprehensive writeup on Favicons.",
			"id" => $shortname."_favicon_path",
			"parent" => "favicon-setup",
			"type" => "text",
			"hint" => "Enter the full URL here (including http://)",
			"std" => ""),

	array("name" => "Header Customization",
			"type" => "sub-section-3",
			"category" => "header-styles",
			"parent" => "visual-effects"
	),

	array("name" => "Default styles or custom styles for header?",
			"desc" => "You can decide to go with the colors / text styles of the theme you are using for the header, or choose your own. ".
				"If you choose default colors / text styles here then the rest of your settings in this section will be ignored. ".
				"If you choose custom styles then the settings you make here will override the theme's settings.",
			"id" => $header_style_setting,
			"parent" => "header-styles",
			"type" => "radio",
			"note" => "Please set this option to \"Custom styles\" if you want to override the theme's settings for the header.",
			"options" => array("theme" => "Theme styles (default)",
							"custom" => "Custom styles"),
			"std" => "theme"),

	array("name" => "Header Layout Style",
			"desc" => "You can choose different header styles - full width or page width:",
			"id" => $shortname."_header_layout_style",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("out-hcfull" => "Header is outside the main wrapper, its background and contents are as wide as your browser window",
				"out-hcalign" => "Header is outside the main wrapper, its background and contents are aligned with the main wrapper",
				"out-cfull-halign" => "Header is outside the main wrapper, its background is as wide as your browser window, but header contents are aligned with the main wrapper",
				"in-align" => "Header is inside the main wrapper"),
			"std" => "in-align"),

	array("name" => "Header Background Image Type",
			"desc" => "You can set an image to use for the header. You can either use a predefined image (default) or a custom gradient or nothing at all.",
			"id" => $shortname."_header_image_type",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("image" => "Use a predefined image (default)",
							"gradient" => "Use a custom gradient", "rot-image" => "Use a rotating set of images from a folder",
							"none" => "No image"),
			"std" => "image"),

	array("name" => "Header Background Image",
			"desc" => "Set the image to use for the header background. If this makes the header text unreadble you can try changing the header color. ".
				"If you have chosen default styles above or a gradient then this setting will be ignored.",
			"id" => $shortname."_header_background_image",
			"parent" => "header-styles",
			"type" => "text",
			"hint" => "Enter the full URL here (including http://)",
			"std" => ""),

	array("name" => "Header Background Image Tiling",
			"desc" => "Set how the predefined header background image should be tiled. This will define how the image will repeat on the background. ".
				"If you have chosen default styles above or not selected a background image then this setting will be ignored.",
			"id" => $shortname."_header_background_repeat",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("repeat" => "Repeat both horizontally and vertically (default)",
							"repeat-x" => "Repeat horizontally only",
							"repeat-y" => "Repeat vertically only",
							"no-repeat" => "Do not repeat - show background once only"),
			"std" => "repeat"),

	array("name" => "Header Background Image Position",
			"desc" => "Set the position of the predefined header background image. ".
				"If you have chosen default styles above or not selected a background image then this setting will be ignored.",
			"id" => $shortname."_header_background_position",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("top left" => "Top left (default)",
							"top center" => "Top center",
							"top right" => "Top right",
							"center left" => "Center left",
							"center center" => "Middle of the page",
							"center right" => "Center right",
							"bottom left" => "Bottom left",
							"bottom center" => "Bottom center",
							"bottom right" => "Bottom right"),
			"std" => "top left"),

	array("name" => "Folder for Rotating Header background",
			"desc" => "Set the folder for rotating header images. If you are not using a rotating header image you can ignore this.",
			"id" => $shortname."_header_background_rot_folder",
			"parent" => "header-styles",
			"type" => "text",
			"hint" => "Enter the path to a folder under ".WP_CONTENT_DIR,
			"std" => ""),

	array("name" => "Header Background Gradient Style",
			"desc" => "Choose the style to use for the header gradient. This will be used only if the \"Header Image Type\" is set to \"Use a custom gradient\" and you have custom styles picked.",
			"id" => $shortname."_header_gradient_style",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array(
							"top-down" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/gradient-t2d.jpg' alt='Top to Bottom'/><br/><p>Top to Bottom</p></div>",
							"down-top" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/gradient-d2t.jpg' alt='Bottom to Top'/><br/><p>Bottom to Top</p></div>",
							"left-right" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/gradient-l2r.jpg' alt='Left to Right'/><br/><p>Left to Right</p></div>",
							"right-left" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/gradient-r2l.jpg' alt='Right to Left'/><br/><p>Right to Left</p></div>",
						),
			"std" => "top-down"),

	array("name" => "Header Background Gradient Start Color",
			"desc" => "Set the starting color for the gradient. The gradient goes from the Start color to the End color. ".
				"This will be used only if the \"Header Image Type\" is set to \"Use a custom gradient\" and you have custom styles picked. ",
			"id" => $shortname."_header_gradient_start_color",
			"parent" => "header-styles",
			"type" => "color-picker",
			"std" => "FFFFFF"),

	array("name" => "Header Background Gradient End Color",
			"desc" => "Set the ending color for the gradient. The gradient goes from the Start color to the End color. ".
				"This will be used only if the \"Header Image Type\" is set to \"Use a custom gradient\" and you have custom styles picked. ",
			"id" => $shortname."_header_gradient_end_color",
			"parent" => "header-styles",
			"type" => "color-picker",
			"std" => "000000"),

	array("name" => "Header Foreground Image Type",
			"desc" => "You might want to use a logo or simply have text in your header:",
			"id" => $shortname."_header_fg_image_type",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("image" => "Use a predefined image or logo",
							"text" => "Use text (default)"),
			"std" => "text"),

	array("name" => "Header Foreground Image",
			"desc" => "Set the image to use for the header. This could be a logo or a stylized header using your own fonts and graphics. ".
				"If you have chosen default styles above or a text header then this setting will be ignored.",
			"id" => $shortname."_header_fg_image",
			"parent" => "header-styles",
			"type" => "text",
			"hint" => "Enter the full URL here (including http://)",
			"std" => ""),

	array("name" => "Blog Title / Header Color",
			"desc" => "Set the color of the blog title / header. You can leave the default values in if you don't have a header image. ".
				"You may need to tweak the colors in case of you have a header background, so that the header can be seen. ".
				"If you have choose to hide your header (in the layout section) then this setting will be ignored.",
			"id" => $shortname."_blog_title_color",
			"parent" => "header-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_blog_title_color", $theme_name)),

	array("name" => "Blog Title / Header Decoration",
			"desc" => "Set the effects of the blog title / header. ".
				"If you have choose to hide your header (in the layout section) then this setting will be ignored.",
			"id" => $shortname."_blog_title_style",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Blog Title / Header Hover Color",
			"desc" => "Set the color of the blog title / header when you hover over it. You can leave the default values in if you don't have a header image. ".
				"You may need to tweak the colors in case of you have a header background, so that the header can be seen. ".
				"If you have choose to hide your header (in the layout section) then this setting will be ignored.",
			"id" => $shortname."_blog_title_hover_color",
			"parent" => "header-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_blog_title_hover_color", $theme_name)),

	array("name" => "Blog Title / Header Hover Decoration",
			"desc" => "Set the effects to show when you hover over the blog title / header. ".
				"If you have choose to hide your header (in the layout section) then this setting will be ignored.",
			"id" => $shortname."_blog_title_hover_style",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Blog Description / Sub-header Color",
			"desc" => "Set the color of the blog description / sub-header. You can leave the default values in if you don't have a header image or a header background. ".
				"You may need to tweak the colors in case of you have a header background, so that the header can be seen. ".
				"If you have choose to hide your header (in the layout section) then this setting will be ignored.",
			"id" => $shortname."_blog_description_color",
			"parent" => "header-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_blog_description_color", $theme_name)),

	array("name" => "Blog Title / Header Alignment",
			"desc" => "Which side would you like your header?",
			"id" => $shortname."_header_alignment",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("left" => "Left", "right" => "Right", "center" => "Center", "hidden" => "Hidden"),
			"std" => "left"),

	array("name" => "Description / Sub-Header Alignment",
			"desc" => "Which side would you like your sub-header?",
			"id" => $shortname."_sub_header_alignment",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("left" => "Left", "right" => "Right", "center" => "Center", "hidden" => "Hidden"),
			"std" => "right"),

	array("name" => "Description / Sub-Header Vertical Alignment, relative to header",
			"desc" => "Which line would you like your sub-header relative to the header?",
			"id" => $shortname."_sub_header_vertical_alignment",
			"parent" => "header-styles",
			"type" => "radio",
			"options" => array("above" => "Above the header text", "below" => "Below the header text", "same-line" => "Same line as the header"),
			"std" => "same-line"),

	array("name" => "Theme Skinning",
		"type" => "sub-section-3",
		"category" => "body-styles",
		"parent" => "visual-effects"
	),

	array("name" => "Body Background Settings",
		"desc" => "Control the settings for the background of the main body",
		"category" => "body-bg-settings",
		"parent" => "body-styles",
		"type" => "sub-section-4",),

	array("name" => "Default or custom backgrounds for main body?",
		"desc" => "You can decide to go with the colors / text styles of the theme you are using, or choose your own. ".
			"If you choose default colors / text styles here then the rest of your settings in this section will be ignored. ".
			"If you choose custom styles then the settings you make here will override the theme's settings.",
		"id" => $body_style_setting,
		"parent" => "body-styles",
		"grouping" => "body-bg-settings",
		"note" => "Please set this option to \"Custom styles\" if you want to override the theme's settings for the body.",
		"type" => "radio",
		"options" => array("theme" => "Theme styles (default)",
						"custom" => "Custom styles"),
		"std" => "theme"),

	array("name" => "Body Background Color",
		"desc" => "Set the color of the background on which the page is. ".
			"Note that you can have a dark theme on a white background - the colors of the main content window are unaffected by this. ".
			"If you have chosen default styles above then this setting will be ignored.",
		"id" => $shortname."_body_background_color",
		"parent" => "body-styles",
		"grouping" => "body-bg-settings",
		"type" => "color-picker",
		"std" => suf_evaluate_style($shortname."_body_background_color", $theme_name)),

	array("name" => "Body Background Image",
		"desc" => "Set the image to use for the background. ".
			"If you have chosen default styles above then this setting will be ignored.",
		"id" => $shortname."_body_background_image",
		"parent" => "body-styles",
		"grouping" => "body-bg-settings",
		"type" => "text",
		"hint" => "Enter the full URL here (including http://)",
		"std" => ""),

	array("name" => "Body Background Image Tiling",
		"desc" => "Set how the background image should be tiled. This will define how the image will repeat on the background. ".
			"If you have chosen default styles above or not selected a background image then this setting will be ignored.",
		"id" => $shortname."_body_background_repeat",
		"parent" => "body-styles",
		"grouping" => "body-bg-settings",
		"type" => "radio",
		"options" => array("repeat" => "Repeat both horizontally and vertically (default)",
						"repeat-x" => "Repeat horizontally only",
						"repeat-y" => "Repeat vertically only",
						"no-repeat" => "Do not repeat - show background once only"),
		"std" => "repeat"),

	array("name" => "Background Image Scrolling",
		"desc" => "You can define your background image to either scroll with the rest of your content or stay fixed. ".
			"If you have chosen default styles above or not selected a background image then this setting will be ignored.",
		"id" => $shortname."_body_background_attachment",
		"parent" => "body-styles",
		"grouping" => "body-bg-settings",
		"type" => "radio",
		"options" => array("scroll" => "Let the background scroll with the rest of the page (default)",
						"fixed" => "Keep the background fixed"),
		"std" => "scroll"),

	array("name" => "Background Image Position",
		"desc" => "Set the position of the background image. ".
			"If you have chosen default styles above or not selected a background image then this setting will be ignored.",
		"id" => $shortname."_body_background_position",
		"parent" => "body-styles",
		"grouping" => "body-bg-settings",
		"type" => "radio",
		"options" => array("top left" => "Top left (default)",
						"top center" => "Top center",
						"top right" => "Top right",
						"center left" => "Center left",
						"center center" => "Middle of the page",
						"center right" => "Center right",
						"bottom left" => "Bottom left",
						"bottom center" => "Bottom center",
						"bottom right" => "Bottom right"),
		"std" => "top left"),

	array("name" => "Wrapper Settings",
		"desc" => "Control the settings for the wrapper of the main content",
		"category" => "wrapper-bg-settings",
		"parent" => "body-styles",
		"type" => "sub-section-4",),

	array("name" => "Default or custom?",
		"id" => $shortname."_wrapper_settings_def_cust",
		"parent" => "body-styles",
		"type" => "radio",
		"grouping" => "wrapper-bg-settings",
		"options" => array("theme" => "Theme styles (default)",
			"custom" => "Custom styles"),
		"std" => "theme"),

	array("name" => "Main Wrapper Background",
		"desc" => "Setup the background of the main container in your page. ".
			"If you have chosen default styles above then this setting will be ignored.",
		"id" => $shortname."_wrapper_bg_settings",
		"parent" => "body-styles",
		"grouping" => "wrapper-bg-settings",
		"type" => "background",
		"options" => array(),
		"std" => array("color" => suf_evaluate_style($shortname."_wrapper_background_color", $theme_name), "image" => "", "trans" => "0",
			"position" => "top left", "repeat" => "repeat", "attachment" => "scroll", "colortype" => "custom")),
/*
	array("name" => "Main Wrapper Background Color",
		"desc" => "Set the color of the main container in your page. ".
			"If you have chosen default styles above then this setting will be ignored.",
		"id" => $shortname."_wrapper_background_color",
		"parent" => "body-styles",
		"grouping" => "wrapper-bg-settings",
		"type" => "color-picker",
		"std" => suf_evaluate_style($shortname."_wrapper_background_color", $theme_name)),
*/
	array("name" => "Show Shadows",
		"desc" => "You can choose to drop a shadow for your page. Shadows look cool on light backgrounds and not so much on dark backgrounds.",
		"id" => $show_shadows,
		"parent" => "body-styles",
		"grouping" => "wrapper-bg-settings",
		"type" => "radio",
		"options" => array("hide" => "Don't show a shadow", "show" => "Show shadow of the main window"),
		"std" => "hide"),

	array("name" => "Post Background Settings",
		"desc" => "Control the settings for the post background",
		"category" => "post-bg-settings",
		"parent" => "body-styles",
		"type" => "sub-section-4",),

	array("name" => "Default or custom?",
		"id" => $shortname."_post_bg_settings_def_cust",
		"parent" => "body-styles",
		"type" => "radio",
		"grouping" => "post-bg-settings",
		"options" => array("theme" => "Theme styles (default)",
			"custom" => "Custom styles"),
		"std" => "theme"),

	array("name" => "Post Background",
		"desc" => "Setup the background of the post. If you have chosen default styles above then this setting will be ignored.",
		"id" => $shortname."_post_bg_settings",
		"parent" => "body-styles",
		"grouping" => "post-bg-settings",
		"type" => "background",
		"options" => array(),
		"std" => array("color" => suf_evaluate_style($shortname."_post_background_color", $theme_name), "image" => "", "trans" => "0",
			"position" => "top left", "repeat" => "repeat", "attachment" => "scroll", "colortype" => "custom")),

	array("name" => "Body Font Settings",
			"type" => "sub-section-3",
			"category" => "body-font-styles",
			"parent" => "visual-effects"
		),

	array("name" => "Default or custom font styles?",
			"desc" => "You can decide to go with the colors / text styles of the theme you are using, or choose your own. ".
				"If you choose default colors / text styles here then the rest of your settings in this section will be ignored. ".
				"If you choose custom styles then the settings you make here will override the theme's settings.",
			"id" => $body_font_style_setting,
			"parent" => "body-font-styles",
			"note" => "Please set this option to \"Custom styles\" if you want to override the theme's settings for the fonts.",
			"type" => "radio",
			"options" => array("theme" => "Theme styles (default)",
							"custom" => "Custom styles"),
			"std" => "theme"),

	array("name" => "Font Face",
			"desc" => "You can choose the fonts that you want to use. If the font you pick cannot be rendered by the browser / OS, ".
				"the default sequence of fonts is attempted (Trebuchet, Trebuchet MS, Tahoma, Lucida Grande, Lucida Sans Unicode, Arial, Verdana, sans-serif). ".
				"The following is a list of \"browser-safe\" fonts, <a href='http://www.ampsoft.net/webdesign-l/WindowsMacFonts.html'>from here</a>.".
				"The fonts in <span class='mac'>blue</span> are the Mac equivalents of the Windows fonts. The <i>italicized</i> text represents the generic font family. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_body_font_family",
			"parent" => "body-font-styles",
			"note" => "Note that the fonts may not render correctly in the following, depending on your OS / browser.",
			"type" => "radio",
			"options" => $font_faces,
			"std" => "'Trebuchet MS', Helvetica, sans-serif"),

	array("name" => "Font Color",
			"desc" => "Set the color of the fonts being used. ".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_font_color",
			"parent" => "body-font-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_font_color", $theme_name)),

	array("name" => "Link Color",
			"desc" => "Set the color of the links in the main content. Font colors in the sidebar are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_link_color",
			"parent" => "body-font-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_link_color", $theme_name)),

	array("name" => "Link Decoration",
			"desc" => "Set the effects for the link text. If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_link_style",
			"parent" => "body-font-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Visited Link Color",
			"desc" => "Set the color of the visited links in the main content. Font colors in the sidebar are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_visited_link_color",
			"parent" => "body-font-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_visited_link_color", $theme_name)),

	array("name" => "Visited Link Decoration",
			"desc" => "Set the effects for the visited link text. If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_visited_link_style",
			"parent" => "body-font-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Link Hover Color",
			"desc" => "Set the color that the links should become when you hover over them in the main content. Font colors in the sidebar are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_link_hover_color",
			"parent" => "body-font-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_link_hover_color", $theme_name)),

	array("name" => "Link Hover Decoration",
			"desc" => "Set the effects for the link text on which you are hovering. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_link_hover_style",
			"parent" => "body-font-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "underline"),

	array("name" => "Sidebars and Widget Areas",
			"type" => "sub-section-3",
			"category" => "sidebar-setup",
			"parent" => "visual-effects"
	),

	array("name" => "Sidebar Layout",
	"desc" => "Suffusion comes with eight widget areas where you can add widgets. You may choose to not use some of these widget areas depending on your requirements.
				By default Sidebar 1 and Right Header Widgets are enabled.<br/?
				<center><img src='".get_bloginfo("stylesheet_directory")."/admin/images/widgets.jpg' alt='Widgets'/></center>",
			"parent" => "sidebar-setup",
			"type" => "blurb",
			),
/*
	array("name" => "Use JQuery to fix widget layout issues?",
			"desc" => "For some third-party widgets the theme's layout breaks because of a mismatch of &lt;div&gt; tags. You can address this by using JQuery to put in a fix.
				Note that the JQuery library is large ( &gt; 50KB), so this will increase the size of your page.
				On the other hand, if you are already using featured posts or tabbed sidebars, you are loading JQuery, so setting this option doesn't matter.",
			"id" => $shortname."_sidebar_jq_fix",
			"parent" => "sidebar-setup",
			"type" => "radio",
			"options" => array("use" => "Use JQuery to fix layout", "dont-use" => "Don't use JQuery (if you aren't facing widget layout issues you can keep this option selected)"),
			"std" => "dont-use"),
*/
	array("name" => "How Many Sidebars?",
			"desc" => "The theme is setup with one sidebar (a two-column theme) by default. You could choose to have two sidebars (a three-column theme) or none if you want.",
			"id" => $shortname."_sidebar_count",
			"parent" => "sidebar-setup",
			"note" => "If you have selected 0 or 1 below, 2 sidebars will still show up in the \"Widgets\" page, but only the selected number will be visible on your blog",
			"type" => "radio",
			"options" => array("0" => "0 (Zero)", "1" => "1 (One)", "2" => "2 (Two)"),
			"std" => "1"),

	array("name" => "Top Bar Right Widgets",
			"desc" => "Control the settings of the Top Bar Right Widgets",
			"category" => "sidebar-setup-tbrh",
			"parent" => "sidebar-setup",
			"type" => "sub-section-4",),

	array("name" => "Style of \"Top Bar Right Widgets\" widget area",
			"desc" => "The \"Top Bar Right Widgets\" can either be constrained to a small area or be expanded as a sliding panel:",
			"id" => $shortname."_wa_tbrh_style",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-tbrh",
			"type" => "radio",
			"options" => array("tiny" => "Show widgets in a tiny widget area",
				"sliding-panel" => "Show widgets in a sliding panel, unstyled",
				"spanel-flat" => "Show widgets in a sliding panel, flat",
				"spanel-boxed" => "Show widgets in a sliding panel, boxed"),
			"std" => "tiny"),

	array("name" => "Title styling of widgets in \"Top Bar Right Widgets\" area",
			"desc" => "If you are displaying widgets in a sliding panel, boxed, you can choose a plain style for the titles of the widgets above the footer or something that goes with the color scheme.",
			"id" => $shortname."_header_for_trbh",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-tbrh",
			"type" => "radio",
			"options" => array("plain" => "Plain title with lower border (unstyled - white for the light themes and black for the dark themes) - Default",
							"plain-borderless" => "Plain title without lower border (unstyled - white for the light themes and black for the dark themes)",
							"scheme" => "Theme-based title (green, gray, blue, red, orange or purple, depending on the selected theme)"),
			"std" => "plain"),

	array("name" => "Sliding Panel \"Open\" text",
			"desc" => "What do you want the sliding panel button to say for opening the panel?",
			"id" => $shortname."_wa_tbrh_open_text",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-tbrh",
			"type" => "text",
			//"hint" => "Use &amp;darr; for a 'Down Arrow' and &amp;uarr; for an 'Up Arrow'",
			"std" => "Open"),

	array("name" => "Sliding Panel \"Close\" text",
			"desc" => "What do you want the sliding panel button to say for opening the panel?",
			"id" => $shortname."_wa_tbrh_close_text",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-tbrh",
			"type" => "text",
			//"hint" => "Use &amp;darr; for a 'Down Arrow' and &amp;uarr; for an 'Up Arrow'",
			"std" => "Close"),

	array("name" => "Columns in \"Top Bar Right Widgets\"",
			"desc" => "How many columns of widgets do you want in this widget area? This is applicable only if this particular widget area is a sliding panel.",
			"id" => $shortname."_wa_tbrh_columns",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-tbrh",
			"type" => "select",
			"options" => array("1" => "1 (One) Column", "2" => "2 (Two) Columns", "3" => "3 (Three) Columns", "4" => "4 (Four) Columns", "5" => "5 (Five) Columns"),
			"std" => "3"),

	array("name" => "Sliding Panel Color",
			"desc" => "Set the color of the sliding panel",
			"id" => $shortname."_wa_tbrh_panel_color",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-tbrh",
			"type" => "color-picker",
			"std" => '#040D0F'),

	array("name" => "Sliding Panel Border",
			"desc" => "Set the color of the sliding panel's border",
			"id" => $shortname."_wa_tbrh_panel_border_color",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-tbrh",
			"type" => "color-picker",
			"std" => '#222222'),

	array("name" => "Sliding Panel Font Color",
			"desc" => "Set the color of the sliding panel's text",
			"id" => $shortname."_wa_tbrh_panel_font_color",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-tbrh",
			"type" => "color-picker",
			"std" => '#AAAAAA'),

	array("name" => "Right Header Widgets",
			"desc" => "Control the settings of the Right Header Widgets",
			"category" => "sidebar-setup-rhw",
			"parent" => "sidebar-setup",
			"type" => "sub-section-4",),

	array("name" => "Show Search in Widget Area on right side of header",
			"desc" => "By default the search field is shown in the navigation bar. If you prefer having the search in your sidebar instead, you can disable this.
				Note that even if you choose to hide the search field here, if you add a search widget through the widget administration to this widget area.
				This option has been left in for backward compatibility.",
			"id" => $shortname."_show_search",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-rhw",
			"type" => "radio",
			"options" => array("show" => "Show search with navigation (default)",
				"hide" => "Hide the search (You can add a widget for the Search, if you wish)"),
			"std" => "show"),

	array("name" => "Sidebar 1",
			"desc" => "Control the settings of your first sidebar",
			"category" => "sidebar-setup-sidebar-1",
			"parent" => "sidebar-setup",
			"type" => "sub-section-4",),

	array("name" => "Position of First Sidebar",
			"desc" => "Which side would you like your first sidebar? ".
				"If you have two sidebars enabled and both are positioned on the same side, this sidebar will be the outer one. ".
				"If you have only one sidebar enabled, this will control the position of that sidebar.",
			"id" => $shortname."_sidebar_alignment",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-1",
			"type" => "radio",
			"options" => array("left" => "Left", "right" => "Right"),
			"std" => "right"),

	array("name" => "Style of first sidebar",
			"desc" => "Your sidebar can have widgets displayed in individual boxes or as a flattened list of widgets. Having widgets as boxes lets you use drag and drop.",
			"id" => $shortname."_wa_sb1_style",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-1",
			"type" => "radio",
			"options" => array("boxed" => "Show widgets in individual boxes",
				"flattened" => "Flatten the sidebar (no boxes for individual widgets)"),
			"std" => "boxed"),

	array("name" => "Default widgets for first sidebar",
			"desc" => "If you have not added any widgets to the first sidebar in the widget administration section of your control panel, Suffusion shows a set of default widgets. You can disable this if you please: ",
			"id" => $shortname."_sidebar_1_def_widgets",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-1",
			"type" => "radio",
			"options" => array("show" => "Show default widgets if nothing is added in the widget control panel (default)",
				"hide" => "Hide default widgets if nothing is added in the widget control panel"),
			"std" => "show"),

	array("name" => "Drag-and-Drop for First Sidebar",
			"desc" => "By default drag-and-drop is enabled for the widgets in the first sidebar. You can turn it off, if you please.",
			"id" => $shortname."_sidebar_1_dnd",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-1",
			"type" => "radio",
			"options" => array("enabled" => "Enable drag-and-drop (default)", "disabled" => "Disable drag-and-drop (this will also disable the collapsibility of of the widgets)"),
			"std" => "enabled"),

	array("name" => "Expand / Collapse for First Sidebar Widgets",
			"desc" => "By default expand/collapse is enabled for the widgets in the first sidebar. You can turn it off, if you please. ".
					"This setting is ignored if you have disabled drag-and-drop for the first sidebar.",
			"id" => $shortname."_sidebar_1_expcoll",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-1",
			"type" => "radio",
			"options" => array("enabled" => "Enable expand / collapse (default)", "disabled" => "Disable expand / collapse"),
			"std" => "enabled"),

	array("name" => "Sidebar 2",
			"desc" => "Control the settings of your second sidebar",
			"category" => "sidebar-setup-sidebar-2",
			"parent" => "sidebar-setup",
			"type" => "sub-section-4",),

	array("name" => "Position of Second Sidebar",
			"desc" => "Which side would you like your second sidebar? ".
				"If you have two sidebars enabled and both are positioned on the same side, this sidebar will be the inner one. ".
				"If you have only one sidebar enabled, this setting will be ignored.",
			"id" => $shortname."_sidebar_2_alignment",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-2",
			"type" => "radio",
			"options" => array("left" => "Left", "right" => "Right"),
			"std" => "right"),

	array("name" => "Style of second sidebar",
			"desc" => "Your sidebar can have widgets displayed in individual boxes or as a flattened list of widgets. Having widgets as boxes lets you use drag and drop.",
			"id" => $shortname."_wa_sb2_style",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-2",
			"type" => "radio",
			"options" => array("boxed" => "Show widgets in individual boxes",
				"flattened" => "Flatten the sidebar (no boxes for individual widgets)"),
			"std" => "boxed"),

	array("name" => "Drag-and-Drop for Second Sidebar",
			"desc" => "By default drag-and-drop is enabled for the second sidebar. You can turn it off, if you please. Note that this setting is ignored if you enable only one sidebar",
			"id" => $shortname."_sidebar_2_dnd",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-2",
			"type" => "radio",
			"options" => array("enabled" => "Enable drag-and-drop (default)", "disabled" => "Disable drag-and-drop (this will also disable the collapsibility of of the widgets)"),
			"std" => "enabled"),

	array("name" => "Expand / Collapse for Second Sidebar Widgets",
			"desc" => "By default drag-and-drop is enabled for the widgets in the second sidebar. You can turn it off, if you please. ".
					"Note that this setting is ignored if you enable only one sidebar, or if you have disabled drag-and-drop for the second sidebar.",
			"id" => $shortname."_sidebar_2_expcoll",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-sidebar-2",
			"type" => "radio",
			"options" => array("enabled" => "Enable expand / collapse (default)", "disabled" => "Disable expand / collapse"),
			"std" => "enabled"),

	array("name" => "Widget Area Below Header",
			"desc" => "Control the settings of the widget area below header",
			"category" => "sidebar-setup-wabh",
			"parent" => "sidebar-setup",
			"type" => "sub-section-4",),

	array("name" => "Enable Widget Area Below Header?",
			"desc" => "This widget area spans the width of the blog page and can be positioned just below the header. Do you want it enabled?
				You can use this widget area for banner advertisements, if you wish. These widgets cannot be moved around in the manner that the sidebar widgets can.
				Note that even if you don't enable it you will see this in the widget administration menu.",
			"id" => $shortname."_widget_area_below_header_enabled",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-wabh",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "disabled"),

	array("name" => "Columns in Widget Area Below Header",
			"desc" => "How many columns of widgets do you want in this widget area? For banner ads etc you might want to leave it at one. If you are removing the sidebars then you might want to set a value like 3 or 4.",
			"id" => $shortname."_widget_area_below_header_columns",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-wabh",
			"type" => "select",
			"options" => array("1" => "1 (One) Column", "2" => "2 (Two) Columns", "3" => "3 (Three) Columns", "4" => "4 (Four) Columns", "5" => "5 (Five) Columns"),
			"std" => "1"),

	array("name" => "Style of widget area below header",
			"desc" => "Your sidebar can have widgets displayed in individual boxes or as a flattened list of widgets. Having widgets as boxes lets you use drag and drop.",
			"id" => $shortname."_wa_wabh_style",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-wabh",
			"type" => "radio",
			"options" => array("boxed" => "Show widgets in individual boxes",
				"flattened" => "Flatten the sidebar (no boxes for individual widgets)"),
			"std" => "boxed"),

	array("name" => "Widget Area Above Footer",
			"desc" => "Control the settings of the widget area above footer",
			"category" => "sidebar-setup-waaf",
			"parent" => "sidebar-setup",
			"type" => "sub-section-4",),

	array("name" => "Enable Widget Area Above Footer?",
			"desc" => "This widget area spans the width of the blog page and can be positioned just above the footer. Do you want it enabled?
				Note that even if you don't enable it you will see this in the widget administration menu.",
			"id" => $shortname."_widget_area_above_footer_enabled",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-waaf",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "disabled"),

	array("name" => "Columns in Widget Area Above Footer",
			"desc" => "How many columns of widgets do you want in this widget area? For banner ads etc you might want to leave it at one. If you are removing the sidebars then you might want to set a value like 3 or 4.",
			"id" => $shortname."_widget_area_above_footer_columns",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-waaf",
			"type" => "select",
			"options" => array("1" => "1 (One) Column", "2" => "2 (Two) Columns", "3" => "3 (Three) Columns", "4" => "4 (Four) Columns", "5" => "5 (Five) Columns"),
			"std" => "1"),

	array("name" => "Style of widget area above footer",
			"desc" => "Your sidebar can have widgets displayed in individual boxes or as a flattened list of widgets. Having widgets as boxes lets you use drag and drop.",
			"id" => $shortname."_wa_waaf_style",
			"parent" => "sidebar-setup",
			"grouping" => "sidebar-setup-waaf",
			"type" => "radio",
			"options" => array("boxed" => "Show widgets in individual boxes",
				"flattened" => "Flatten the sidebar (no boxes for individual widgets)"),
			"std" => "boxed"),

/*
	array("name" => "Rounded Corners",
			"type" => "sub-section-3",
			"category" => "rounded-corners",
			"parent" => "visual-effects"
	),

	array("name" => "Enable JQuery Corners?",
			"desc" => "Rounded corners are supported by CSS3-capable browsers. At the time of writing Firefox, Safari, Chrome and Konqueror fall under this bucket.
					Other browsers like IE and Opera don't have support for this yet. Suffusion has rounded corners built in through CSS.
					However, to display rounded corners for all browsers you will have to enable the <a href='http://www.malsup.com/jquery/corner/'>JQuery Corners plugin</a>.",
			"id" => $shortname."_corner_jq_enabled",
			"parent" => "rounded-corners",
			"type" => "radio",
			"options" => array("none" => "No rounded corners for any browser", "css" => "CSS-based rounded corners", "jquery" => "JQuery-based rounded corners"),
			"std" => "css"),

	array("name" => "Corner Effect (JQuery Corner only)",
			"desc" => "If you have selected JQuery corners above, you can set your corner style to be one from the multiple options
				that the <a href='http://www.malsup.com/jquery/corner/'>JQuery Corners plugin</a> provides.",
			"id" => $shortname."_corner_jq_style",
			"parent" => "rounded-corners",
			"type" => "radio",
			"options" => array("round" => "Round", "bevel" => "Bevel", "notch" => "Notch", 'bite' => 'Bite', 'cool' => 'Cool', 'sharp' => 'Sharp',
				'slide' => 'Slide', 'jut' => 'Jut', 'curl' => 'Curl', 'tear' => 'Tear', 'fray' => 'Fray', 'wicked' => 'Wicked',
				'sculpt' => 'Sculpt', 'long' => 'Long', 'dog' => 'Dog Ear 1', 'dog2' => 'Dog Ear 2', 'dog3' => 'Dog Ear 3', ),
			"std" => "round"),
*/
	array("name" => "Widget Styles",
			"type" => "sub-section-3",
			"category" => "widget-styles",
			"parent" => "visual-effects"
	),

	array("name" => "Sidebar Widgets Titles",
			"desc" => "You can choose a plain style for the headers of the sidebar widgets, or something that goes with the color scheme. Note that text widgets without a title will not display a header.",
			"id" => $sidebar_header,
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("plain" => "Plain sidebar header with lower border (unstyled - white for the light themes and black for the dark themes) - Default",
							"plain-borderless" => "Plain sidebar header without lower border (unstyled - white for the light themes and black for the dark themes)",
							"scheme" => "Theme-based sidebar header (green, gray, blue, red, orange or purple, depending on the selected theme)"),
			"std" => "plain"),

	array("name" => "Default or custom font styles for sidebar?",
			"desc" => "You can decide to go with the colors / text styles of the theme you are using, or choose your own. ".
				"If you choose default colors / text styles here then the subsequent settings in this section will be ignored. ".
				"If you choose custom styles then the settings you make here will override the theme's settings.",
			"id" => $shortname."_sb_font_style_setting",
			"parent" => "widget-styles",
			"note" => "Please set this option to \"Custom styles\" if you want to override the theme's settings for the sidebar fonts.",
			"type" => "radio",
			"options" => array("theme" => "Theme styles (default)",
							"custom" => "Custom styles"),
			"std" => "theme"),

	array("name" => "Sidebar Font Color",
			"desc" => "Set the color of the fonts being used. ".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_sb_font_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_sb_font_color", $theme_name)),

	array("name" => "Sidebar Link Color",
			"desc" => "Set the color of the links in the sidebar. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_sb_link_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_sb_link_color", $theme_name)),

	array("name" => "Sidebar Link Decoration",
			"desc" => "Set the effects for the link text in the sidebar. If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_sb_link_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Sidebar Visited Link Color",
			"desc" => "Set the color of the visited links in the sidebar. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_sb_visited_link_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_sb_visited_link_color", $theme_name)),

	array("name" => "Sidebar Visited Link Decoration",
			"desc" => "Set the effects for the visited link text. If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_sb_visited_link_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Sidebar Link Hover Color",
			"desc" => "Set the color that the links should become when you hover over them in the sidebar. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_sb_link_hover_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_sb_link_hover_color", $theme_name)),

	array("name" => "Sidebar Link Hover Decoration",
			"desc" => "Set the effects for the link text on which you are hovering. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_sb_link_hover_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "underline"),

	array("name" => "Title styling for widgets below header",
			"desc" => "You can choose a plain style for the titles of the widgets below the header, or something that goes with the color scheme. Note that text widgets without a title will not be affected by this.",
			"id" => $shortname."_header_for_widgets_below_header",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("plain" => "Plain title with lower border (unstyled - white for the light themes and black for the dark themes) - Default",
							"plain-borderless" => "Plain title without lower border (unstyled - white for the light themes and black for the dark themes)",
							"scheme" => "Theme-based title (green, gray, blue, red, orange or purple, depending on the selected theme)"),
			"std" => "plain"),

	array("name" => "Default or custom font styles for widget area below header?",
			"desc" => "You can decide to go with the colors / text styles of the theme you are using, or choose your own. ".
				"If you choose default colors / text styles here then the subsequent settings in this section will be ignored. ".
				"If you choose custom styles then the settings you make here will override the theme's settings.",
			"id" => $shortname."_wabh_font_style_setting",
			"parent" => "widget-styles",
			"note" => "Please set this option to \"Custom styles\" if you want to override the theme's settings for the fonts in the widget area below the header.",
			"type" => "radio",
			"options" => array("theme" => "Theme styles (default)",
							"custom" => "Custom styles"),
			"std" => "theme"),

	array("name" => "Font Color for Widget Area Below Header",
			"desc" => "Set the color of the fonts being used. ".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_wabh_font_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_wabh_font_color", $theme_name)),

	array("name" => "Link Color for Widget Area Below Header",
			"desc" => "Set the color of the links in the widgets. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_wabh_link_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_wabh_link_color", $theme_name)),

	array("name" => "Link Decoration for Widget Area Below Header",
			"desc" => "Set the effects for the link text in the widgets. If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_wabh_link_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Visited Link Color for Widget Area Below Header",
			"desc" => "Set the color of the visited links in the widgets. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_wabh_visited_link_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_wabh_visited_link_color", $theme_name)),

	array("name" => "Visited Link Decoration for Widget Area Below Header",
			"desc" => "Set the effects for the visited link text. If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_wabh_visited_link_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Link Hover Color for Widget Area Below Header",
			"desc" => "Set the color that the links should become when you hover over them in the widgets. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_wabh_link_hover_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_wabh_link_hover_color", $theme_name)),

	array("name" => "Link Hover Decoration for Widget Area Below Header",
			"desc" => "Set the effects for the link text on which you are hovering. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_wabh_link_hover_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "underline"),

	array("name" => "Title styling for widgets above footer",
			"desc" => "You can choose a plain style for the titles of the widgets above the footer, or something that goes with the color scheme. Note that text widgets without a title will not be affected by this.",
			"id" => $shortname."_header_for_widgets_above_footer",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("plain" => "Plain title with lower border (unstyled - white for the light themes and black for the dark themes) - Default",
							"plain-borderless" => "Plain title without lower border (unstyled - white for the light themes and black for the dark themes)",
							"scheme" => "Theme-based title (green, gray, blue, red, orange or purple, depending on the selected theme)"),
			"std" => "plain"),

	array("name" => "Default or custom font styles for widget area above footer?",
			"desc" => "You can decide to go with the colors / text styles of the theme you are using, or choose your own. ".
				"If you choose default colors / text styles here then the subsequent settings in this section will be ignored. ".
				"If you choose custom styles then the settings you make here will override the theme's settings.",
			"id" => $shortname."_waaf_font_style_setting",
			"parent" => "widget-styles",
			"note" => "Please set this option to \"Custom styles\" if you want to override the theme's settings for the widget area above the footer.",
			"type" => "radio",
			"options" => array("theme" => "Theme styles (default)",
							"custom" => "Custom styles"),
			"std" => "theme"),

	array("name" => "Font Color for Widget Area Above Footer",
			"desc" => "Set the color of the fonts being used. ".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_waaf_font_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_waaf_font_color", $theme_name)),

	array("name" => "Link Color for Widget Area Above Footer",
			"desc" => "Set the color of the links in the widgets. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_waaf_link_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_waaf_link_color", $theme_name)),

	array("name" => "Link Decoration for Widget Area Above Footer",
			"desc" => "Set the effects for the link text in the widgets. If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_waaf_link_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Visited Link Color for Widget Area Above Footer",
			"desc" => "Set the color of the visited links in the widgets. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_waaf_visited_link_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_waaf_visited_link_color", $theme_name)),

	array("name" => "Visited Link Decoration for Widget Area Above Footer",
			"desc" => "Set the effects for the visited link text. If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_waaf_visited_link_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "none"),

	array("name" => "Link Hover Color for Widget Area Above Footer",
			"desc" => "Set the color that the links should become when you hover over them in the widgets. Font colors in the main content are unaffected".
				"Make sure that your font color goes well enough with the theme. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_waaf_link_hover_color",
			"parent" => "widget-styles",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_waaf_link_hover_color", $theme_name)),

	array("name" => "Link Hover Decoration for Widget Area Above Footer",
			"desc" => "Set the effects for the link text on which you are hovering. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_waaf_link_hover_style",
			"parent" => "widget-styles",
			"type" => "radio",
			"options" => array("underline" => "Underlined", "none" => "None"),
			"std" => "underline"),

	array("name" => "Footer Customziation",
			"type" => "sub-section-3",
			"category" => "footer-customization",
			"parent" => "visual-effects"
	),

	array("name" => "Text in left part of footer",
			"desc" => "Enter the text to put in the left section of the footer. HTML is permitted. For the &copy; symbol use &amp;#169; .",
			"id" => $shortname."_footer_left",
			"parent" => "footer-customization",
			"type" => "textarea",
			"hint" => "Enter the text here.",
			"note" => "If you have any text here, it will be included with your pages (even if structurally incorrect!!).",
			"std" => "&amp;#169; ".date('Y')." <a href='".get_bloginfo('url')."'>".get_bloginfo('name')."</a>"),

	array("name" => "Text in central part of footer",
			"desc" => "Enter the text to put in the central section of the footer. HTML is permitted. For the &copy; symbol use &amp;#169; .",
			"id" => $shortname."_footer_center",
			"parent" => "footer-customization",
			"type" => "textarea",
			"hint" => "Enter the text here.",
			"note" => "If you have any text here, it will be included with your pages (even if structurally incorrect!!).",
			"std" => ""),

	array("name" => "Sizes and Margins",
			"type" => "sub-section-3",
			"category" => "size-options",
			"parent" => "visual-effects"
	),

	array("name" => "Default sizes / margins for page elements?",
			"desc" => "You can decide to go with the sizes and margins (gaps) defined with the theme for different page elements or pick your own. ".
				"If you choose custom styles then the settings you make here will override the theme's settings.",
			"id" => $shortname."_size_options",
			"parent" => "size-options",
			"type" => "radio",
			"note" => "Please set this option to \"Custom styles\" if you want to override the theme's settings for the header.",
			"options" => array("theme" => "Theme sizes and margins",
							"custom" => "Custom sizes and margins (Default)"),
			"std" => "custom"),

	array("name" => "Overall Page Width",
			"desc" => "Suffusion comes with 3 preset page width options: 800px, 1000px and 1200px. You can also define a custom width if you please, or allow the width of the page to be determined by the width of its main components like the sidebars and the main content column.
				Due to difficulties with fitting things on the page, the minimum size allowed is 600px. If you enter something less than 600, it is considered to be 600.",
			"id" => $shortname."_wrapper_width_preset",
			"parent" => "size-options",
			"type" => "radio",
			"options" => array("800" => "800px", "1000" => "1000px (Default)", "1200" => "1200px",
							"custom" => "Custom width (defined below)", "custom-components" => "Custom width, but constructed from individual components (defined below)"),
			"std" => "1000"),

	array("name" => "Custom value for page width",
			"desc" => "If you have selected \"Custom width\" above, you can set the width here. Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 600 will be treated as 600. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width.
				Also note that if you are setting a width over here with the \"Custom width\" selection in place, the widths of the individual components like the main column, the sidebars etc. are auto-calculated",
			"id" => $shortname."_wrapper_width",
			"parent" => "size-options",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 1000",
			"std" => "1000"),

	array("name" => "Custom component width - Custom value for main column width",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the main column.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 380 will be treated as 380. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width. ",
			"id" => $shortname."_main_col_width",
			"parent" => "size-options",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 725",
			"std" => "725"),

	array("name" => "Custom component width - Custom value for width of first sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the first sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_sb_1_width",
			"parent" => "size-options",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Custom component width - Custom value for width of second sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the second sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_sb_2_width",
			"parent" => "size-options",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Empty Space Between Top of Page and Header",
			"desc" => "There is a gap of 20px between the top of the page and the header. You can change it here. ".
				"If you have chosen default styles above then this setting will be ignored.",
			"id" => $shortname."_wrapper_margin",
			"parent" => "size-options",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "20"),

	array("name" => "Height of the Header image",
			"desc" => "The header is 55px high by default. You can change this setting if you have a header image needs to fit.
				Note that both above and below the header is 15px of padding, making the effective height of the header 85px.",
			"id" => $shortname."_header_height",
			"parent" => "size-options",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "55"),

	array("name" => "Custom Emphasis Elements",
			"type" => "sub-section-3",
			"category" => "emphasis-setup",
			"parent" => "visual-effects"
	),

	array("name" => "Custom elements to enhance page appearance",
			"desc" => "Suffusion comes with predefined elements that you can use for emphasizing sections of your blog. There are four types defined
				<ul class='margin-20'>
					<li>Download - class='download'</li>
					<li>Announcement - class='announcement'</li>
					<li>Note - class='note'</li>
					<li>Warning - class='warning'</li>
				</ul>
				To use any of these elements you can enclose text on your blog within &lt;p&gt; and &lt;/p&gt; tags or &lt;div&gt; and &lt;/div&gt; tags with the class name:

				<ul class='margin-20'>
					<li>&lt;p class='download'&gt; Some stuff to download &lt;/p&gt; or &lt;div class='download'&gt;Some other stuff to download&lt;/div&gt;</li>
					<li>&lt;p class='announcement'&gt; Some announcements &lt;/p&gt; or &lt;div class='announcement'&gt;Some more announcements&lt;/div&gt;</li>
					<li>&lt;p class='note'&gt; Notes &lt;/p&gt; or &lt;div class='announcement'&gt;More notes&lt;/div&gt;</li>
					<li>&lt;p class='warning'&gt; Warnings &lt;/p&gt; or &lt;div class='warning'&gt;Other warnings&lt;/div&gt;</li>
				</ul>",
			"parent" => "emphasis-setup",
			"type" => "blurb",
			),

	array("name" => "Default styles for emphasis elements?",
			"desc" => "You can decide to go with the emphasis styles defined with the theme or pick your own. ".
				"If you choose custom styles then the settings you make here will override the theme's settings.",
			"id" => $shortname."_emphasis_customization",
			"parent" => "emphasis-setup",
			"type" => "radio",
			"note" => "Please set this option to \"Custom styles\" if you want to override the theme's settings for the emphasis eelements.",
			"options" => array("theme" => "Theme styles",
							"custom" => "Custom styles"),
			"std" => "theme"),

	array("name" => "Download",
			"desc" => "Change setting for the download class",
			"category" => "emphasis-download",
			"parent" => "emphasis-setup",
			"type" => "sub-section-4",),

	array("name" => "Download Block Font Color",
			"desc" => "Set the font color for text within a \"download\" block. ",
			"id" => $shortname."_download_font_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-download",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_download_font_color", $theme_name)),

	array("name" => "Download Block Background Color",
			"desc" => "Set the background color for a \"download\" block. ",
			"id" => $shortname."_download_background_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-download",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_download_background_color", $theme_name)),

	array("name" => "Download Block Border Color",
			"desc" => "Set the border color for a \"download\" block. ",
			"id" => $shortname."_download_border_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-download",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_download_border_color", $theme_name)),

	array("name" => "Announcement",
			"desc" => "Change setting for the announcement class",
			"category" => "emphasis-announcement",
			"parent" => "emphasis-setup",
			"type" => "sub-section-4",),

	array("name" => "Announcement Block Font Color",
			"desc" => "Set the font color for text within a \"announcement\" block. ",
			"id" => $shortname."_announcement_font_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-announcement",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_announcement_font_color", $theme_name)),

	array("name" => "Announcement Block Background Color",
			"desc" => "Set the background color for a \"announcement\" block. ",
			"id" => $shortname."_announcement_background_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-announcement",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_announcement_background_color", $theme_name)),

	array("name" => "Announcement Block Border Color",
			"desc" => "Set the border color for a \"announcement\" block. ",
			"id" => $shortname."_announcement_border_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-announcement",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_announcement_border_color", $theme_name)),

	array("name" => "Note",
			"desc" => "Change setting for the note class",
			"category" => "emphasis-note",
			"parent" => "emphasis-setup",
			"type" => "sub-section-4",),

	array("name" => "Note Block Font Color",
			"desc" => "Set the font color for text within a \"note\" block. ",
			"id" => $shortname."_note_font_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-note",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_note_font_color", $theme_name)),

	array("name" => "Note Block Background Color",
			"desc" => "Set the background color for a \"note\" block. ",
			"id" => $shortname."_note_background_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-note",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_note_background_color", $theme_name)),

	array("name" => "Note Block Border Color",
			"desc" => "Set the border color for a \"note\" block. ",
			"id" => $shortname."_note_border_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-note",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_note_border_color", $theme_name)),

	array("name" => "Warning",
			"desc" => "Change setting for the warning class",
			"category" => "emphasis-warning",
			"parent" => "emphasis-setup",
			"type" => "sub-section-4",),

	array("name" => "Warning Block Font Color",
			"desc" => "Set the font color for text within a \"warning\" block. ",
			"id" => $shortname."_warning_font_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-warning",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_warning_font_color", $theme_name)),

	array("name" => "Warning Block Background Color",
			"desc" => "Set the background color for a \"warning\" block. ",
			"id" => $shortname."_warning_background_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-warning",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_warning_background_color", $theme_name)),

	array("name" => "Warning Block Border Color",
			"desc" => "Set the border color for a \"warning\" block. ",
			"id" => $shortname."_warning_border_color",
			"parent" => "emphasis-setup",
			"grouping" => "emphasis-warning",
			"type" => "color-picker",
			"std" => suf_evaluate_style($shortname."_warning_border_color", $theme_name)),

	array("name" => "Blog Features",
			"type" => "sub-section-2",
			"category" => "blog-features",
			"parent" => "root"
	),

	array("name" => "Main Navigation Bar Setup",
			"type" => "sub-section-3",
			"category" => "nav-setup",
			"parent" => "blog-features"
	),

	array("name" => "Main Navigation Bar Look and Feel",
			"desc" => "Adjust the general look and feel options of the Main Navigation Bar",
			"category" => "nav-lf",
			"parent" => "nav-setup",
			"type" => "sub-section-4",),

	array("name" => "Show / Hide Main Navigation Bar",
			"desc" => "You can choose to show/hide your main navigation bar. If you prefer having pages, categories and links listed in the sidebar, select \"Hidden\".",
			"id" => $shortname."_nav_contents",
			"parent" => "nav-setup",
			"grouping" => "nav-lf",
			"type" => "radio",
			"options" => array("pages" => "Drop-down menus (Default)", "hide" => "Hidden"),
			"std" => "pages"),

	array("name" => "Main Navigation Bar Style",
			"desc" => "You can choose different navigation bar styles - full width or page width.
				This will only be effective if your Header is outside the main wrapper (see Visual Effects -&gt; Header Customization):",
			"id" => $shortname."_nav_bar_style",
			"parent" => "nav-setup",
			"grouping" => "nav-lf",
			"type" => "radio",
			"options" => array("full-full" => "Navigation bar is as wide as your browser window and contents of the bar begin from the left or right",
				"full-align" => "Navigation bar is as wide as your browser window and contents of the bar are aligned with your main page",
				"align" => "Navigation bar and its contents are aligned with your main page"),
			"std" => "align"),

	array("name" => "Drop-down menu delay",
			"desc" => "You can set a delay for the drop-down menu in the navigation bar.",
			"id" => $shortname."_nav_delay",
			"parent" => "nav-setup",
			"grouping" => "nav-lf",
			"type" => "text",
			"hint" => "Leave blank for no delay",
			"std" => "500"),

	array("name" => "Fade effect for drop-down menu",
			"desc" => "There is a fade-in effect for the drop-down menu enabled by default. You can disable it",
			"id" => $shortname."_nav_effect",
			"parent" => "nav-setup",
			"grouping" => "nav-lf",
			"type" => "radio",
			"options" => array("none" => "No effects", "fade" => "Fade in the page"),
			"std" => "fade"),

	array("name" => "Show \"Home\" page?",
			"desc" => "You can show a link to your blog's home page. This could either be an icon or a text link. This setting is ignored if you are hiding your navigation bar.",
			"id" => $shortname."_show_home",
			"parent" => "nav-setup",
			"grouping" => "nav-lf",
			"type" => "radio",
			"options" => array("none" => "Don't show a home link (default)", "text" => "Show a text link", "icon" => "Show an icon"),
			"std" => "none"),

	array("name" => "\"Home\" page text",
			"desc" => "If you have opted to show a text link above, you can set the text to show. The default is \"Home\".
				This setting is ignored if you are hiding your navigation bar or if you have chosen to not show a home link or to show a home icon.",
			"id" => $shortname."_home_text",
			"parent" => "nav-setup",
			"grouping" => "nav-lf",
			"type" => "text",
			"std" => "Home"),

	array("name" => "Order of entities in navigation bar",
			"desc" => "You can define the order in which Pages, Categories and Links (Bookmarks) appear in the navigation bar: ",
			"id" => $shortname."_nav_entity_order",
			"parent" => "nav-setup",
			"grouping" => "nav-lf",
			"type" => "sortable-list",
			"std" => suffusion_entity_prepositions('nav')),

	array("name" => "Text Transformation for Navigation Bar",
			"desc" => "By default all your page names are displayed with the first letter of each word capitalized in the navigation bar (except in IE 6, where it is unstyled). You can change this setting:",
			"id" => $shortname."_nav_text_transform",
			"parent" => "nav-setup",
			"grouping" => "nav-lf",
			"type" => "radio",
			"options" => array("uppercase" => "ALL UPPERCASE", "lowercase" => "all lowercase",
				"capitalize" => "Capitalize First Letter Of Each Word (default)", "none" => "No transformation"),
			"std" => "capitalize"),

	array("name" => "Pages in Navigation Bar",
			"desc" => "Control the display of pages in the navigation bar",
			"category" => "nav-pages",
			"parent" => "nav-setup",
			"type" => "sub-section-4",),

	array("name" => "Page listing style in Navigation Bar",
			"desc" => "You can choose how to show pages in your navigation bar. By default a single tab for pages is shown in the navigation bar.",
			"id" => $shortname."_nav_pages_style",
			"parent" => "nav-setup",
			"grouping" => "nav-pages",
			"type" => "radio",
			"options" => array("flattened" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-page-flat.jpg' alt='Flattened'/><p>Show the top level pages in the navigation bar and their sub-pages in drop-downs</p></div>",
				"rolled-up" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-page-roll-up.jpg' alt='Flattened'/><p>Show a single tab called \"Pages\" (or whatever you want to call it) and build a drop-down under it (default)</p></div>"),
			"std" => "rolled-up"),

	array("name" => "\"Pages\" tab title",
			"desc" => "In the above option if you have chosen to show a single tab for pages and build a drop-down under it, you can set the title for that tab.
				This setting is ignored if you have chosen to display top level pages in the navigation bar.",
			"id" => $shortname."_nav_page_tab_title",
			"parent" => "nav-setup",
			"grouping" => "nav-pages",
			"type" => "text",
			"std" => "Pages"),

	array("name" => "\"Pages\" tab link",
			"desc" => "If you have a specific page that you want to go to upon clicking the Pages tab, set the full URL here.
				This setting is ignored if you have chosen to display top level pages in the navigation bar.",
			"id" => $shortname."_nav_page_tab_link",
			"parent" => "nav-setup",
			"grouping" => "nav-pages",
			"type" => "text",
			"hint" => "Enter the full URL, including http://",
			"std" => ""),

	array("name" => "Pages in Navigation Bar - All or Selected",
		"desc" => "You can decide if you want to show all pages or selected pages in the navigation bar.
			If you choose 'All' your settings in the next option will be ignored.
			Note that this option is different from choosing 'Select All' in the next option, because this guarantees that always all are displayed, while the next option only ensures that all selections at the time of setup are displayed",
		"id" => $shortname."_nav_pages_all_sel",
		"parent" => "nav-setup",
		"grouping" => "nav-pages",
		"type" => "radio",
		"options" => array("all" => "All, ignoring next option", "selected" => "Selections from the next option"),
		"std" => "selected"),

	array("name" => "Select pages to show in Navigation Bar",
			"desc" => "If you have too many pages on your blog you might want to exclude some so that the navigation bar doesn't get ugly. Note that if your navigation bar is hidden, this setting is ignored. Also if you select a page whose parent is not selected, the child will NOT be displayed. All pages are excluded by default",
			"id" => $shortname."_nav_pages",
			"parent" => "nav-setup",
			"grouping" => "nav-pages",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_page_array($shortname."_nav_pages"),
			"std" => $all_page_ids),

	array("name" => "Categories in Navigation Bar",
			"desc" => "Control the display of categories in the navigation bar",
			"category" => "nav-cats",
			"parent" => "nav-setup",
			"type" => "sub-section-4",),

	array("name" => "Category listing style in Navigation Bar",
			"desc" => "You can choose how to show categories in your navigation bar. By default a single tab for categories is shown in the navigation bar.",
			"id" => $shortname."_nav_cat_style",
			"parent" => "nav-setup",
			"grouping" => "nav-cats",
			"type" => "radio",
			"options" => array("flattened" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-cat-flat.jpg' alt='Flattened'/><p>Show the top level categories in the navigation bar and their sub-pages in drop-downs</p></div>",
				"rolled-up" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-cat-roll-up.jpg' alt='Flattened'/><p>Show a single tab called \"Categories\" (or whatever you want to call it) and build a drop-down under it (default)</p></div>"),
			"std" => "rolled-up"),

	array("name" => "\"Categories\" tab title",
			"desc" => "In the above option if you have chosen to show a single tab for categories and build a drop-down under it, you can set the title for that tab.
				This setting is ignored if you have chosen to display top level categories in the navigation bar.",
			"id" => $shortname."_nav_cat_tab_title",
			"parent" => "nav-setup",
			"grouping" => "nav-cats",
			"type" => "text",
			"std" => "Categories"),

	array("name" => "\"Categories\" tab link",
			"desc" => "If you have a specific page that you want to go to upon clicking the Categories tab, set the full URL here.
				This setting is ignored if you have chosen to display top level categories in the navigation bar.",
			"id" => $shortname."_nav_cat_tab_link",
			"parent" => "nav-setup",
			"grouping" => "nav-cats",
			"type" => "text",
			"hint" => "Enter the full URL, including http://",
			"std" => ""),

	array("name" => "Categories in Navigation Bar - All or Selected",
		"desc" => "You can decide if you want to show all categories or selected categories in the navigation bar.
			If you choose 'All' your settings in the next option will be ignored.
			Note that this option is different from choosing 'Select All' in the next option, because this guarantees that always all are displayed, while the next option only ensures that all selections at the time of setup are displayed",
		"id" => $shortname."_nav_cats_all_sel",
		"parent" => "nav-setup",
		"grouping" => "nav-cats",
		"type" => "radio",
		"options" => array("all" => "All, ignoring next option", "selected" => "Selections from the next option"),
		"std" => "selected"),

	array("name" => "Select categories to show in Navigation Bar",
			"desc" => "If you have too many categories on your blog you might want to exclude some so that the navigation bar doesn't get ugly. Note that if your navigation bar is hidden, this setting is ignored. Also if you select a category whose parent is not selected, the child will NOT be displayed.
				The exclusion is hierarchical, so if you exclude a parent category but include its child, neither the parent nor the child will show up in the dropdown. All categories are excluded by default. ",
			"id" => $shortname."_nav_cats",
			"parent" => "nav-setup",
			"grouping" => "nav-cats",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_category_array($shortname."_nav_cats"),
			'std' => $all_category_ids),

	array("name" => "Links in Navigation Bar",
			"desc" => "Control the display of links in the navigation bar",
			"category" => "nav-links",
			"parent" => "nav-setup",
			"type" => "sub-section-4",),

	array("name" => "WordPress Link listing style in Navigation Bar",
			"desc" => "You can choose how to show links in your navigation bar. By default a single tab for links is shown in the navigation bar.",
			"id" => $shortname."_nav_links_style",
			"parent" => "nav-setup",
			"grouping" => "nav-links",
			"type" => "radio",
			"options" => array("flattened" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-link-flat.jpg' alt='Flattened'/><p>Show the links in the navigation bar</p></div>",
				"rolled-up" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-link-roll-up.jpg' alt='Flattened'/><p>Show a single tab called \"Links\" (or whatever you want to call it) and build a drop-down under it</p></div>"),
			"std" => "rolled-up"),

	array("name" => "\"Links\" tab title",
			"desc" => "In the above option if you have chosen to show a single tab for WordPress links and build a drop-down under it, you can set the title for that tab.
				This setting is ignored if you have chosen to display individual links in the navigation bar.",
			"id" => $shortname."_nav_links_tab_title",
			"parent" => "nav-setup",
			"grouping" => "nav-links",
			"type" => "text",
			"std" => "Links"),

	array("name" => "\"Links\" tab link",
			"desc" => "If you have a specific page that you want to go to upon clicking the Links tab, set the full URL here.
				This setting is ignored if you have chosen to display top level links in the navigation bar.",
			"id" => $shortname."_nav_links_tab_link",
			"parent" => "nav-setup",
			"grouping" => "nav-links",
			"type" => "text",
			"hint" => "Enter the full URL, including http://",
			"std" => ""),

	array("name" => "Links in Navigation Bar - All or Selected",
		"desc" => "You can decide if you want to show all links or selected links in the navigation bar.
			If you choose 'All' your settings in the next option will be ignored.
			Note that this option is different from choosing 'Select All' in the next option, because this guarantees that always all are displayed, while the next option only ensures that all selections at the time of setup are displayed",
		"id" => $shortname."_nav_links_all_sel",
		"parent" => "nav-setup",
		"grouping" => "nav-links",
		"type" => "radio",
		"options" => array("all" => "All, ignoring next option", "selected" => "Selections from the next option"),
		"std" => "selected"),

	array("name" => "Select links to show in Navigation Bar",
			"desc" => "If you have too many links on your blog you might want to exclude some so that the navigation bar doesn't get ugly. Note that if your navigation bar is hidden, this setting is ignored.
				All links are excluded by default. ",
			"id" => $shortname."_nav_links",
			"parent" => "nav-setup",
			"grouping" => "nav-links",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_link_array($shortname."_nav_links")),

	array("name" => "Navigation Breadcrumb",
			"desc" => "Control the breadcrumb display. Note that this option will control breadcrumbs for <i>both, the top navigation bar and the main navigation bar</i>.",
			"category" => "nav-bc",
			"parent" => "nav-setup",
			"type" => "sub-section-4",),

	array("name" => "Excluded pages in breadcrumb",
			"desc" => "Pages excluded in the drop down menu are not shown in the breadcrumb. You might want to change this setting if you want all pages to be available for navigation:",
			"id" => $shortname."_nav_exclude_in_breadcrumb",
			"parent" => "nav-setup",
			"grouping" => "nav-bc",
			"type" => "radio",
			"options" => array("hide" => "Hide excluded pages", "show" => "Show excluded pages"),
			"std" => "hide"),

	array("name" => "Breadcrumb Navigation for Pages",
			"desc" => "For every page that you visit you see all siblings of the page, its parent and all siblings of the parent below the navigation bar.
				This is okay if you have a small number of pages at each level, but cumbersome if you have many siblings (it messes up the display). You can change this setting:",
			"id" => $shortname."_nav_breadcrumb",
			"parent" => "nav-setup",
			"grouping" => "nav-bc",
			"type" => "radio",
			"options" => array("all" => "Show all siblings, and all siblings of parent (default)",
				"breadcrumb" => "Don't show siblings, but show entire path to the page (traditional \"breadcrumb\" display)",
				"none" => "Hide the breadcrumb view altogether"),
			"std" => "breadcrumb"),

	array("name" => "Breadcrumb Separator",
			"desc" => "This is the symbol that appears as a separator between levels in your breadcrumb.
				If you have selected the \"breadcrumb\" display above then the setting you make here takes effect. Otherwise this is ignored:",
			"id" => $shortname."_breadcrumb_separator",
			"parent" => "nav-setup",
			"grouping" => "nav-bc",
			"type" => "text",
//			"hint" => "Use &amp;bull; for &bull;, &amp;gt; for &gt; and &amp;raquo; for &raquo;",
			"std" => "&raquo;"),

	array("name" => "Top Navigation Bar Setup",
			"type" => "sub-section-3",
			"category" => "navt-setup",
			"parent" => "blog-features"
	),

	array("name" => "Top Navigation Bar Look and Feel",
			"desc" => "Adjust the general look and feel options of the Top Navigation Bar",
			"category" => "navt-lf",
			"parent" => "navt-setup",
			"type" => "sub-section-4",),

	array("name" => "Set up the Top Navigation Bar",
			"desc" => "You can define what you want to show in your top navigation bar. The navigation bar contains two widget areas, 'Top Bar Left Widgets' and 'Top Bar Right Widgets' and a drop down menu.
				If you prefer having pages, categories and links listed in the sidebar, select \"Hidden\".",
			"id" => $shortname."_navt_contents",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "radio",
			"options" => array("pages" => "Drop-down menus and widget areas", "hide" => "Hidden (Default)"),
			"std" => "hide"),

	array("name" => "Top Navigation Bar Style",
			"desc" => "You can choose different navigation bar styles - full width or page width:",
			"id" => $shortname."_navt_bar_style",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "radio",
			"options" => array("full-full" => "Navigation bar is as wide as your browser window and contents of the bar begin from the left or right",
				"full-align" => "Navigation bar is as wide as your browser window and contents of the bar are aligned with your main page",
				"align" => "Navigation bar and its contents are aligned with your main page"),
			"std" => "align"),

	array("name" => "Drop-down menu position",
			"desc" => "Where in the navigation bar do you want your drop-down menu?",
			"id" => $shortname."_navt_dd_pos",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "radio",
			"concept" => "halign",
			"options" => array("left" => "Left", "right" => "Right"),
			"std" => "left"),

	array("name" => "Drop-down menu delay",
			"desc" => "You can set a delay for the drop-down menu in the navigation bar.",
			"id" => $shortname."_navt_delay",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "text",
			"hint" => "Leave blank for no delay",
			"std" => "500"),

	array("name" => "Fade effect for drop-down menu",
			"desc" => "There is a fade-in effect for the drop-down menu enabled by default. You can disable it",
			"id" => $shortname."_navt_effect",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "radio",
			"options" => array("none" => "No effects", "fade" => "Fade in the page"),
			"std" => "fade"),

	array("name" => "Show \"Home\" page?",
			"desc" => "You can show a link to your blog's home page. This could either be an icon or a text link. This setting is ignored if you are hiding your navigation bar.",
			"id" => $shortname."_navt_show_home",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "radio",
			"options" => array("none" => "Don't show a home link (default)", "text" => "Show a text link", "icon" => "Show an icon"),
			"std" => "none"),

	array("name" => "\"Home\" page text",
			"desc" => "If you have opted to show a text link above, you can set the text to show. The default is \"Home\".
				This setting is ignored if you are hiding your navigation bar or if you have chosen to not show a home link or to show a home icon.",
			"id" => $shortname."_navt_home_text",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "text",
			"std" => "Home"),

	array("name" => "Order of entities in top navigation bar",
			"desc" => "You can define the order in which Pages, Categories and Links (Bookmarks) appear in the navigation bar: ",
			"id" => $shortname."_navt_entity_order",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "sortable-list",
			"std" => suffusion_entity_prepositions('nav')),

	array("name" => "Text Transformation for Top Navigation Bar",
			"desc" => "By default all your page names are displayed with the first letter of each word capitalized in the navigation bar (except in IE 6, where it is unstyled). You can change this setting:",
			"id" => $shortname."_navt_text_transform",
			"parent" => "navt-setup",
			"grouping" => "navt-lf",
			"type" => "radio",
			"options" => array("uppercase" => "ALL UPPERCASE", "lowercase" => "all lowercase",
				"capitalize" => "Capitalize First Letter Of Each Word (default)", "none" => "No transformation"),
			"std" => "capitalize"),

	array("name" => "Pages in Navigation Bar",
			"desc" => "Control the display of pages in the navigation bar",
			"category" => "navt-pages",
			"parent" => "navt-setup",
			"type" => "sub-section-4",),

	array("name" => "Page listing style in top Navigation Bar",
			"desc" => "You can choose how to show pages in your navigation bar. By default a single tab for pages is shown in the navigation bar.",
			"id" => $shortname."_navt_pages_style",
			"parent" => "navt-setup",
			"grouping" => "navt-pages",
			"type" => "radio",
			"options" => array("flattened" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-page-flat.jpg' alt='Flattened'/><p>Show the top level pages in the navigation bar and their sub-pages in drop-downs</p></div>",
				"rolled-up" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-page-roll-up.jpg' alt='Flattened'/><p>Show a single tab called \"Pages\" (or whatever you want to call it) and build a drop-down under it (default)</p></div>"),
			"std" => "rolled-up"),

	array("name" => "\"Pages\" tab title",
			"desc" => "In the above option if you have chosen to show a single tab for pages and build a drop-down under it, you can set the title for that tab.
				This setting is ignored if you have chosen to display top level pages in the navigation bar.",
			"id" => $shortname."_navt_page_tab_title",
			"parent" => "navt-setup",
			"grouping" => "navt-pages",
			"type" => "text",
			"std" => "Pages"),

	array("name" => "\"Pages\" tab link",
			"desc" => "If you have a specific page that you want to go to upon clicking the Pages tab, set the full URL here.
				This setting is ignored if you have chosen to display top level pages in the navigation bar.",
			"id" => $shortname."_navt_page_tab_link",
			"parent" => "navt-setup",
			"grouping" => "navt-pages",
			"type" => "text",
			"hint" => "Enter the full URL, including http://",
			"std" => ""),

	array("name" => "Pages in Navigation Bar - All or Selected",
		"desc" => "You can decide if you want to show all pages or selected pages in the navigation bar.
			If you choose 'All' your settings in the next option will be ignored.
			Note that this option is different from choosing 'Select All' in the next option, because this guarantees that always all are displayed, while the next option only ensures that all selections at the time of setup are displayed",
		"id" => $shortname."_navt_pages_all_sel",
		"parent" => "navt-setup",
		"grouping" => "navt-pages",
		"type" => "radio",
		"options" => array("all" => "All, ignoring next option", "selected" => "Selections from the next option"),
		"std" => "selected"),

	array("name" => "Select pages to show in Navigation Bar",
			"desc" => "If you have too many pages on your blog you might want to exclude some so that the navigation bar doesn't get ugly. Note that if your navigation bar is hidden, this setting is ignored. Also if you select a page whose parent is not selected, the child will NOT be displayed. All pages are excluded by default",
			"id" => $shortname."_navt_pages",
			"parent" => "navt-setup",
			"grouping" => "navt-pages",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_page_array($shortname."_navt_pages"),
			"std" => ""),

	array("name" => "Categories in Navigation Bar",
			"desc" => "Control the display of categories in the navigation bar",
			"category" => "navt-cats",
			"parent" => "navt-setup",
			"type" => "sub-section-4",),

	array("name" => "Category listing style in Navigation Bar",
			"desc" => "You can choose how to show categories in your navigation bar. By default a single tab for categories is shown in the navigation bar.",
			"id" => $shortname."_navt_cat_style",
			"parent" => "navt-setup",
			"grouping" => "navt-cats",
			"type" => "radio",
			"options" => array("flattened" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-cat-flat.jpg' alt='Flattened'/><p>Show the top level categories in the navigation bar and their sub-pages in drop-downs</p></div>",
				"rolled-up" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-cat-roll-up.jpg' alt='Flattened'/><p>Show a single tab called \"Categories\" (or whatever you want to call it) and build a drop-down under it (default)</p></div>"),
			"std" => "rolled-up"),

	array("name" => "\"Categories\" tab title",
			"desc" => "In the above option if you have chosen to show a single tab for categories and build a drop-down under it, you can set the title for that tab.
				This setting is ignored if you have chosen to display top level categories in the navigation bar.",
			"id" => $shortname."_navt_cat_tab_title",
			"parent" => "navt-setup",
			"grouping" => "navt-cats",
			"type" => "text",
			"std" => "Categories"),

	array("name" => "\"Categories\" tab link",
			"desc" => "If you have a specific page that you want to go to upon clicking the Categories tab, set the full URL here.
				This setting is ignored if you have chosen to display top level categories in the navigation bar.",
			"id" => $shortname."_navt_cat_tab_link",
			"parent" => "navt-setup",
			"grouping" => "navt-cats",
			"type" => "text",
			"hint" => "Enter the full URL, including http://",
			"std" => ""),

	array("name" => "Categories in Navigation Bar - All or Selected",
		"desc" => "You can decide if you want to show all categories or selected categories in the navigation bar.
			If you choose 'All' your settings in the next option will be ignored.
			Note that this option is different from choosing 'Select All' in the next option, because this guarantees that always all are displayed, while the next option only ensures that all selections at the time of setup are displayed",
		"id" => $shortname."_navt_cats_all_sel",
		"parent" => "navt-setup",
		"grouping" => "navt-cats",
		"type" => "radio",
		"options" => array("all" => "All, ignoring next option", "selected" => "Selections from the next option"),
		"std" => "selected"),

	array("name" => "Select categories to show in Navigation Bar",
			"desc" => "If you have too many categories on your blog you might want to exclude some so that the navigation bar doesn't get ugly. Note that if your navigation bar is hidden, this setting is ignored. Also if you select a category whose parent is not selected, the child will NOT be displayed.
				The exclusion is hierarchical, so if you exclude a parent category but include its child, neither the parent nor the child will show up in the dropdown. All categories are excluded by default. ",
			"id" => $shortname."_navt_cats",
			"parent" => "navt-setup",
			"grouping" => "navt-cats",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_category_array($shortname."_navt_cats"),
			'std' => ""),

	array("name" => "Links in Navigation Bar",
			"desc" => "Control the display of links in the navigation bar",
			"category" => "navt-links",
			"parent" => "navt-setup",
			"type" => "sub-section-4",),

	array("name" => "WordPress Link listing style in Top Navigation Bar",
			"desc" => "You can choose how to show links in your navigation bar. By default a single tab for links is shown in the navigation bar.",
			"id" => $shortname."_navt_links_style",
			"parent" => "navt-setup",
			"grouping" => "navt-links",
			"type" => "radio",
			"options" => array("flattened" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-link-flat.jpg' alt='Flattened'/><p>Show the links in the navigation bar</p></div>",
				"rolled-up" => "<div class='picture'><img src='". get_stylesheet_directory_uri(). "/admin/images/nav-link-roll-up.jpg' alt='Flattened'/><p>Show a single tab called \"Links\" (or whatever you want to call it) and build a drop-down under it</p></div>"),
			"std" => "rolled-up"),

	array("name" => "\"Links\" tab title",
			"desc" => "In the above option if you have chosen to show a single tab for WordPress links and build a drop-down under it, you can set the title for that tab.
				This setting is ignored if you have chosen to display individual links in the navigation bar.",
			"id" => $shortname."_navt_links_tab_title",
			"parent" => "navt-setup",
			"grouping" => "navt-links",
			"type" => "text",
			"std" => "Links"),

	array("name" => "\"Links\" tab link",
			"desc" => "If you have a specific page that you want to go to upon clicking the Links tab, set the full URL here.
				This setting is ignored if you have chosen to display top level links in the navigation bar.",
			"id" => $shortname."_navt_links_tab_link",
			"parent" => "navt-setup",
			"grouping" => "navt-links",
			"type" => "text",
			"hint" => "Enter the full URL, including http://",
			"std" => ""),

	array("name" => "Links in Navigation Bar - All or Selected",
		"desc" => "You can decide if you want to show all links or selected links in the navigation bar.
			If you choose 'All' your settings in the next option will be ignored.
			Note that this option is different from choosing 'Select All' in the next option, because this guarantees that always all are displayed, while the next option only ensures that all selections at the time of setup are displayed",
		"id" => $shortname."_navt_links_all_sel",
		"parent" => "navt-setup",
		"grouping" => "navt-links",
		"type" => "radio",
		"options" => array("all" => "All, ignoring next option", "selected" => "Selections from the next option"),
		"std" => "selected"),

	array("name" => "Select links to show in Navigation Bar",
			"desc" => "If you have too many links on your blog you might want to exclude some so that the navigation bar doesn't get ugly.
				All links are excluded by default. ",
			"id" => $shortname."_navt_links",
			"parent" => "navt-setup",
			"grouping" => "navt-links",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_link_array($shortname."_navt_links")),

	array("name" => "Posts and Pages",
			"type" => "sub-section-3",
			"category" => "post-settings",
			"parent" => "blog-features"
	),

	array("name" => "Posts",
			"desc" => "Control positioning of post information",
			"category" => "post-settings-post",
			"parent" => "post-settings",
			"type" => "sub-section-4",),

	array("name" => "Show Categories for posts?",
			"desc" => "Links for the categories that the post is associated with show up under the title for all posts on the left side. Do you want to hide them?",
			"id" => $shortname."_post_show_cats",
			"parent" => "post-settings",
			"grouping" => "post-settings-post",
			"type" => "select",
			"options" => array("show" => "Show Categories under title on the left side", "show-tright" => "Show Categories under title on the right side",
				"show-bleft" => "Show Categories above footer on the left side", "show-bright" => "Show Categories near footer on the right side", "hide" => "Hide Categories"),
			"std" => "show"),

	array("name" => "Show Comments link for Posts?",
			"desc" => "A link for comments shows up under the title for all posts on the right side. Do you want to hide it?",
			"id" => $shortname."_post_show_comment",
			"parent" => "post-settings",
			"grouping" => "post-settings-post",
			"type" => "select",
			"options" => array( "show-tleft" => "Show Comments link under title on the left side", "show" => "Show Comments link under title on the right side",
				"show-bleft" => "Show Comments link above footer on the left side", "show-bright" => "Show Comments link near footer on the right side", "hide" => "Hide Comments link"),
			"std" => "show"),

	array("name" => "Show \"Posted By\" for Posts?",
			"desc" => "Information about the poster shows up near the footer for all posts on the left side. Do you want to hide it?",
			"id" => $shortname."_post_show_posted_by",
			"parent" => "post-settings",
			"grouping" => "post-settings-post",
			"type" => "select",
			"options" => array("show-tleft" => "Show Posted By under title on the left side", "show-tright" => "Show Posted By under title on the right side",
				"show" => "Show Posted By above footer on the left side", "show-bright" => "Show Posted By near footer on the right side", "hide" => "Hide Posted By"),
			"std" => "show"),

	array("name" => "Show Tags for posts?",
			"desc" => "Links for the tags that the post is associated with show up near the footer for all posts on the right side. Do you want to hide them?",
			"id" => $shortname."_post_show_tags",
			"parent" => "post-settings",
			"grouping" => "post-settings-post",
			"type" => "select",
			"options" => array("show-tleft" => "Show Tags under title on the left side", "show-tright" => "Show Tags under title on the right side",
				"show-bleft" => "Show Tags above footer on the left side", "show" => "Show Tags near footer on the right side", "hide" => "Hide Tags"),
			"std" => "show"),

	array("name" => "Pages",
			"desc" => "Control positioning of page information",
			"category" => "post-settings-page",
			"parent" => "post-settings",
			"type" => "sub-section-4",),

	array("name" => "Show Comments link for Pages?",
			"desc" => "A link for comments shows up under the title for all pages on the right side. Do you want to hide it?",
			"id" => $shortname."_page_show_comment",
			"parent" => "post-settings",
			"grouping" => "post-settings-page",
			"type" => "select",
			"options" => array( "show-tleft" => "Show Comments link under title on the left side", "show" => "Show Comments link under title on the right side",
				"show-bleft" => "Show Comments link above footer on the left side", "show-bright" => "Show Comments link near footer on the right side", "hide" => "Hide Comments link"),
			"std" => "show"),

	array("name" => "Show \"Posted By\" for Pages?",
			"desc" => "Information about the poster shows up near the footer for all pages on the left side. Do you want to hide it?",
			"id" => $shortname."_page_show_posted_by",
			"parent" => "post-settings",
			"grouping" => "post-settings-page",
			"type" => "select",
			"options" => array("show-tleft" => "Show Posted By under title on the left side", "show-tright" => "Show Posted By under title on the right side",
				"show" => "Show Posted By above footer on the left side", "show-bright" => "Show Posted By near footer on the right side", "hide" => "Hide Posted By"),
			"std" => "show"),

	array("name" => "Layout: Excerpt / List / Tile / Full",
			"type" => "sub-section-3",
			"category" => "excerpt-settings",
			"parent" => "blog-features"
	),

	array("name" => "Front Page settings",
		"desc" => "Control front page layout",
		"category" => "layout-front",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Layout Settings for the Front Page",
		"desc" => "By default for all posts on the front page, the complete contents are displayed.",
		"id" => $shortname."_index_excerpt",
		"parent" => "excerpt-settings",
		"grouping" => "layout-front",
		"type" => "radio",
		"options" => array("content" => "Display full content", "excerpt" => "Display excerpt", "list" => "Display list", "tiles" => 'Display tiles'),
		"std" => "content"),

	array("name" => "Number of Full content posts on Front Page",
		"desc" => "In the Excerpt, List and Tile display you can choose to show the first few posts with full content. Set the number of posts for which you want the full content displayed (ignored if you select full content above): ",
		"id" => $shortname."_index_fc_number",
		"parent" => "excerpt-settings",
		"grouping" => "layout-front",
		"type" => "select",
		"options" => array("0" => "0 (Zero)", "1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)",
			"5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)", "8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "0"),

	array("name" => "Category Page settings",
		"desc" => "Control category page layout",
		"category" => "layout-cat",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Layout Settings for Categories",
		"desc" => "If you select a category, you can choose to show excerpts instead of full contents for each post. By default the complete contents are displayed. ",
		"id" => $shortname."_category_excerpt",
		"parent" => "excerpt-settings",
		"grouping" => "layout-cat",
		"type" => "radio",
		"options" => array("content" => "Display full content", "excerpt" => "Display excerpt", "list" => "Display list", "tiles" => 'Display tiles'),
		"std" => "content"),

	array("name" => "Number of Full content posts for Categories",
		"desc" => "In the Excerpt, List and Tile display you can choose to show the first few posts with full content. Set the number of posts for which you want the full content displayed (ignored if you select full content above): ",
		"id" => $shortname."_category_fc_number",
		"parent" => "excerpt-settings",
		"grouping" => "layout-cat",
		"type" => "select",
		"options" => array("0" => "0 (Zero)", "1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)",
			"5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)", "8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "0"),

	array("name" => "Date-based Archive Page settings",
		"desc" => "Control date-based archive page layout",
		"category" => "layout-archive",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Layout Settings for Date-based Archives",
		"desc" => "If you select a month or a year, you can choose to show excerpts instead of full contents for each post. By default the complete contents are displayed. ",
		"id" => $shortname."_archive_excerpt",
		"parent" => "excerpt-settings",
		"grouping" => "layout-archive",
		"type" => "radio",
		"options" => array("content" => "Display full content", "excerpt" => "Display excerpt", "list" => "Display list", "tiles" => 'Display tiles'),
		"std" => "content"),

	array("name" => "Number of Full content posts for date-based archives",
		"desc" => "In the Excerpt, List and Tile display you can choose to show the first few posts with full content. Set the number of posts for which you want the full content displayed (ignored if you select full content above): ",
		"id" => $shortname."_archive_fc_number",
		"parent" => "excerpt-settings",
		"grouping" => "layout-archive",
		"type" => "select",
		"options" => array("0" => "0 (Zero)", "1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)",
			"5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)", "8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "0"),

	array("name" => "Tag Page settings",
		"desc" => "Control tag page layout",
		"category" => "layout-tag",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Layout Settings for Tags",
		"desc" => "If you select a tag, you can choose to show excerpts instead of full contents for each post. By default the complete contents are displayed. ",
		"id" => $shortname."_tag_excerpt",
		"parent" => "excerpt-settings",
		"grouping" => "layout-tag",
		"type" => "radio",
		"options" => array("content" => "Display full content", "excerpt" => "Display excerpt", "list" => "Display list", "tiles" => 'Display tiles'),
		"std" => "content"),

	array("name" => "Number of Full content posts for Tags",
		"desc" => "In the Excerpt, List and Tile display you can choose to show the first few posts with full content. Set the number of posts for which you want the full content displayed (ignored if you select full content above): ",
		"id" => $shortname."_tag_fc_number",
		"parent" => "excerpt-settings",
		"grouping" => "layout-tag",
		"type" => "select",
		"options" => array("0" => "0 (Zero)", "1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)",
			"5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)", "8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "0"),

	array("name" => "Search Page settings",
		"desc" => "Control search page layout",
		"category" => "layout-search",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Layout Settings for Search Results",
		"desc" => "When you perform a search the complete contents of the matching posts are displayed. You can change this to show only the excerpts. ",
		"id" => $shortname."_search_excerpt",
		"parent" => "excerpt-settings",
		"grouping" => "layout-search",
		"type" => "radio",
		"options" => array("content" => "Display full content", "excerpt" => "Display excerpt", "list" => "Display list", "tiles" => 'Display tiles'),
		"std" => "content"),

	array("name" => "Number of Full content posts for Search Results",
		"desc" => "In the Excerpt, List and Tile display you can choose to show the first few posts with full content. Set the number of posts for which you want the full content displayed (ignored if you select full content above): ",
		"id" => $shortname."_search_fc_number",
		"parent" => "excerpt-settings",
		"grouping" => "layout-search",
		"type" => "select",
		"options" => array("0" => "0 (Zero)", "1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)",
			"5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)", "8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "0"),

	array("name" => "Author Page settings",
		"desc" => "Control author page layout",
		"category" => "layout-author",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Layout Settings for the Author Page",
		"desc" => "When you pull up the posts for an author the complete contents of the posts are displayed. You can change this to show only the excerpts. ",
		"id" => $shortname."_author_excerpt",
		"parent" => "excerpt-settings",
		"grouping" => "layout-author",
		"type" => "radio",
		"options" => array("content" => "Display full content", "excerpt" => "Display excerpt", "list" => "Display list", "tiles" => 'Display tiles'),
		"std" => "content"),

	array("name" => "Number of Full content posts for Authors",
		"desc" => "In the Excerpt, List and Tile display you can choose to show the first few posts with full content. Set the number of posts for which you want the full content displayed (ignored if you select full content above): ",
		"id" => $shortname."_author_fc_number",
		"parent" => "excerpt-settings",
		"grouping" => "layout-author",
		"type" => "select",
		"options" => array("0" => "0 (Zero)", "1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)",
			"5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)", "8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "0"),

	array("name" => "General Excerpt settings",
		"desc" => "Control general settings for excerpts",
		"category" => "excerpt-gen",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Number of words in auto-generated excerpts (WordPress 2.9 and higher)",
		"desc" => "By default auto-generated excerpts in WordPress are 55 words long. You can set this length to anything you like:",
		"id" => $shortname."_excerpt_custom_length",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-gen",
		"type" => "text",
		"hint" => "Enter the number of words here.",
		"std" => "55"),

	array("name" => "Replacement text for \"[...]\" in excerpts (WordPress 2.9 and higher)",
		"desc" => "By default auto-generated excerpts in WordPress end with \"[...]\". You can change this:",
		"id" => $shortname."_excerpt_custom_more_text",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-gen",
		"type" => "text",
		"hint" => "Enter the replacement text here.",
		"std" => "[...]"),

	array("name" => "Thumbnail settings",
		"desc" => "Control settings for thumbnails",
		"category" => "excerpt-thumb",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Show thumbnails for excerpts",
		"desc" => "If you are retrieving an excerpt, you can display a thumbnail for it.
			WP 2.9 supports native thumbnails. So if you have a Post Thumbnail set in your Edit Page or Edit Post screen (right side), this takes precedence.
			Otherwise the thumbnail is picked up from the URL provided in the \"Thumbnail\" setting of a post or a page:",
		"id" => $shortname."_show_excerpt_thumbnail",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "radio",
		"options" => array("show" => "Display Thumbnail, if available", "hide" => "Hide Thumbnail"),
		"std" => "show"),

	array("name" => "Show thumbnails for full content (WordPress 2.9 and higher)",
		"desc" => "WP 2.9 introduced native thumbnail capability. The thumbnail can be defined for both excerpts and full content.
			For excerpts the previous setting takes effect. You can show thumbnails for posts by controlling the setting here.
			Note that to use this feature your thumbnail must be defined in the \"Post Thumbnail\" section of your Edit Page or Edit Post screen:",
		"id" => $shortname."_show_content_thumbnail",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "radio",
		"options" => array("show" => "Display Thumbnail, if available", "hide" => "Hide Thumbnail"),
		"std" => "show"),

	array("name" => "Use TimThumb for resizing",
		"desc" => "The default WP implementation of thumbnail resizing has some limitations.
			Suffusion uses <a href='http://www.darrenhoyt.com/2008/04/02/timthumb-php-script-released/'>TimThumb</a> to address the shortcomings.
			Note that if you are linking to an image on an external site, TimThumb will download a copy of that image locally.
			<b>Make sure that you are not violating any copyright.</b> You can disable TimThumb if you face issues:",
		"id" => $shortname."_img_use_resizing_script",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "radio",
		"options" => array("timthumb" => "Use TimThumb", "wp" => "Use the default WordPress resizing"),
		"std" => "timthumb"),

	array("name" => "Use TimThumb 'Zoom Crop'",
		"desc" => "Try changing this setting if you feel your images are not being cropped correctly:",
		"id" => $shortname."_excerpt_tt_zc",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "radio",
		"options" => array("0" => "No zoom crop", "1" => "Use zoom crop"),
		"std" => "1"),

	array("name" => "Set TimThumb compression quality",
		"desc" => "Adjust this if you want to change the quality of your compressed image. The default is 75:",
		"id" => $shortname."_excerpt_tt_quality",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "slider",
		"options" => array("range" => "min", "min" => 25, "max" => 100, "step" => 1, "size" => "400px", "unit" => ""),
		"std" => 75),

	array("name" => "Thumbnail alignment in excerpts",
		"desc" => "You can set the thumbnail (if present) to appear either on the left or on the right of the excerpt:",
		"id" => $shortname."_excerpt_thumbnail_alignment",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "radio",
		"options" => array("left" => "Show thumbnail on the left of the excerpt", "right" => "Show thumbnail on the right of the excerpt"),
		"std" => "left"),

	array("name" => "Thumbnail size in excerpts",
		"desc" => "You can set the size of the thumbnail (if present). This is the size of the thumbnail in the excerpt:",
		"id" => $shortname."_excerpt_thumbnail_size",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "radio",
		"options" => array("thumbnail" => "Thumbnail size, as defined in Settings -&gt; Media",
			"medium" => "Medium size, as defined in Settings -&gt; Media",
			"large" => "Large size, as defined in Settings -&gt; Media",
			"full" => "Full size of the image",
			"custom" => "Custom size defined below"),
		"std" => "thumbnail"),

	array("name" => "Custom width of thumbnail",
		"desc" => "If you have chosen to define a custom size above, please enter the width in pixels:",
		"id" => $shortname."_excerpt_thumbnail_custom_width",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "text",
		"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
		"std" => "200"),

	array("name" => "Custom height of thumbnail",
		"desc" => "If you have chosen to define a custom size above, please enter the height in pixels:",
		"id" => $shortname."_excerpt_thumbnail_custom_height",
		"parent" => "excerpt-settings",
		"grouping" => "excerpt-thumb",
		"type" => "text",
		"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
		"std" => "200"),

	array("name" => "List layout settings",
		"desc" => "Control settings for \"Display List\" option ",
		"category" => "layout-list",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Number of posts in \"Display List\" option",
		"desc" => "If you have selected \"Display List\" for any of the views above, you can control the number of posts to show per page:",
		"id" => $shortname."_excerpt_list_count",
		"parent" => "excerpt-settings",
		"grouping" => "layout-list",
		"type" => "radio",
		"options" => array("all" => "Show all results",
			"posts-per-page" => "Show as many posts as allowed in the 'Posts Per Page' setting in Settings -&gt; Reading",),
		"std" => "all"),

	array("name" => "List style in \"Display List\" option",
		"desc" => "If you have selected \"Display List\" for any of the views above, you can choose to show ordered or unordered lists:",
		"id" => $shortname."_excerpt_list_style",
		"parent" => "excerpt-settings",
		"grouping" => "layout-list",
		"type" => "radio",
		"options" => array("ul" => "Unordered List", "ol" => "Ordered List",),
		"std" => "ul"),

	array("name" => "Tile layout settings",
		"desc" => "Control settings for \"Display Tiles\" option ",
		"category" => "layout-tiles",
		"parent" => "excerpt-settings",
		"type" => "sub-section-4",),

	array("name" => "Number of excerpts per row in \"Display Tiles\" option",
		"desc" => "If you have selected \"Display Tiles\" option for any of the views above, you can control the number of excerpts (tiles) to show per row:",
		"id" => $shortname."_tile_excerpts_per_row",
		"parent" => "excerpt-settings",
		"grouping" => "layout-tiles",
		"type" => "select",
		"options" => array("1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)", "5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)",
			"8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "3"),

	array("name" => "Thumbnail container for excerpts",
		"desc" => "You can show thumbnails for excerpts in the tiles display: ",
		"id" => $shortname."_tile_images_enabled",
		"parent" => "excerpt-settings",
		"grouping" => "layout-tiles",
		"type" => "radio",
		"options" => array("show" => "Always show Thumbnail container", "hide" => "Always hide Thumbnail container",
			"hide-empty" => "Hide Thumbnail container if there is no thumbnail"),
		"std" => "show"),

	array("name" => "Thumbnail container height for excerpts",
		"desc" => "For the purposes of visual consistency you can set the height of the box in which the thumbnail will be placed. Your thumbnail will be \"cropped\" to this height: ",
		"id" => $shortname."_tile_image_box_height",
		"parent" => "excerpt-settings",
		"grouping" => "layout-tiles",
		"type" => "text",
		"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
		"std" => "100"),

	array("name" => "Display Tiles - Alignment of post title in Excerpts",
		"desc" => "You can set the alignment for the post title in the excerpts: ",
		"id" => $shortname."_tile_title_alignment",
		"parent" => "excerpt-settings",
		"grouping" => "layout-tiles",
		"type" => "radio",
		"options" => array("left" => "Left", "center" => "Center", "right" => "Right"),
		"std" => "left"),

	array("name" => "SEO / Meta Settings",
		"type" => "sub-section-3",
		"category" => "seo-settings",
		"parent" => "blog-features"
	),

	array("name" => "Enable SEO settings for the theme?",
			"desc" => "Suffusion comes bundled with SEO settings. You should turn these off if you are using a plugin like All-in-One SEO or Platinum SEO. ",
			"id" => $shortname."_seo_enabled",
			"parent" => "seo-settings",
			"type" => "radio",
			"options" => array("enabled" => "Enable SEO", "disabled" => "Disable SEO"),
			"std" => "enabled"),

	array("name" => "Select Meta tags",
			"desc" => "The options you pick here will be applied to the document headers. Each option corresponds to a meta tag that the theme creates: ",
			"id" => $shortname."_seo_all_settings",
			"parent" => "seo-settings",
			"type" => "multi-select",
			"options" => suf_get_formatted_options_array($shortname."_seo_all_settings", array('generator' => 'Show WordPress version tags',
				'theme' => 'Include Suffusion theme information tags',
				'robots' => 'Hide page from Google and other search engines',
				'author' => "Include author information",
				'copyright' => 'Include copyright info',
				'revised' => "Include page revision info"))),

	array("name" => "Title style",
		"desc" => "The best practices in SEO suggest that your article title should be the first text in your page title.
			For category views etc the article title is the name of category. You can pick your setting: ",
		"id" => $shortname."_seo_title_style",
		"parent" => "seo-settings",
		"type" => "radio",
		"options" => array('page-blog' => 'Show the page title followed by the blog title',
			'blog-page' => 'Show the blog title followed by the page title', 'page' => 'Show the page title only'),
		"std" => "page-blog"),

	array("name" => "Title Separator",
			"desc" => "This is the symbol that appears as a separator between the page title and blog title (based on your selection in the parevious option):",
			"id" => $shortname."_seo_title_separator",
			"parent" => "seo-settings",
			"type" => "text",
			"hint" => "Use &amp;bull; for &bull;, &amp;gt; for &gt; and &amp;raquo; for &raquo;",
			"std" => "&raquo;"),

	array("name" => "Homepage Meta Description",
			"desc" => "Enter a brief description for your home page, not more than 30 words:",
			"id" => $shortname."_seo_meta_description",
			"parent" => "seo-settings",
			"hint" => "Leave blank if you don't want a meta description",
			"type" => "textarea"),

	array("name" => "Homepage Meta Keywords",
			"desc" => "Enter a comma-separated list of keywords that best describe your blog:",
			"id" => $shortname."_seo_meta_keywords",
			"parent" => "seo-settings",
			"type" => "textarea",
			"hint" => "Leave blank if you don't want meta keywords"),

	array("name" => "Comment Settings",
			"type" => "sub-section-3",
			"category" => "comment-settings",
			"parent" => "blog-features"
	),

	array("name" => "Hide \"Comment form closed\" Message on Pages",
			"desc" => "If you disable comments on a page, by default a  \"Comment form closed\" message shows up. ".
				"You can choose to hide this message for selected pages, if you thing it makes your page look too \"blog-like\". ".
				"If you select a page from the list below it will not show the \"Comment form closed\" message. ".
				"Note that if comments are <b>enabled</b> for a page, selecting it here will not make a difference. ",
			"id" => $shortname."_comments_disabled",
			"parent" => "comment-settings",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_page_array($shortname."_comments_disabled")),

	array("name" => "Hide \"Comment form closed\" Message on Posts",
		"desc" => "If you disable comments on a post, by default a  \"Comment form closed\" message shows up. ".
			"You can choose to hide this message for all such posts, if you thing it makes your page look too \"blog-like\". ".
			"Note that if comments are <b>enabled</b> for a post, setting this option will not make a difference. ",
		"id" => $shortname."_comments_disabled_msg_for_posts",
		"parent" => "comment-settings",
		"type" => "radio",
		"options" => array('show' => 'Show the message', 'hide' => 'Hide the message'),
		"std" => "show"),

	array("name" => "Show Trackbacks and Pingbacks?",
			"desc" => "By default Trackbacks and Pingbacks to your blog posts show up along with other comments. ",
			"id" => $shortname."_show_track_ping",
			"parent" => "comment-settings",
			"type" => "radio",
			"options" => array("show" => "Show all Trackbacks and Pingbacks with comments", "hide" => "Don't show Trackbacks and Pingbacks",
				"separate" => "Show Trackbacks and Pingbacks, but separate them from the comments"),
			"std" => "show"),

	array("name" => "Allow Replies for Trackbacks and Pingbacks?",
			"desc" => "For comments that are trackbacks or pingbacks you might want to hide the \"Reply\" link: ",
			"id" => $shortname."_show_hide_reply_link_for_pings",
			"parent" => "comment-settings",
			"type" => "radio",
			"options" => array("allow" => "Allow replies to Trackbacks and Pingbacks", "disallow" => "Don't allow replies to Trackbacks and Pingbacks"),
			"std" => "disallow"),

	array("name" => "Comment form labels styles",
			"desc" => "You can choose to have theme-based styles for labels in your comment form, or leave them unstyled. The theme-based style is more colorful (which you may or may not prefer): ",
			"id" => $shortname."_comment_label_styles",
			"parent" => "comment-settings",
			"type" => "radio",
			"options" => array("plain" => "Plain (unstyled, default)", "theme" => "Theme-based style"),
			"std" => "plain"),

	array("name" => "Featured Content",
		"type" => "sub-section-3",
		"category" => "featured-settings",
		"parent" => "blog-features"
	),

	array("name" => "Showing Featured Posts",
			"desc" => "Featured posts help bring certain posts to the top of your blog. Suffusion supports Featured Posts in 2 different ways:
				<ul class='margin-20'>
					<li>Sticky Posts</li>
					<li>Selected Categories</li>
				</ul>
				Suffusion uses the excellent <a href='http://www.malsup.com/jquery/cycle/'>JQuery Cycle</a> to create a Featured section above your posts.
				Additionally you can define a \"Featured Image\" (preferably as wide as your blog posts). If you don't associate a featured image, the thumbnail will be picked.
				And if you don't provide a thumbnail, the first attached image will be used. Note, though, that not having a featured image will generate thumbnail size images, displaying a lot of blank space.
				Good practices:
				<ul class='margin-20'>
					<li>Use featured images for every post that you want to show in your featured section.</li>
					<li>Define featured images that are at least as wide as your posts.</li>
					<li>Don't use too many featured posts. Remember that this section should have useful information, not all information. Having too many posts will make your script sluggish.</li>
				</ul>
				",
			"parent" => "featured-settings",
			"type" => "blurb"),

	array("name" => "Where to Show",
			"desc" => "Where do you want the Featured Content to appear?",
			"category" => "fc-where",
			"parent" => "featured-settings",
			"type" => "sub-section-4",),

	array("name" => "Main (default) page",
			"desc" => "You can enable the Featured Posts slider on your main page. This is also the default page: ",
			"id" => $shortname."_featured_index_view",
			"parent" => "featured-settings",
			"grouping" => "fc-where",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "disabled"),

	array("name" => "Category view",
			"desc" => "You can enable the Featured Posts slider for your category view. This way you will see the featured section whenever you are looking at posts in a particular category: ",
			"id" => $shortname."_featured_category_view",
			"parent" => "featured-settings",
			"grouping" => "fc-where",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "disabled"),

	array("name" => "Tag view",
			"desc" => "You can enable the Featured Posts slider for your tag view. This way you will see the featured section whenever you are looking at posts with a particular tag: ",
			"id" => $shortname."_featured_tag_view",
			"parent" => "featured-settings",
			"grouping" => "fc-where",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "disabled"),

	array("name" => "Author view",
			"desc" => "You can enable the Featured Posts slider for your author view. This way you will see the featured section whenever you are looking at an author page: ",
			"id" => $shortname."_featured_author_view",
			"parent" => "featured-settings",
			"grouping" => "fc-where",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "disabled"),

	array("name" => "Search view",
			"desc" => "You can enable the Featured Posts slider for your search view. This way you will see the featured section whenever you are looking at search results: ",
			"id" => $shortname."_featured_search_view",
			"parent" => "featured-settings",
			"grouping" => "fc-where",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "disabled"),

	array("name" => "Time archive view",
			"desc" => "You can enable the Featured Posts slider for your tiem archive (time / date / day / month / year) view. This way you will see the featured section whenever you are looking at time-based archives: ",
			"id" => $shortname."_featured_time_view",
			"parent" => "featured-settings",
			"grouping" => "fc-where",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "disabled"),

	array("name" => "Static Pages with Featured Content",
			"desc" => "By default the featured content is not shown on static pages. You can choose the pages in your blog that will contain the Featured Posts: ",
			"id" => $shortname."_featured_pages_with_fc",
			"parent" => "featured-settings",
			"grouping" => "fc-where",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_page_array($shortname."_featured_pages_with_fc")),

	array("name" => "What to Show",
			"desc" => "What do you want to display in the Featured Content section?",
			"category" => "fc-what",
			"parent" => "featured-settings",
			"type" => "sub-section-4",),

	array("name" => "Featured Posts - Number of Posts",
			"desc" => "You can decide how many posts you want to show on your blog. By default this is limited to the number of posts you allow per page: ",
			"id" => $shortname."_featured_num_posts",
			"parent" => "featured-settings",
			"grouping" => "fc-what",
			"type" => "text",
			"hint" => "Enter the number here. Please enter positive numeric values only",
			"std" => get_option('posts_per_page')),

	array("name" => "Featured Posts - Show Sticky Posts",
			"desc" => "You can include sticky posts in the featured posts slider.
				To make a post \"sticky\" go to the \"Edit Posts\" menu, then click on the \"Visibility\" option in the publish section and
				select \"Stick this post to the front page\": ",
			"id" => $shortname."_featured_allow_sticky",
			"parent" => "featured-settings",
			"grouping" => "fc-what",
			"type" => "radio",
			"options" => array("show" => "Show sticky posts", "hide" => "Hide sticky posts"),
			"std" => "show"),

	array("name" => "Featured Posts - Show Latest Posts",
			"desc" => "You can include the latest posts of your blog in the featured section: ",
			"id" => $shortname."_featured_show_latest",
			"parent" => "featured-settings",
			"grouping" => "fc-what",
			"type" => "radio",
			"options" => array("show" => "Show latest posts", "hide" => "Hide latest posts"),
			"std" => "hide"),

	array("name" => "Featured Posts - Number of Latest Posts",
			"desc" => "You can decide how many of the latest posts you want to show on your blog. This is not relevant if you are hiding latest posts.
				In case the number of latest posts is higher than the total number of posts, this setting is ignored: ",
			"id" => $shortname."_featured_num_latest_posts",
			"parent" => "featured-settings",
			"grouping" => "fc-what",
			"type" => "text",
			"hint" => "Enter the number here. Please enter positive numeric values only",
			"std" => 5),

	array("name" => "Featured Posts - Select Categories",
			"desc" => "In addition to sticky posts you can include posts from selected categories in the featured posts slider.
				By default no category is selected: ",
			"id" => $shortname."_featured_selected_categories",
			"parent" => "featured-settings",
			"grouping" => "fc-what",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_category_array($shortname."_featured_selected_categories")),

	array("name" => "Featured Posts - Select Pages",
			"desc" => "You can also include static pages in the featured posts slider. Note that the inclusion is NOT hierarchical here. By default no page is selected: ",
			"id" => $shortname."_featured_selected_pages",
			"parent" => "featured-settings",
			"grouping" => "fc-what",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_page_array($shortname."_featured_selected_pages")),

	array("name" => "How to Show",
			"desc" => "Set the visual effects of the featured content section here",
			"category" => "fc-how",
			"parent" => "featured-settings",
			"type" => "sub-section-4",),

	array("name" => "Use \"Lite\" version of JQuery Cycle?",
			"desc" => "If you are using the 'Fade' transition below and you don't want the post index, you should use the Lite version of the JQuery Cycle plugin. It is much smaller: ",
			"id" => $shortname."_featured_use_lite",
			"parent" => "featured-settings",
			"grouping" => "fc-how",
			"type" => "radio",
			"options" => array("lite" => "Use Lite version (4 KB)", "regular" => "Use Regular version (29 KB)"),
			"std" => "regular"),

	array("name" => "Featured Posts - Transition Effects",
			"desc" => "You can pick the effect you want to use for your featured posts' transitions. These are effects provided by the JQuery Cycle script.
				Note that not all effects will look good on your blog. You should pick the one that best suits your needs: ",
			"id" => $shortname."_featured_fx",
			"parent" => "featured-settings",
			"grouping" => "fc-how",
			"type" => "radio",
			"options" => array("fade" => "Fade In", "scrollUp" => "Scroll Up", "scrollDown" => "Scroll Down", "scrollLeft" => "Scroll Left", "scrollRight" => "Scroll Right",
				"scrollHorz" => "Scroll Horizontally", "scrollVert" => "Scroll Vertically",
				"slideX" => "Slide in and back horizontally", "slideY" => "Slide in and back vertically",
				"turnUp" => "Turn Upwards", "turnDown" => "Turn Downwards", "turnLeft" => "Turn Leftwards", "turnRight" => "Turn Rightwards",
				"zoom" => "Zoom", "fadeZoom" => "Zoom and Fade", "blindX" => "Vertical Blinds", "blindY" => "Horizontal Blinds", "blindZ" => "Diagonal Blinds",
				"growX" => "Grow horizontally from center", "growY" => "Grow vertically from center",
				"curtainX" => "Squeeze in both edges horizontally", "curtainY" => "Squeeze in both edges vertically",
				"cover" => "Current post is covered by next post", "uncover" => "Current post moves off next post", "wipe" => "Wipe",
			),
			"std" => "fade"),

	array("name" => "Featured Posts - Image synchronization",
		"desc" => "By default a new image starts showing only when the old one has cleared. You can change this behavior: ",
		"id" => $shortname."_featured_sync",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "radio",
		"options" => array("0" => "Show new image only after old one has cleared out fully", "1" => "Start showing new image as the old one starts clearing out"),
		"std" => "0"),

	array("name" => "Featured Posts - Time for each post display",
			"desc" => "The posts in the Featured Posts are each displayed for 4000 milliseconds (4 seconds). You can change this interval: ",
			"id" => $shortname."_featured_interval",
			"parent" => "featured-settings",
			"grouping" => "fc-how",
			"type" => "text",
			"hint" => "Enter the time in milliseconds (don't enter \"ms\"!)",
			"std" => "4000"),

	array("name" => "Featured Posts - Transition speed for post",
			"desc" => "Depending on the transition effect you have chosen you may want to speed up or slow down your transition. Set the duration of the transition effect here: ",
			"id" => $shortname."_featured_transition_speed",
			"parent" => "featured-settings",
			"grouping" => "fc-how",
			"type" => "text",
			"hint" => "Enter the time in milliseconds (don't enter \"ms\"!)",
			"std" => "1000"),

	array("name" => "Height of the Featured Posts section",
			"desc" => "The Featured Posts section is 250px high by default. You can change this setting depending on the size of your featuerd images.",
			"id" => $shortname."_featured_height",
			"parent" => "featured-settings",
			"grouping" => "fc-how",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "250"),

	array("name" => "Featured Posts - Show Border",
			"desc" => "You can opt to show a border for your featured posts section: ",
			"id" => $shortname."_featured_show_border",
			"parent" => "featured-settings",
			"grouping" => "fc-how",
			"type" => "radio",
			"options" => array("show" => "Show border", "hide" => "Hide border"),
			"std" => "show"),

	array("name" => "Image size in featured content",
			"desc" => "You can set the size of the featured image (if present):",
			"id" => $shortname."_featured_image_size",
			"parent" => "featured-settings",
			"grouping" => "fc-how",
			"type" => "radio",
			"options" => array("full" => "Full size of the image",
				"custom" => "Custom size defined below"),
			"std" => "full"),

	array("name" => "Custom width of featured image",
		"desc" => "If you have chosen to define a custom size above, please enter the width in pixels:",
		"id" => $shortname."_featured_image_custom_width",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "text",
		"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
		"std" => "200"),

	array("name" => "Custom height of featured image",
		"desc" => "If you have chosen to define a custom size above, please enter the height in pixels:",
		"id" => $shortname."_featured_image_custom_height",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "text",
		"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
		"std" => "200"),

	array("name" => "Featured Posts - Display Text",
		"desc" => "You can decide what you want to include in your text display for the featured content. This text is laid over the featured image: ",
		"id" => $shortname."_featured_excerpt_type",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "radio",
		"options" => array("title-excerpt" => "Show post title and excerpt (default)", "title" => "Show post title only (no excerpt)",
			"excerpt" => "Show excerpt only (no title)", "none" => "Don't show any text (useful if your images have text included)"),
		"std" => "title-excerpt"),

	array("name" => "Featured Posts - Position of Text",
		"desc" => "You can decide where you want your excerpt to appear on the featured posts section: ",
		"id" => $shortname."_featured_excerpt_position",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "radio",
		"options" => array("top" => "Top", "bottom" => "Bottom", "right" => "Right", "left" => "Left",
			"alttb" => "Alternate excerpt between top and bottom", "altlr" => "Alternate excerpt between left and right",
			"rotate" => "Rotate between the four positions"),
		"std" => "rotate"),

	array("name" => "Width of Text",
		"desc" => "You can define the width to use for excerpts. Note that this is relevant only if your excerpt is at the right or at the left of your featured posts.",
		"id" => $shortname."_featured_excerpt_width",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "text",
		"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
		"std" => "250"),

	array("name" => "Featured Posts - Text background color",
		"desc" => "Depending on the color of your featured images, you might want to choose a different background color for your excerpt in your featured posts. ",
		"id" => $shortname."_featured_excerpt_bg_color",
		"grouping" => "fc-how",
		"parent" => "featured-settings",
		"type" => "color-picker",
		"std" => "222222"),

	array("name" => "Featured Posts - Text font color",
		"desc" => "Depending on the color of your featured images, you might want to choose a different font color for your excerpt in your featured posts. ",
		"id" => $shortname."_featured_excerpt_font_color",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "color-picker",
		"std" => "FFFFFF"),

	array("name" => "Featured Posts - Link font color",
		"desc" => "Depending on the color of your featured images, you might want to choose a different link font color in your excerpt in your featured posts. ",
		"id" => $shortname."_featured_excerpt_link_color",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "color-picker",
		"std" => "FFFFFF"),

	array("name" => "Featured Posts - Post Index",
		"desc" => "You can show a numbered listing of posts for your Featured Posts: ",
		"id" => $shortname."_featured_pager",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "radio",
		"options" => array("show" => "Show Post Index", "hide" => "Hide Post Index"),
		"std" => "show"),

	array("name" => "Featured Posts - Pause, Previous and Next Controls",
		"desc" => "In addition to the numbered listing of posts you can display a controller for showing links to \"Previous Post\", \"Pause\" and \"Next Post\": ",
		"id" => $shortname."_featured_controller",
		"parent" => "featured-settings",
		"grouping" => "fc-how",
		"type" => "radio",
		"options" => array("show" => "Show Pause, Previous and Next Controls", "hide" => "Hide Pause, Previous and Next Controls"),
		"std" => "hide"),

	array("name" => "Tabbed Sidebar",
		"type" => "sub-section-3",
		"category" => "sbtab-settings",
		"parent" => "blog-features"
	),

	array("name" => "Enable Tabbed Sidebar?",
			"desc" => "Tabbed Sidebars, a.k.a. Tabbed Widgets are used to represent multiple widgets in a single tabbed window. Suffusion lets you set up your tabbed sidebar.
				Do you want to enable it? ",
			"id" => $shortname."_sbtab_enabled",
			"parent" => "sbtab-settings",
			"type" => "radio",
			"note" => "If you have chosen to have 0 sidebars in your \"Sidebars and Widget Areas\" setup, this setting is irrelevant.",
			"options" => array("enabled" => "Enable Tabbed Sidebar", "disabled" => "Do not enable the Tabbed Sidebar"),
			"std" => "disabled"),

	array("name" => "Alignment of Tabbed Sidebar",
			"desc" => "Which side do you want your tabbed sidebar? Note that you need to have at least one sidebar enabled on the side that you are selecting here, or the other side might be used. ",
			"id" => $shortname."_sbtab_alignment",
			"parent" => "sbtab-settings",
			"type" => "radio",
			"options" => array("right" => "Right", "left" => "Left"),
			"std" => "right"),

	array("name" => "Contents of Tabbed Sidebar",
			"desc" => "You can pick what you want to show in the tabbed sidebar: ",
			"id" => $shortname."_sbtab_widgets",
			"parent" => "sbtab-settings",
			"type" => "multi-select",
			"options" => suffusion_get_formatted_sbtab_array('suf_sbtab_widgets', true)),

	array("name" => "Order of tabs in Tabbed Sidebar",
			"desc" => "You can define the order of the tabs in the tabbed sidebar: ",
			"id" => $shortname."_sbtab_widget_order",
			"parent" => "sbtab-settings",
			"type" => "sortable-list",
			"std" => suffusion_tab_array_prepositions()),

	array("name" => "Tabbed Sidebar - Categories Title",
			"desc" => "If you have opted to display the Categories tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_categories_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['categories']['title']),

	array("name" => "Tabbed Sidebar - List categories hierarchically?",
			"desc" => "You can decide if you want to list your categories in a hierarchical manner: ",
			"id" => $shortname."_sbtab_categories_hierarchical",
			"parent" => "sbtab-settings",
			"type" => "radio",
			"options" => array("hierarchical" => "Categories listed hierarchically",
							"flat" => "Categories listed flat"),
			"std" => "hierarchical"),

	array("name" => "Tabbed Sidebar - Show post count for each category?",
			"desc" => "You can display the number of posts in each category. Categories with 0 posts are excluded: ",
			"id" => $shortname."_sbtab_categories_post_count",
			"parent" => "sbtab-settings",
			"type" => "radio",
			"options" => array("show" => "Show Post Count",
							"hide" => "Hide Post Count"),
			"std" => "hide"),

	array("name" => "Tabbed Sidebar - Archives Title",
			"desc" => "If you have opted to display the Archives tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_archives_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['archives']['title']),

	array("name" => "Tabbed Sidebar - Archive grouping",
			"desc" => "What kind of grouping do you want to display for your archives? ",
			"id" => $shortname."_sbtab_archives_type",
			"parent" => "sbtab-settings",
			"type" => "radio",
			"options" => array("yearly" => "Yearly", "monthly" => "Monthly", "weekly" => "Weekly","daily" => "Daily", "postbypost" => "Posts ordered by post date",
							"alpha" => "Posts ordered by post title"),
			"std" => "monthly"),

	array("name" => "Tabbed Sidebar - Archive list type",
			"desc" => "What kind of listing do you want for your archives? ",
			"id" => $shortname."_sbtab_archives_list_type",
			"parent" => "sbtab-settings",
			"type" => "radio",
			"options" => array("html" => "A bullet list", "option" => "A dropdown list"),
			"std" => "html"),

	array("name" => "Tabbed Sidebar - Show post count for each archive?",
			"desc" => "You can display the number of posts in each archive. Archives with 0 posts are excluded: ",
			"id" => $shortname."_sbtab_archives_post_count",
			"parent" => "sbtab-settings",
			"type" => "radio",
			"options" => array("show" => "Show Post Count",
							"hide" => "Hide Post Count"),
			"std" => "hide"),

	array("name" => "Tabbed Sidebar - Links Title",
			"desc" => "If you have opted to display the Links tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_Links_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['links']['title']),

	array("name" => "Tabbed Sidebar - Meta Title",
			"desc" => "If you have opted to display the Meta tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_meta_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['meta']['title']),

	array("name" => "Tabbed Sidebar - Pages Title",
			"desc" => "If you have opted to display the Pages tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_pages_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['pages']['title']),

	array("name" => "Tabbed Sidebar - Recent Comments Title",
			"desc" => "If you have opted to display the Recent Comments tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_recent_comments_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['recent_comments']['title']),

	array("name" => "Tabbed Sidebar - Recent Posts Title",
			"desc" => "If you have opted to display the Recent Posts tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_recent_posts_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['recent_posts']['title']),

	array("name" => "Tabbed Sidebar - Search Title",
			"desc" => "If you have opted to display the Search tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_search_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['search']['title']),

	array("name" => "Tabbed Sidebar - Tag Cloud Title",
			"desc" => "If you have opted to display the Tag Cloud tab in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_tag_cloud_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['tag_cloud']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 1 Title",
			"desc" => "If you have opted to display the Custom Tab 1 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_1_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_1']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 1 Contents",
			"desc" => "If you have opted to display the Custom Tab 1 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_1_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 2 Title",
			"desc" => "If you have opted to display the Custom Tab 2 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_2_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_2']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 2 Contents",
			"desc" => "If you have opted to display the Custom Tab 2 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_2_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 3 Title",
			"desc" => "If you have opted to display the Custom Tab 3 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_3_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_3']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 3 Contents",
			"desc" => "If you have opted to display the Custom Tab 3 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_3_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 4 Title",
			"desc" => "If you have opted to display the Custom Tab 4 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_4_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_4']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 4 Contents",
			"desc" => "If you have opted to display the Custom Tab 4 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_4_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 5 Title",
			"desc" => "If you have opted to display the Custom Tab 5 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_5_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_5']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 5 Contents",
			"desc" => "If you have opted to display the Custom Tab 5 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_5_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 6 Title",
			"desc" => "If you have opted to display the Custom Tab 6 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_6_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_6']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 6 Contents",
			"desc" => "If you have opted to display the Custom Tab 6 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_6_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 7 Title",
			"desc" => "If you have opted to display the Custom Tab 7 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_7_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_7']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 7 Contents",
			"desc" => "If you have opted to display the Custom Tab 7 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_7_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 8 Title",
			"desc" => "If you have opted to display the Custom Tab 8 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_8_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_8']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 8 Contents",
			"desc" => "If you have opted to display the Custom Tab 8 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_8_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 9 Title",
			"desc" => "If you have opted to display the Custom Tab 9 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_9_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_9']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 9 Contents",
			"desc" => "If you have opted to display the Custom Tab 9 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_9_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Tabbed Sidebar - Custom Tab 10 Title",
			"desc" => "If you have opted to display the Custom Tab 10 in the tabbed sidebar, you can set its title here: ",
			"id" => $shortname."_sbtab_custom_tab_10_title",
			"parent" => "sbtab-settings",
			"type" => "text",
			"std" => $sidebar_tabs['custom_tab_10']['title']),

	array("name" => "Tabbed Sidebar - Custom Tab 10 Contents",
			"desc" => "If you have opted to display the Custom Tab 10 in the tabbed sidebar, you can set its contents here: ",
			"id" => $shortname."_sbtab_custom_tab_10_contents",
			"parent" => "sbtab-settings",
			"type" => "textarea",
			"std" => ""),

	array("name" => "Page Navigation",
		"type" => "sub-section-3",
		"category" => "pagination-settings",
		"parent" => "blog-features"
	),

	array("name" => "Options for paged navigation of posts",
			"desc" => "Suffusion lets you select your own type of page navigation. And if you don't like Suffusion's page navigation styles, you can always use WP-PageNavi.
				If you use WP-PageNavi then the selection here is ignored. ",
			"id" => $shortname."_pagination_type",
			"parent" => "pagination-settings",
			"type" => "radio",
			"options" => array("old-new" => "Simple navigation, showing links to a page with older posts and a page with newer posts",
				"numbered" => "A numbered listing of pages"),
			"std" => "old-new"),

	array("name" => "Numbered Listing - Page x of y",
			"desc" => "If you have chosen to display a numbered listing of pages, you can choose to show prefix the page list that will highlight which page you are on.
				It will put in a text saying \"Page x of y\". If you use WP-PageNavi then the selection here is ignored.",
			"id" => $shortname."_pagination_index",
			"parent" => "pagination-settings",
			"type" => "radio",
			"options" => array("show" => "Show \"Page x of y\"",
				"hide" => "Don't show \"Page x of y\""),
			"std" => "show"),

	array("name" => "Numbered Listing - Previous and Next links",
			"desc" => "If you have chosen to display a numbered listing of pages, you can choose to additionally show links for \"Older Entries\" and \"Newer Entries\".
				If you use WP-PageNavi then the selection here is ignored.",
			"id" => $shortname."_pagination_prev_next",
			"parent" => "pagination-settings",
			"type" => "radio",
			"options" => array("show" => "Show links for \"Older Entries\" and \"Newer Entries\"",
				"hide" => "Don't show links for \"Older Entries\" and \"Newer Entries\""),
			"std" => "show"),

	array("name" => "Numbered Listing - Show all pages in listing",
			"desc" => "If you have chosen to display a numbered listing of pages, you can choose to display all the pages in the list or replace it with dots as appropriate.
				In case of a large number of pages you might prefer to use dots. If you use WP-PageNavi then the selection here is ignored.",
			"id" => $shortname."_pagination_show_all",
			"parent" => "pagination-settings",
			"type" => "radio",
			"options" => array("all" => "Show all pages in the list",
				"dots" => "Replace pages in the middle with dots"),
			"std" => "dots"),

	array("name" => "Options for paged navigation of comments",
			"desc" => "Here you can decide if you want paged navigation for your comments: ",
			"id" => $shortname."_cpagination_type",
			"parent" => "pagination-settings",
			"type" => "radio",
			"options" => array("old-new" => "Simple navigation, showing links to a page with older comments and a page with newer comments",
				"numbered" => "A numbered listing of pages for the comments"),
			"std" => "old-new"),

	array("name" => "Numbered Listing of Comments - Page x of y",
			"desc" => "If you have chosen to display a numbered listing of pages for comments, you can choose to show prefix the page list that will highlight which page you are on.
				It will put in a text saying \"Page x of y\".",
			"id" => $shortname."_cpagination_index",
			"parent" => "pagination-settings",
			"type" => "radio",
			"options" => array("show" => "Show \"Page x of y\"",
				"hide" => "Don't show \"Page x of y\""),
			"std" => "show"),

	array("name" => "Numbered Listing of Comments - Previous and Next links",
			"desc" => "If you have chosen to display a numbered listing of pages for comments, you can choose to additionally show links for \"Older Comments\" and \"Newer Comments\"",
			"id" => $shortname."_cpagination_prev_next",
			"parent" => "pagination-settings",
			"type" => "radio",
			"options" => array("show" => "Show links for \"Older Comments\" and \"Newer Comments\"",
				"hide" => "Don't show links for \"Older Comments\" and \"Newer Comments\""),
			"std" => "show"),

	array("name" => "Numbered Listing of Comments - Show all comment pages in listing",
			"desc" => "If you have chosen to display a numbered listing of comment pages, you can choose to display all the pages in the list or replace it with dots as appropriate.
				In case of a large number of pages you might prefer to use dots.",
			"id" => $shortname."_cpagination_show_all",
			"parent" => "pagination-settings",
			"type" => "radio",
			"options" => array("all" => "Show all pages in the list",
				"dots" => "Replace pages in the middle with dots"),
			"std" => "dots"),

	array("name" => "User Profiles",
			"type" => "sub-section-3",
			"category" => "user-profiles",
			"parent" => "blog-features"
	),

	array("name" => "Select Additional Social Networks",
			"desc" => "You can add other contact methods for users on your blog. These will show up in the admin page under Users -&gt; Your Profile.
				This will take effect only if you are at WordPress verison 2.9 or later: ",
			"id" => $shortname."_uprof_networks",
			"parent" => "user-profiles",
			"type" => "multi-select",
			"options" => suf_get_formatted_options_array($shortname."_uprof_networks", $social_networks)),

	array("name" => "Show author information for individual posts and pages",
			"desc" => "You can add author information to each post. In subsequent options you can specify what you want to put in the author information section.",
			"id" => $shortname."_uprof_post_info_enabled",
			"parent" => "user-profiles",
			"type" => "radio",
			"options" => array("hide" => "Don't show author information", "bottom" => "Show information at the bottom of the content"),
			"std" => "hide"),

	array("name" => "Author information header",
			"desc" => "Specify the header for the author information section. Leave blank if you don't want a header",
			"id" => $shortname."_uprof_post_info_header",
			"parent" => "user-profiles",
			"type" => "text",
			"std" => "[suffusion-the-author]"),

	array("name" => "Author Gravatar",
			"desc" => "You can choose to show the Gravatar for the author in the information section",
			"id" => $shortname."_uprof_post_info_gravatar",
			"parent" => "user-profiles",
			"type" => "radio",
			"options" => array("hide" => "Don't show Gravatar", "show" => "Show Gravatar"),
			"std" => "show"),

	array("name" => "Gravatar Size",
			"desc" => "Set the size of the gravatar",
			"id" => $shortname."_uprof_post_info_gravatar_size",
			"parent" => "user-profiles",
			"type" => "radio",
			"options" => array("32" => "32px", "48" => "48px", "64" => "64px", "96" => "96px", "128" => "128px", ),
			"std" => "64"),

	array("name" => "Gravatar Alignment",
			"desc" => "Which side do you want your Gravatar?",
			"id" => $shortname."_uprof_post_info_gravatar_alignment",
			"parent" => "user-profiles",
			"type" => "radio",
			"options" => array("left" => "Left", "right" => "Right"),
			"std" => "left"),

	array("name" => "Author information content",
			"desc" => "Here you can put in any information you want about the author. You can use any of the author short codes:",
			"id" => $shortname."_uprof_post_info_content",
			"parent" => "user-profiles",
			"type" => "textarea",
			"std" => "[suffusion-the-author display='description']"),

	array("name" => "Analytics",
			"type" => "sub-section-3",
			"category" => "analytics",
			"parent" => "blog-features"
	),

	array("name" => "Enable Analytics?",
			"desc" => "If you have a Google Analytics acccount you can add your tracking code through this section. ".
				"Note that if you are using a separate plugin for analytics you can ignore this section (i.e., don't enable Analytics).",
			"id" => $shortname."_analytics_enabled",
			"parent" => "analytics",
			"type" => "radio",
			"note" => "Please set this option to \"Analytics enabled\" if you want to override the theme's settings for Analytics.",
			"options" => array("not-enabled" => "Analytics not enabled(default)",
							"enabled" => "Analytics enabled"),
			"std" => "not-enabled"),

	array("name" => "Custom Google Analytics Tracking Code",
			"desc" => "Enter your tracking code here for Google Analytics (with the <code>&lt;script&gt;</code> and <code>&lt;/script&gt;</code> tags). Note that you can skip this if you are using a plugin for analytics",
			"id" => $shortname."_custom_analytics_code",
			"parent" => "analytics",
			"type" => "textarea",
			"hint" => "Enter the tracking code here",
			"note" => "If you have any text here, it will be included with your pages (even if incorrect!!). Note that if your analytics are not enabled then this will be ignored.",
			"std" => ""),

	array("name" => "OpenID Setup",
			"type" => "sub-section-3",
			"category" => "openid-setup",
			"parent" => "blog-features"
	),

	array("name" => "Enable OpenID support?",
			"desc" => "If you have set up your blog as an <a href=\"http://openid.net/\">OpenID</a> server, you will need to populate the OpenID server and delegate here.".
				"This theme currently does not help set your blog up as an OpenID provider. It only supports your blog if you have OpenID enabled. If you want to set your blog as a server see <a href=\"http://intertwingly.net/blog/2007/01/03/OpenID-for-non-SuperUsers\">here</a>.",
			"id" => $shortname."_openid_enabled",
			"parent" => "openid-setup",
			"type" => "radio",
			"note" => "Please set this option to \"OpenID enabled\" if you want to override the theme's settings for OpenID.",
			"options" => array("not-enabled" => "OpenID not enabled(default)",
							"enabled" => "OpenID enabled"),
			"std" => "not-enabled"),

	array("name" => "OpenID Server",
			"desc" => "Set the location of your OpenID server. ".
				"If you have chosen \"OpenID not enabled\" above then this setting will be ignored.",
			"id" => $shortname."_openid_server",
			"parent" => "openid-setup",
			"type" => "text",
			"hint" => "Enter the full URL here (including http://)",
			"std" => ""),

	array("name" => "OpenID Delegate",
			"desc" => "Set the location of your OpenID delegate. ".
				"If you have chosen \"OpenID not enabled\" above then this setting will be ignored.",
			"id" => $shortname."_openid_delegate",
			"parent" => "openid-setup",
			"type" => "text",
			"hint" => "Enter the full URL here (including http://)",
			"std" => ""),

	array("name" => "Custom Includes",
			"type" => "sub-section-3",
			"category" => "custom-additions",
			"parent" => "blog-features"
	),

	array("name" => "Don't like the default styles? Add your own...",
			"desc" => "If you are really picky about how your blog should look and the bundled styles don't make you happy, feel free to add your own styles here.
				You can either add externally defined stylesheets or define the CSS here.
				These are called up at the end of all other stylesheet invocations (unless of course you have a plugin that adds something after this!), so what you define here will pretty much override everything else.",
			"parent" => "custom-additions",
			"category" => "custom-css",
			"type" => "sub-section-4",
			),

	array("name" => "Custom Styles",
			"desc" => "If you want to define any custom styles, include the CSS code here. These styles will override all other styles that you have defined / set.
				Don't include the <code>&lt;style&gt;</code> and <code>&lt;/style&gt;</code> tags.",
			"id" => $shortname."_custom_css_code",
			"parent" => "custom-additions",
			"grouping" => "custom-css",
			"type" => "textarea",
			"hint" => "Enter the CSS styles here",
			"note" => "If you have any text here, it will be included in the header of your pages (even if incorrect!!).",
			"std" => ""),

	array("name" => "First Additional Stylesheet link",
			"desc" => "If you want to define any additional stylesheets, include the entire link here for the first sheet. An example would be a plugin with a separate stylesheet.",
			"id" => $shortname."_custom_css_link_1",
			"parent" => "custom-additions",
			"grouping" => "custom-css",
			"type" => "text",
			"hint" => "Enter the stylesheet here, including http://",
			"std" => ""),

	array("name" => "Second Additional Stylesheet link",
			"desc" => "If you want to define any additional stylesheets, include the entire link here for the second sheet. An example would be a plugin with a separate stylesheet.",
			"id" => $shortname."_custom_css_link_2",
			"parent" => "custom-additions",
			"grouping" => "custom-css",
			"type" => "text",
			"hint" => "Enter the stylesheet here, including http://",
			"std" => ""),

	array("name" => "Third Additional Stylesheet link",
			"desc" => "If you want to define any additional stylesheets, include the entire link here for the third sheet. An example would be a plugin with a separate stylesheet.",
			"id" => $shortname."_custom_css_link_3",
			"parent" => "custom-additions",
			"grouping" => "custom-css",
			"type" => "text",
			"hint" => "Enter the stylesheet here, including http://",
			"std" => ""),

	array("name" => "Custom PHP",
		"desc" => "Suffusion offers a number of action hooks defined in the actions.php file, and some filter hooks defined in the file filters.php.
			You can extend this functionality by including your own PHP.",
		"parent" => "custom-additions",
		"category" => "custom-php",
		"type" => "sub-section-4",
		),

	array("name" => "Custom PHP file location",
		"desc" => "You can define your custom PHP code in a separate file and include a reference to that file here. Do note the following:
			<ul class='margin-20'>
				<li>This file must be put somewhere under your WordPress content directory, ".WP_CONTENT_DIR.".</li>
				<li>Include the path relative to the content directory, e.g. my-functions/custom-functions.php. Make sure you use the path separator \"/\", not \"\\\".</li>
				<li>If your path includes a sub-directory like \"my-functions\", make sure that the sub-directory exists in your content directory.</li>
				<li>Don't use the Unix folder paths \".\" and \"..\".</li>
				<li><b>Don't put any \"echo\" or \"print\" calls in your file outside a function call.</b> Otherwise you will get an error saying that you attempted to write the headers after they had already been sent.</li>
				<li><b>Make sure that your file has no syntax errors.</b> Otherwise you will see a white page.</li>
			</ul>",
		"id" => $shortname."_custom_php_file",
		"parent" => "custom-additions",
		"grouping" => "custom-php",
		"type" => "text",
		"hint" => "Enter the path to the file",
		"std" => ""),

	array("name" => "Got JavaScript?",
		"desc" => "Here you can add custom JavaScript. This is a feature that will normally not be used, since you will rely on plugins to automatically add JavaScript.",
		"parent" => "custom-additions",
		"category" => "custom-js",
		"type" => "sub-section-4",
		),

    array("name" => "Use CDN version of JQuery?",
		"desc" => "Instead of WP's JS files, you can use Google CDN's JS files for JQuery. This might speed up load times for your users.",
		"id" => $shortname."_cdn_jquery_enabled",
		"parent" => "custom-additions",
        "grouping" => "custom-js",
		"type" => "radio",
        "options" => array("cdn" => "Use CDN",
                            "wp" => "Use WordPress"),
            "std" => "wp"),

	array("name" => "First External JavaScript file",
			"desc" => "If you want to define any additional JavaScript files, include the entire link here for the first file.
				Note that you have to ensure the JavaScript file's variables and definitions don't conflict with other JS variables and definitions. ",
			"id" => $shortname."_custom_js_file_1",
			"parent" => "custom-additions",
			"grouping" => "custom-js",
			"type" => "text",
			"hint" => "Enter the JavaScript file path here, including http://",
			"std" => ""),

	array("name" => "Second External JavaScript file",
			"desc" => "If you want to define any additional JavaScript files, include the entire link here for the second file.
				Note that you have to ensure the JavaScript file's variables and definitions don't conflict with other JS variables and definitions. ",
			"id" => $shortname."_custom_js_file_2",
			"parent" => "custom-additions",
			"grouping" => "custom-js",
			"type" => "text",
			"hint" => "Enter the JavaScript file path here, including http://",
			"std" => ""),

	array("name" => "Third External JavaScript file",
			"desc" => "If you want to define any additional JavaScript files, include the entire link here for the third file.
				Note that you have to ensure the JavaScript file's variables and definitions don't conflict with other JS variables and definitions. ",
			"id" => $shortname."_custom_js_file_3",
			"parent" => "custom-additions",
			"grouping" => "custom-js",
			"type" => "text",
			"hint" => "Enter the JavaScript file path here, including http://",
			"std" => ""),

	array("name" => "Custom Header JavaScript",
			"desc" => "If you want to add some custom JavaScript to your header you can do so here.
				This could include affiliate code or anything else that you want to add.
				Do not include the <code>&lt;script&gt;</code> and <code>&lt;/script&gt;</code> tags.",
			"id" => $shortname."_custom_header_js",
			"parent" => "custom-additions",
			"grouping" => "custom-js",
			"type" => "textarea",
			"hint" => "Enter the JavaScript here",
			"note" => "If you have any text here, it will be included in the header of your pages (even if incorrect!!).",
			"std" => ""),

	array("name" => "Custom Footer JavaScript",
			"desc" => "If you want to add some custom JavaScript to your footer you can do so here.
				This could include affiliate code or anything else that you want to add.
				Do not include the <code>&lt;script&gt;</code> and <code>&lt;/script&gt;</code> tags.",
			"id" => $shortname."_custom_footer_js",
			"grouping" => "custom-js",
			"parent" => "custom-additions",
			"type" => "textarea",
			"hint" => "Enter the JavaScript here",
			"note" => "If you have any text here, it will be included in the footer of your pages (even if incorrect!!).",
			"std" => ""),

	array("name" => "Additional Auto-discovery RSS / Atom feeds",
			"desc" => "You might want to set up additional RSS / Atom feeds for your blog, like a \"Post of the Day\" etc. You can add those feeds here.
				Note that this section is for <b>auto-discovery</b> of feeds only. It will make your feed show up in the address bar of browsers like FireFox.",
			"parent" => "custom-additions",
			"category" => "custom-feed",
			"type" => "sub-section-4",
			),

	array("name" => "Disable default feed?",
			"desc" => "By default Suffusion creates the default RSS feed for the theme. If you would prefer using FeedBurner or another such feed, you might want to disable the default feed:",
			"id" => $shortname."_custom_default_rss_enabled",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "radio",
			"options" => array("not-enabled" => "Default feed not enabled",
							"enabled" => "Default feed enabled"),
			"std" => "enabled"),

	array("name" => "Address of First Additional RSS Feed",
			"desc" => "If you want to define any additional RSS Feeds, include the entire link here for the first feed. You could set up a FeedBurner feed here",
			"id" => $shortname."_custom_rss_feed_1",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed URL here, including http://",
			"std" => ""),

	array("name" => "Title of First Additional RSS Feed",
			"desc" => "What should the first feed be called? E.g. Post of the day. This will be ignored if the preceding field is blank.",
			"id" => $shortname."_custom_rss_title_1",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed title here",
			"std" => ""),

	array("name" => "Address of Second Additional RSS Feed",
			"desc" => "If you want to define any additional RSS Feeds, include the entire link here for the second feed.",
			"id" => $shortname."_custom_rss_feed_2",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed URL here, including http://",
			"std" => ""),

	array("name" => "Title of Second Additional RSS Feed",
			"desc" => "What should the second feed be called? E.g. Post of the day. This will be ignored if the preceding field is blank.",
			"id" => $shortname."_custom_rss_title_2",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed title here",
			"std" => ""),

	array("name" => "Address of Third Additional RSS Feed",
			"desc" => "If you want to define any additional RSS Feeds, include the entire link here for the third feed.",
			"id" => $shortname."_custom_rss_feed_3",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed URL here, including http://",
			"std" => ""),

	array("name" => "Title of Third Additional RSS Feed",
			"desc" => "What should the third feed be called? E.g. Post of the day. This will be ignored if the preceding field is blank.",
			"id" => $shortname."_custom_rss_title_3",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed title here",
			"std" => ""),

	array("name" => "Address of First Additional Atom Feed",
			"desc" => "If you want to define any additional Atom Feeds, include the entire link here for the first feed.",
			"id" => $shortname."_custom_atom_feed_1",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed URL here, including http://",
			"std" => ""),

	array("name" => "Title of First Additional Atom Feed",
			"desc" => "What should the first feed be called? E.g. Post of the day. This will be ignored if the preceding field is blank.",
			"id" => $shortname."_custom_atom_title_1",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed title here",
			"std" => ""),

	array("name" => "Address of Second Additional Atom Feed",
			"desc" => "If you want to define any additional Atom Feeds, include the entire link here for the second feed.",
			"id" => $shortname."_custom_atom_feed_2",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed URL here, including http://",
			"std" => ""),

	array("name" => "Title of Second Additional Atom Feed",
			"desc" => "What should the second feed be called? E.g. Post of the day. This will be ignored if the preceding field is blank.",
			"id" => $shortname."_custom_atom_title_2",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed title here",
			"std" => ""),

	array("name" => "Address of Third Additional Atom Feed",
			"desc" => "If you want to define any additional Atom Feeds, include the entire link here for the third feed.",
			"id" => $shortname."_custom_atom_feed_3",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed URL here, including http://",
			"std" => ""),

	array("name" => "Title of Third Additional Atom Feed",
			"desc" => "What should the third feed be called? E.g. Post of the day. This will be ignored if the preceding field is blank.",
			"id" => $shortname."_custom_atom_title_3",
			"parent" => "custom-additions",
			"grouping" => "custom-feed",
			"type" => "text",
			"hint" => "Enter the feed title here",
			"std" => ""),

	array("name" => "Templates",
			"type" => "sub-section-2",
			"category" => "templates",
			"parent" => "root"
	),

	array("name" => "Magazine",
			"type" => "sub-section-3",
			"category" => "magazine-template",
			"parent" => "templates"
	),

	array("name" => "The \"Magazine\" template",
			"desc" => "The magazine template can be used as the landing page for magazine-style blogs. It displays featured content, headlines, excerpts and categories.
				Suffusion natively supports the <a href='http://wordpress.org/extend/plugins/category-icons/'>\"Category Icons\" plugin by Brahim Machkouri</a>.
				So if you have the plugin installed, the icon for the category will be automatically displayed for the categories in the magazine view. ",
			"parent" => "magazine-template",
			"type" => "blurb"
		),

	array("name" => "Enable Featured Posts on magazine template",
			"desc" => "You can enable the Featured Posts slider on your magazine template: ",
			"id" => $shortname."_mag_featured_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("enabled" => "Enabled", "disabled" => "Disabled"),
			"std" => "enabled"),

	array("name" => "Show main page content for the magazine template",
			"desc" => "You can show the content of the page on the magazine template. You can use this as an introduction to the page. By default it is hidden: ",
			"id" => $shortname."_mag_content_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Show", "hide" => "Hide"),
			"std" => "hide"),

	array("name" => "Show headlines for the magazine template",
			"desc" => "You can show a section for headlines on the magazine template. Headlines can be displayed for all posts in a selected category by selecting from the list below.
				Additionally you can set individual posts up as headlines from the addtional options below each post: ",
			"id" => $shortname."_mag_headlines_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Show headlines", "hide" => "Hide headlines"),
			"std" => "show"),

	array("name" => "Magazine Template - Main Title for headlines section",
			"desc" => "You can set the main title of the headline section: ",
			"id" => $shortname."_mag_headline_title",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the title here (leave blank if you don't want a title).",
			"std" => 'Headlines'),

	array("name" => "Magazine Template - Main title alignment for headlines section",
			"desc" => "Where do you want your main title for the headlines section positioned? ",
			"id" => $shortname."_mag_headline_main_title_alignment",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("left" => "Left", "center" => "Center", "right" => "Right"),
			"std" => "left"),

	array("name" => "Magazine template - Height of headline section",
			"desc" => "You can set the height of the headline section here. Choose a larger number if you have more headlines: ",
			"id" => $shortname."_mag_headlines_height",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "250"),

	array("name" => "Magazine template - Width of headline image box",
			"desc" => "You can set the width of the headline image section here. The image will be put inside a container of this width: ",
			"id" => $shortname."_mag_headline_image_container_width",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "250"),

	array("name" => "Magazine template - Headline image scaling",
			"desc" => "Your can set a custom size for your headline images, or let the size be the same as that of the excerpt images: ",
			"id" => $shortname."_mag_headline_image_size",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("excerpt" => "Same size as excerpt images", "custom" => "Custom size (defined below)"),
			"std" => "excerpt"),

	array("name" => "Magazine template - Custom Height of headline image",
			"desc" => "If you have picked a custom size for the headline images above, you can set the height here: ",
			"id" => $shortname."_mag_headline_image_custom_height",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "200"),

	array("name" => "Magazine template - Custom Width of headline image",
			"desc" => "If you have picked a custom size for the headline images above, you can set the width here: ",
			"id" => $shortname."_mag_headline_image_custom_width",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "200"),

	array("name" => "Magazine template - Select categories for headlines",
			"desc" => "You can pick categories to include in the headlines section. All posts in the selected categories will be shown.
				By default no category is selected: ",
			"id" => $shortname."_mag_headline_categories",
			"parent" => "magazine-template",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_category_array($shortname."_mag_headline_categories")),

	array("name" => "Show an excerpts section for the magazine template",
			"desc" => "You can show a section with specific excerpts: ",
			"id" => $shortname."_mag_excerpts_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Show excerpts", "hide" => "Hide excerpts"),
			"std" => "show"),

	array("name" => "Magazine Template - Main Title for excerpts section",
			"desc" => "You can set the main title of the excerpts section: ",
			"id" => $shortname."_mag_excerpts_title",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the title here (leave blank if you don't want a title).",
			"std" => 'Other Big Stories'),

	array("name" => "Magazine Template - Main title alignment for excerpts section",
			"desc" => "Where do you want your main title for the excerpts section positioned? ",
			"id" => $shortname."_mag_excerpts_main_title_alignment",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("left" => "Left", "center" => "Center", "right" => "Right"),
			"std" => "left"),

	array("name" => "Magazine Template - Maximum number of excerpts",
			"desc" => "You can set the maximum number of excerpts to show: ",
			"id" => $shortname."_mag_total_excerpts",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter a positive numeric value only",
			"std" => get_option('posts_per_page')),

	array("name" => "Magazine Template - Maximum Number of excerpts per row",
			"desc" => "You can define how many excerpts you want to show per row: ",
			"id" => $shortname."_mag_excerpts_per_row",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)", "5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)",
				"8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
			"std" => "3"),

	array("name" => "Magazine template - Select categories for excerpts",
			"desc" => "You can pick categories to include in the headlines section. All posts in the selected categories will be shown.
				By default no category is selected: ",
			"id" => $shortname."_mag_excerpt_categories",
			"parent" => "magazine-template",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_category_array($shortname."_mag_excerpt_categories")),

	array("name" => "Magazine Template - Thumbnail container for excerpts",
			"desc" => "You can show thumbnails for excerpts in the magazine template: ",
			"id" => $shortname."_mag_excerpts_images_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Always show Thumbnail container", "hide" => "Always hide Thumbnail container",
				"hide-empty" => "Hide Thumbnail container if there is no thumbnail"),
			"std" => "show"),

	array("name" => "Magazine Template - Thumbnail container height for excerpts",
			"desc" => "For the purposes of visual consistency you can set the height of the box in which the thumbnail will be placed. Your thumbnail will be \"cropped\" to this height: ",
			"id" => $shortname."_mag_excerpts_image_box_height",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "100"),

	array("name" => "Magazine template - Excerpt thumbnail image scaling",
			"desc" => "You can set a custom size for your excerpt thumbnail images, or let the size be the same as that of the regular excerpt images: ",
			"id" => $shortname."_mag_excerpt_image_size",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("excerpt" => "Same size as excerpt images", "custom" => "Custom size (defined below)"),
			"std" => "excerpt"),

	array("name" => "Magazine template - Custom height of thumbnail image in excerpts",
			"desc" => "If you have picked a custom size for the excerpt thumbnail images above, you can set the height here: ",
			"id" => $shortname."_mag_excerpt_image_custom_height",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "200"),

	array("name" => "Magazine template - Custom width of thumbnail image in excerpts",
			"desc" => "If you have picked a custom size for the excerpt thumbnail images above, you can set the width here: ",
			"id" => $shortname."_mag_excerpt_image_custom_width",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "200"),

	array("name" => "Magazine template - Alignment of post title in Excerpts",
			"desc" => "You can set the alignment for the post title in the excerpts: ",
			"id" => $shortname."_mag_excerpt_title_alignment",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("left" => "Left", "center" => "Center", "right" => "Right"),
			"std" => "left"),

	array("name" => "Magazine Template - Text for \"Full story\" in excerpts",
			"desc" => "You can set the text to show for the \"Full story\" link in excerpts: ",
			"id" => $shortname."_mag_excerpt_full_story_text",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the text here (leave blank for no link)",
			"std" => 'Full Story'),

	array("name" => "Show a categories section for the magazine template",
			"desc" => "You can show a section with lists of posts from specific categories: ",
			"id" => $shortname."_mag_categories_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Show categories", "hide" => "Hide categories"),
			"std" => "show"),

	array("name" => "Magazine Template - Main Title for categories section",
			"desc" => "You can set the main title for the categories section here: ",
			"id" => $shortname."_mag_catblocks_title",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the title here (leave blank if you don't want a title).",
			"std" => 'Other Stories'),

	array("name" => "Magazine Template - Main title alignment for categories section",
			"desc" => "Where do you want your main title for the categories section positioned? ",
			"id" => $shortname."_mag_catblocks_main_title_alignment",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("left" => "Left", "center" => "Center", "right" => "Right"),
			"std" => "left"),

	array("name" => "Magazine template - Select category blocks to show",
			"desc" => "You can also show specific catagory blocks on the magazine template. A category block can include a category icon, the category description and some post titles.
				By default no category is selected: ",
			"id" => $shortname."_mag_catblock_categories",
			"parent" => "magazine-template",
			"export" => "ne",
			"type" => "multi-select",
			"options" => suf_get_formatted_category_array($shortname."_mag_catblock_categories")),

	array("name" => "Magazine Template - Maximum Number of category blocks per row",
			"desc" => "You can define how many category blocks you want to show per row: ",
			"id" => $shortname."_mag_catblocks_per_row",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)", "5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)",
				"8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
			"std" => "3"),

	array("name" => "Magazine Template - Category title alignment for each Category Block",
			"desc" => "Where do you want your category title positioned for each category block? ",
			"id" => $shortname."_mag_catblocks_title_alignment",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("left" => "Left", "center" => "Center", "right" => "Right"),
			"std" => "left"),

	array("name" => "Magazine Template - Images for category blocks",
			"desc" => "If  you have the <a href='http://wordpress.org/extend/plugins/category-icons/'>\"Category Icons\" plugin by Brahim Machkouri</a> you can include an image at the top of each category block: ",
			"id" => $shortname."_mag_catblocks_images_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Always show Category Icons container", "hide" => "Always hide Category Icons container",
				"hide-empty" => "Hide Category Icons container if there is no icon"),
			"std" => "hide"),

	array("name" => "Magazine Template - Image container height for category blocks",
			"desc" => "For the purposes of visual consistency you can set the height of the box in which the category image will be placed. Your icon will be \"cropped\" to this height: ",
			"id" => $shortname."_mag_catblocks_image_box_height",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored.",
			"std" => "100"),

	array("name" => "Magazine Template - Description for category blocks",
			"desc" => "You can show your category's description in each category block: ",
			"id" => $shortname."_mag_catblocks_desc_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Show Description", "hide" => "Hide Description"),
			"std" => "hide"),

	array("name" => "Magazine Template - Latest posts in category blocks",
			"desc" => "You can show your category's latest posts in each category block: ",
			"id" => $shortname."_mag_catblocks_posts_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Show Posts", "hide" => "Hide Posts"),
			"std" => "show"),

	array("name" => "Magazine Template - Maximum Number of posts in category blocks",
			"desc" => "You can the number of posts you want listed in each category block. By default this is set to 5: ",
			"id" => $shortname."_mag_catblocks_num_posts",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the number here. Enter -1 to show all posts.",
			"std" => '5'),

	array("name" => "Magazine Template - Text for \"See all posts\" in category blocks",
			"desc" => "You can set the text to show for the \"See all posts\" link in category blocks: ",
			"id" => $shortname."_mag_catblocks_see_all_text",
			"parent" => "magazine-template",
			"type" => "text",
			"hint" => "Enter the text here (leave blank for no link)",
			"std" => 'See all posts'),

	array("name" => "Magazine Template - Post display style in category blocks",
			"desc" => "You can decide if you want to show your posts in the category blocks in a magazine-style (boxed) or in a sidebar-style (underlined): ",
			"id" => $shortname."_mag_catblocks_post_style",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("magazine" => "Magazine Style (posts highlight with a box around them when you hover)", "sidebar" => "Sidebar Style (posts are underlined when you hover over them)"),
			"std" => 'magazine'),
/*
	array("name" => "Magazine Template - Subscription link in Category Blocks",
			"desc" => "You can show an RSS link for each category block: ",
			"id" => $shortname."_mag_catblocks_rss_enabled",
			"parent" => "magazine-template",
			"type" => "radio",
			"options" => array("show" => "Show subscription link", "hide" => "Hide subscription link"),
			"std" => "show"),
 */

	array("name" => "Page of Posts",
		"type" => "sub-section-3",
		"category" => "pop-template",
		"parent" => "templates"
	),

	array("name" => "The \"Page of Posts\" template",
		"desc" => "This template can be used to create a page of posts. This will follow the default sidebar layout for the theme.",
		"category" => "pop-settings",
		"parent" => "pop-template",
		"type" => "sub-section-4"
	),

	array("name" => "Layout Settings for the \"Page of Posts\" template",
		"desc" => "By default for all posts on this template, the complete contents are displayed.",
		"id" => $shortname."_pop_excerpt",
		"parent" => "pop-template",
		"grouping" => "pop-settings",
		"type" => "radio",
		"options" => array("content" => "Display full content", "excerpt" => "Display excerpt", "list" => "Display list", "tiles" => 'Display tiles'),
		"std" => "content"),

	array("name" => "Number of Full content posts on \"Page of Posts\" template",
		"desc" => "In the Excerpt, List and Tile display you can choose to show the first few posts with full content. Set the number of posts for which you want the full content displayed (ignored if you select full content above): ",
		"id" => $shortname."_pop_fc_number",
		"parent" => "pop-template",
		"grouping" => "pop-settings",
		"type" => "select",
		"options" => array("0" => "0 (Zero)", "1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)",
			"5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)", "8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "0"),

	array("name" => "Single Category",
			"type" => "sub-section-3",
			"category" => "category-template",
			"parent" => "templates"
	),

	array("name" => "The \"Category\" template",
			"desc" => "The category template is applied whenever you open a category. It displays all posts associated with a category.
				Suffusion natively supports the <a href='http://wordpress.org/extend/plugins/category-icons/'>\"Category Icons\" plugin by Brahim Machkouri</a>.
				So if you have the plugin installed, the icon for the category will be automatically displayed. ",
			"parent" => "category-template",
			"type" => "blurb"
		),

	array("name" => "Enable Category Introduction?",
			"desc" => "By default the name of the category and its description are not shown on a category page. You can change it: ",
			"id" => $shortname."_cat_info_enabled",
			"parent" => "category-template",
			"type" => "radio",
			"options" => array("enabled" => "Category Information enabled",
							"not-enabled" => "Category Information not enabled (default)"),
			"std" => "not-enabled"),

	array("name" => "All Categories",
			"type" => "sub-section-3",
			"category" => "categories-template",
			"parent" => "templates"
	),

	array("name" => "The \"All Categories\" template",
			"desc" => "The \"All Categories\" template can be used if you want to list out all your categories on a single page.
				You can additionally decide to show the categories hierarchically, or show the RSS feed for each category or the number of posts in each category.",
			"parent" => "categories-template",
			"type" => "blurb"
		),

	array("name" => "List categories hierarchically?",
			"desc" => "You can decide if you want to list your categories in a hierarchical manner: ",
			"id" => $shortname."_temp_cats_hierarchical",
			"parent" => "categories-template",
			"type" => "radio",
			"options" => array("hierarchical" => "Categories listed hierarchically",
							"flat" => "Categories listed flat"),
			"std" => "hierarchical"),
/*
	array("name" => "Category Listing Style",
			"desc" => "Select the listing style for your categories: ",
			"id" => $shortname."_temp_cats_list_style",
			"parent" => "categories-template",
			"type" => "radio",
			"options" => array("ordered" => "Ordered listing (numbered)",
							"unordered" => "Unordered listing (bullets)"),
			"std" => "unordered"),
 */
	array("name" => "Show RSS feeds for each category?",
			"desc" => "You can display a link to an RSS feed for each category: ",
			"id" => $shortname."_temp_cats_rss",
			"parent" => "categories-template",
			"type" => "radio",
			"options" => array("show" => "Show RSS feed",
							"hide" => "Hide RSS feed"),
			"std" => "show"),

	array("name" => "Show post count for each category?",
			"desc" => "You can display the number of posts in each category. Categories with 0 posts are excluded: ",
			"id" => $shortname."_temp_cats_post_count",
			"parent" => "categories-template",
			"type" => "radio",
			"options" => array("show" => "Show Post Count",
							"hide" => "Hide Post Count"),
			"std" => "hide"),

	array("name" => "Single Tag",
			"type" => "sub-section-3",
			"category" => "tag-template",
			"parent" => "templates"
	),

	array("name" => "The \"Tag\" template",
			"desc" => "The tag template is applied whenever you open a tag. It displays all posts with a particular tag. ",
			"parent" => "tag-template",
			"type" => "blurb"
		),

	array("name" => "Show Tag Description",
			"desc" => "By default the name of the Tag and its description are not shown on a tag page. You can change it: ",
			"id" => $shortname."_tag_info_enabled",
			"parent" => "tag-template",
			"type" => "radio",
			"options" => array("enabled" => "Tag Description enabled",
							"not-enabled" => "Tag Description not enabled (default)"),
			"std" => "not-enabled"),

	array("name" => "Single Author",
			"type" => "sub-section-3",
			"category" => "author-template",
			"parent" => "templates"
	),

	array("name" => "The single \"Author\" template",
			"desc" => "The author template is applied whenever you open an author page. It displays all posts associated with a category.",
			"parent" => "author-template",
			"type" => "blurb"
		),

	array("name" => "Enable Author Introduction?",
			"desc" => "By default the name of the author and a the description are shown on an author page. You can change it: ",
			"id" => $shortname."_author_info_enabled",
			"parent" => "author-template",
			"type" => "radio",
			"options" => array("enabled" => "Author Information enabled (default)",
							"not-enabled" => "Author Information not enabled"),
			"std" => "enabled"),

	array("name" => "No Sidebars",
			"type" => "sub-section-3",
			"category" => "no-sidebars",
			"parent" => "templates"
	),

	array("name" => "The \"No Sidebars\" template",
			"desc" => "You can use the \"No Sidebars\" template if you have a page where you don't want sidebars to show up, but the rest of your blog has sidebars enabled.
				To set up pages with this template, select the \"No Sidebars\" template while creating or updating a page.",
			"parent" => "no-sidebars",
			"type" => "blurb"
		),

	array("name" => "Enable Widget Area Below Header?",
			"desc" => "By default the \"Widget Area Below Header\" is enabled in the \"No Sidebars\" template. You can change it: ",
			"id" => $shortname."_ns_wabh_enabled",
			"parent" => "no-sidebars",
			"type" => "radio",
			"options" => array("enabled" => "Widget Area below Header enabled (default)",
							"not-enabled" => "Widget Area below Header not enabled"),
			"std" => "enabled"),

	array("name" => "Enable Widget Area Above Footer?",
			"desc" => "By default the \"Widget Area Above Footer\" is enabled in the \"No Sidebars\" template. You can change it: ",
			"id" => $shortname."_ns_waaf_enabled",
			"parent" => "no-sidebars",
			"type" => "radio",
			"options" => array("enabled" => "Widget Area above Footer enabled (default)",
							"not-enabled" => "Widget Area above Footer not enabled"),
			"std" => "enabled"),

	array("name" => "Single Left Sidebar",
			"type" => "sub-section-3",
			"category" => "1l-sidebar",
			"parent" => "templates"
	),

	array("name" => "The \"Single Left Sidebar\" template",
			"desc" => "You can use this template if you have a page where you want a single sidebar to show up on the left.
				To set up pages with this template, select the \"Single Left Sidebar\" template while creating or updating a page.",
			"parent" => "1l-sidebar",
			"type" => "blurb"
		),

	array("name" => "Overall Page Width",
			"desc" => "Suffusion comes with 3 preset page width options: 800px, 1000px and 1200px. You can also define a custom width if you please, or allow the width of the page to be determined by the width of its main components like the sidebars and the main content column.
				Due to difficulties with fitting things on the page, the minimum size allowed is 600px. If you enter something less than 600, it is considered to be 600.",
			"id" => $shortname."_1l_wrapper_width_preset",
			"parent" => "1l-sidebar",
			"type" => "radio",
			"options" => array("800" => "800px", "1000" => "1000px (Default)", "1200" => "1200px",
							"custom" => "Custom width (defined below)", "custom-components" => "Custom width, but constructed from individual components (defined below)"),
			"std" => "1000"),

	array("name" => "Custom value for page width",
			"desc" => "If you have selected \"Custom width\" above, you can set the width here. Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 600 will be treated as 600. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width.
				Also note that if you are setting a width over here with the \"Custom width\" selection in place, the widths of the individual components like the main column, the sidebars etc. are auto-calculated",
			"id" => $shortname."_1l_wrapper_width",
			"parent" => "1l-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 1000",
			"std" => "1000"),

	array("name" => "Custom component width - Custom value for main column width",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the main column.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 380 will be treated as 380. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width. ",
			"id" => $shortname."_1l_main_col_width",
			"parent" => "1l-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 725",
			"std" => "725"),

	array("name" => "Custom component width - Custom value for width of sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the first sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_1l_sb_1_width",
			"parent" => "1l-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Single Right Sidebar",
			"type" => "sub-section-3",
			"category" => "1r-sidebar",
			"parent" => "templates"
	),

	array("name" => "The \"Single Right Sidebar\" template",
			"desc" => "You can use this template if you have a page where you want a single sidebar to show up on the right.
				To set up pages with this template, select the \"Single Right Sidebar\" template while creating or updating a page.",
			"parent" => "1r-sidebar",
			"type" => "blurb"
		),

	array("name" => "Overall Page Width",
			"desc" => "Suffusion comes with 3 preset page width options: 800px, 1000px and 1200px. You can also define a custom width if you please, or allow the width of the page to be determined by the width of its main components like the sidebars and the main content column.
				Due to difficulties with fitting things on the page, the minimum size allowed is 600px. If you enter something less than 600, it is considered to be 600.",
			"id" => $shortname."_1r_wrapper_width_preset",
			"parent" => "1r-sidebar",
			"type" => "radio",
			"options" => array("800" => "800px", "1000" => "1000px (Default)", "1200" => "1200px",
							"custom" => "Custom width (defined below)", "custom-components" => "Custom width, but constructed from individual components (defined below)"),
			"std" => "1000"),

	array("name" => "Custom value for page width",
			"desc" => "If you have selected \"Custom width\" above, you can set the width here. Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 600 will be treated as 600. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width.
				Also note that if you are setting a width over here with the \"Custom width\" selection in place, the widths of the individual components like the main column, the sidebars etc. are auto-calculated",
			"id" => $shortname."_1r_wrapper_width",
			"parent" => "1r-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 1000",
			"std" => "1000"),

	array("name" => "Custom component width - Custom value for main column width",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the main column.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 380 will be treated as 380. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width. ",
			"id" => $shortname."_1r_main_col_width",
			"parent" => "1r-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 725",
			"std" => "725"),

	array("name" => "Custom component width - Custom value for width of sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the first sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_1r_sb_1_width",
			"parent" => "1r-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Single Left, Single Right Sidebar",
			"type" => "sub-section-3",
			"category" => "1l1r-sidebar",
			"parent" => "templates"
	),

	array("name" => "The \"Single Left and Single Right Sidebar\" template",
			"desc" => "You can use this template if you have a page where you want a single sidebar to show up on the left and right sides.
				To set up pages with this template, select the \"Single Left and Single Right Sidebar\" template while creating or updating a page.",
			"parent" => "1l1r-sidebar",
			"type" => "blurb"
		),

	array("name" => "Overall Page Width",
			"desc" => "Suffusion comes with 3 preset page width options: 800px, 1000px and 1200px. You can also define a custom width if you please, or allow the width of the page to be determined by the width of its main components like the sidebars and the main content column.
				Due to difficulties with fitting things on the page, the minimum size allowed is 600px. If you enter something less than 600, it is considered to be 600.",
			"id" => $shortname."_1l1r_wrapper_width_preset",
			"parent" => "1l1r-sidebar",
			"type" => "radio",
			"options" => array("800" => "800px", "1000" => "1000px (Default)", "1200" => "1200px",
							"custom" => "Custom width (defined below)", "custom-components" => "Custom width, but constructed from individual components (defined below)"),
			"std" => "1000"),

	array("name" => "Custom value for page width",
			"desc" => "If you have selected \"Custom width\" above, you can set the width here. Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 600 will be treated as 600. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width.
				Also note that if you are setting a width over here with the \"Custom width\" selection in place, the widths of the individual components like the main column, the sidebars etc. are auto-calculated",
			"id" => $shortname."_1l1r_wrapper_width",
			"parent" => "1l1r-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 1000",
			"std" => "1000"),

	array("name" => "Custom component width - Custom value for main column width",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the main column.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 380 will be treated as 380. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width. ",
			"id" => $shortname."_1l1r_main_col_width",
			"parent" => "1l1r-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 725",
			"std" => "725"),

	array("name" => "Custom component width - Custom value for width of left sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the first sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_1l1r_sb_1_width",
			"parent" => "1l1r-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Custom component width - Custom value for width of right sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the second sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_1l1r_sb_2_width",
			"parent" => "1l1r-sidebar",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Double Left Sidebars",
			"type" => "sub-section-3",
			"category" => "2l-sidebars",
			"parent" => "templates"
	),

	array("name" => "The \"Double Left Sidebars\" template",
			"desc" => "You can use this template if you have a page where you want two sidebars to show up on the left.
				To set up pages with this template, select the \"Double Left Sidebars\" template while creating or updating a page.",
			"parent" => "2l-sidebars",
			"type" => "blurb"
		),

	array("name" => "Overall Page Width",
			"desc" => "Suffusion comes with 3 preset page width options: 800px, 1000px and 1200px. You can also define a custom width if you please, or allow the width of the page to be determined by the width of its main components like the sidebars and the main content column.
				Due to difficulties with fitting things on the page, the minimum size allowed is 600px. If you enter something less than 600, it is considered to be 600.",
			"id" => $shortname."_2l_wrapper_width_preset",
			"parent" => "2l-sidebars",
			"type" => "radio",
			"options" => array("800" => "800px", "1000" => "1000px (Default)", "1200" => "1200px",
							"custom" => "Custom width (defined below)", "custom-components" => "Custom width, but constructed from individual components (defined below)"),
			"std" => "1000"),

	array("name" => "Custom value for page width",
			"desc" => "If you have selected \"Custom width\" above, you can set the width here. Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 600 will be treated as 600. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width.
				Also note that if you are setting a width over here with the \"Custom width\" selection in place, the widths of the individual components like the main column, the sidebars etc. are auto-calculated",
			"id" => $shortname."_2l_wrapper_width",
			"parent" => "2l-sidebars",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 1000",
			"std" => "1000"),

	array("name" => "Custom component width - Custom value for main column width",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the main column.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 380 will be treated as 380. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width. ",
			"id" => $shortname."_2l_main_col_width",
			"parent" => "2l-sidebars",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 725",
			"std" => "725"),

	array("name" => "Custom component width - Custom value for width of first sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the first sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_2l_sb_1_width",
			"parent" => "2l-sidebars",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Custom component width - Custom value for width of second sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the second sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_2l_sb_2_width",
			"parent" => "2l-sidebars",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Double Right Sidebars",
			"type" => "sub-section-3",
			"category" => "2r-sidebars",
			"parent" => "templates"
	),

	array("name" => "The \"Double Right Sidebars\" template",
			"desc" => "You can use this template if you have a page where you want two sidebars to show up on the right.
				To set up pages with this template, select the \"Double Right Sidebars\" template while creating or updating a page.",
			"parent" => "2r-sidebars",
			"type" => "blurb"
		),

	array("name" => "Overall Page Width",
			"desc" => "Suffusion comes with 3 preset page width options: 800px, 1000px and 1200px. You can also define a custom width if you please, or allow the width of the page to be determined by the width of its main components like the sidebars and the main content column.
				Due to difficulties with fitting things on the page, the minimum size allowed is 600px. If you enter something less than 600, it is considered to be 600.",
			"id" => $shortname."_2r_wrapper_width_preset",
			"parent" => "2r-sidebars",
			"type" => "radio",
			"options" => array("800" => "800px", "1000" => "1000px (Default)", "1200" => "1200px",
							"custom" => "Custom width (defined below)", "custom-components" => "Custom width, but constructed from individual components (defined below)"),
			"std" => "1000"),

	array("name" => "Custom value for page width",
			"desc" => "If you have selected \"Custom width\" above, you can set the width here. Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 600 will be treated as 600. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width.
				Also note that if you are setting a width over here with the \"Custom width\" selection in place, the widths of the individual components like the main column, the sidebars etc. are auto-calculated",
			"id" => $shortname."_2r_wrapper_width",
			"parent" => "2r-sidebars",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 1000",
			"std" => "1000"),

	array("name" => "Custom component width - Custom value for main column width",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the main column.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 380 will be treated as 380. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"80%\" as the width. ",
			"id" => $shortname."_2r_main_col_width",
			"parent" => "2r-sidebars",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 725",
			"std" => "725"),

	array("name" => "Custom component width - Custom value for width of first sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the first sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_2r_sb_1_width",
			"parent" => "2r-sidebars",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Custom component width - Custom value for width of second sidebar",
			"desc" => "If you have selected \"Custom width, but constructed from individual components\" above, you can set the width here for the second sidebar.
				Please enter the width in pixels. <b>Do not enter \"px\".</b>
				Anything below 95 will be treated as 95. Note that this is a fixed width theme, not a fluid theme. What this means is that you cannot specify things like \"10%\" as the width. ",
			"id" => $shortname."_2r_sb_2_width",
			"parent" => "2r-sidebars",
			"type" => "text",
			"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 260",
			"std" => "260"),

	array("name" => "Now Reading",
		"type" => "sub-section-3",
		"category" => "nr-template",
		"parent" => "templates"
	),

	array("name" => "The \"Now Reading\" plugin templates",
		"desc" => "If you have a site for book reviews the <a href='http://robm.me.uk/projects/plugins/wordpress/now-reading'>Now Reading plugin</a> is a gerat one to use.
		 	Suffusion has templates that support this plugin, which you can control here",
		"parent" => "nr-template",
		"type" => "blurb"
	),

	array("name" => "General Settings",
		"desc" => "Control the general display settings for all templates",
		"category" => "nr-general",
		"parent" => "nr-template",
		"type" => "sub-section-4",),

	array("name" => "Number of Books per row",
		"desc" => "For all pages displaying multiple books, how many books do you want to display per row? ",
		"id" => $shortname."_nr_books_per_row",
		"parent" => "nr-template",
		"grouping" => "nr-general",
		"type" => "select",
		"options" => array("1" => "1 (One)", "2" => "2 (Two)", "3" => "3 (Three)", "4" => "4 (Four)", "5" => "5 (Five)", "6" => "6 (Six)", "7" => "7 (Seven)",
			"8" => "8 (Eight)", "9" => "9 (Nine)", "10" => "10 (Ten)"),
		"std" => "4"),

	array("name" => "Width of book cover image",
		"desc" => "Set the width of the book cover image here",
		"id" => $shortname."_nr_main_cover_w",
		"parent" => "nr-template",
		"grouping" => "nr-general",
		"type" => "text",
		"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 108",
		"std" => "108"),

	array("name" => "Height of book cover image",
		"desc" => "Set the height of the book cover image here",
		"id" => $shortname."_nr_main_cover_h",
		"parent" => "nr-template",
		"grouping" => "nr-general",
		"type" => "text",
		"hint" => "Enter the number of pixels here (don't enter 'px'). Non-integers will be ignored. Incompatible values will be treated as 160",
		"std" => "160"),

	array("name" => "Text if no books are found for a section",
		"desc" => "If you are looking at a section that has no books what text would you like to display?",
		"id" => $shortname."_nr_no_books_text",
		"parent" => "nr-template",
		"grouping" => "nr-general",
		"type" => "textarea",
		"std" => "None"),

	array("name" => "Library Settings",
		"desc" => "Control the display of the Library view",
		"category" => "nr-lib",
		"parent" => "nr-template",
		"type" => "sub-section-4",),

	array("name" => "Title of Library Page",
		"id" => $shortname."_nr_lib_title",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "text",
		"std" => "Library"),

	array("name" => "Display Currently Reading Books",
		"desc" => "Choose if you want to display the \"Currently Reading\" section",
		"id" => $shortname."_nr_lib_curr_show",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Section title for Currently Reading Books",
		"id" => $shortname."_nr_lib_curr_title",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "text",
		"std" => "Currently Reading"),

	array("name" => "Section text for Currently Reading Books",
		"desc" => "This text will be displayed at the top of the Currently Reading section",
		"id" => $shortname."_nr_lib_curr_text",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "textarea",
		"std" => ""),

	array("name" => "Display Unread Books",
		"desc" => "Choose if you want to display the \"Unread\" section",
		"id" => $shortname."_nr_lib_unread_show",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Section title for Unread Books",
		"id" => $shortname."_nr_lib_unread_title",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "text",
		"std" => "Up Next"),

	array("name" => "Section text for Unread Books",
		"desc" => "This text will be displayed at the top of the Unread Books section",
		"id" => $shortname."_nr_lib_unread_text",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "textarea",
		"std" => ""),

	array("name" => "Display Completed Books",
		"desc" => "Choose if you want to display the \"Completed\" section",
		"id" => $shortname."_nr_lib_completed_show",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Section title for Completed Books",
		"id" => $shortname."_nr_lib_completed_title",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "text",
		"std" => "Finished Reading"),

	array("name" => "Section text for Completed Books",
		"desc" => "This text will be displayed at the top of the Completed Books section",
		"id" => $shortname."_nr_lib_completed_text",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "textarea",
		"std" => ""),

	array("name" => "Order of sections",
		"desc" => "You can define the order in which the Currently Reading, Unread and Completed sections appear: ",
		"id" => $shortname."_nr_lib_order",
		"parent" => "nr-template",
		"grouping" => "nr-lib",
		"type" => "sortable-list",
		"std" => suffusion_entity_prepositions('nr')),

	array("name" => "Single Book Settings",
		"desc" => "Control the display of the Single Book view",
		"category" => "nr-single",
		"parent" => "nr-template",
		"type" => "sub-section-4",),

	array("name" => "Reading statistics: Show when book was added to library",
		"desc" => "This text will be displayed below the book's image",
		"id" => $shortname."_nr_single_added_show",
		"parent" => "nr-template",
		"grouping" => "nr-single",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Reading statistics: Tagline for when you added this book",
		"id" => $shortname."_nr_single_added_text",
		"parent" => "nr-template",
		"grouping" => "nr-single",
		"type" => "text",
		"std" => "Added on: "),

	array("name" => "Reading statistics: Show when you began reading this book",
		"desc" => "This text will be displayed below the book's image",
		"id" => $shortname."_nr_single_started_show",
		"parent" => "nr-template",
		"grouping" => "nr-single",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Reading statistics: Tagline for when you began reading this book",
		"id" => $shortname."_nr_single_started_text",
		"parent" => "nr-template",
		"grouping" => "nr-single",
		"type" => "text",
		"std" => "Started: "),

	array("name" => "Reading statistics: Show when you finished reading this book",
		"desc" => "This text will be displayed below the book's image",
		"id" => $shortname."_nr_single_finished_show",
		"parent" => "nr-template",
		"grouping" => "nr-single",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Reading statistics: Tagline for when you finished reading this book",
		"id" => $shortname."_nr_single_finished_text",
		"parent" => "nr-template",
		"grouping" => "nr-single",
		"type" => "text",
		"std" => "Finished: "),

	array("name" => "Show meta information about the book",
		"desc" => "This text will be displayed below the book's image. Meta tags are added through the Now Reading plugin.",
		"id" => $shortname."_nr_single_meta_show",
		"parent" => "nr-template",
		"grouping" => "nr-single",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Now Reading Widget Settings",
		"desc" => "Control the display of the Widget",
		"category" => "nr-w",
		"parent" => "nr-template",
		"type" => "sub-section-4",),

	array("name" => "Display Library Search",
		"desc" => "Choose where you want the search field for the Now Reading plugin",
		"id" => $shortname."_nr_wid_search_show",
		"parent" => "nr-template",
		"grouping" => "nr-w",
		"type" => "select",
		"options" => array("top" => "Top of widget", "bottom" => "Bottom of widget", "hide" => "Hide"),
		"std" => "bottom"),

	array("name" => "Display Currently Reading Books",
		"desc" => "Choose if you want to display the \"Currently Reading\" section",
		"id" => $shortname."_nr_wid_curr_show",
		"parent" => "nr-template",
		"grouping" => "nr-w",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Section title for Currently Reading Books",
		"id" => $shortname."_nr_wid_curr_title",
		"parent" => "nr-template",
		"grouping" => "nr-w",
		"type" => "text",
		"std" => "Currently Reading"),

	array("name" => "Display Unread Books",
		"desc" => "Choose if you want to display the \"Unread\" section",
		"id" => $shortname."_nr_wid_unread_show",
		"parent" => "nr-template",
		"grouping" => "nr-w",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Section title for Unread Books",
		"id" => $shortname."_nr_wid_unread_title",
		"parent" => "nr-template",
		"grouping" => "nr-w",
		"type" => "text",
		"std" => "Up Next"),

	array("name" => "Display Completed Books",
		"desc" => "Choose if you want to display the \"Completed\" section",
		"id" => $shortname."_nr_wid_completed_show",
		"parent" => "nr-template",
		"grouping" => "nr-w",
		"type" => "radio",
		"options" => array("show" => "Show", "hide" => "Hide"),
		"std" => "show"),

	array("name" => "Section title for Completed Books",
		"id" => $shortname."_nr_wid_completed_title",
		"parent" => "nr-template",
		"grouping" => "nr-w",
		"type" => "text",
		"std" => "Finished Reading"),

	array("name" => "Order of sections",
		"desc" => "You can define the order in which the Currently Reading, Unread and Completed sections appear: ",
		"id" => $shortname."_nr_wid_order",
		"parent" => "nr-template",
		"grouping" => "nr-w",
		"type" => "sortable-list",
		"std" => suffusion_entity_prepositions('nr')),

	array("name" => "404 Page",
			"type" => "sub-section-3",
			"category" => "404-page",
			"parent" => "templates"
	),

	array("name" => "The \"404 Page\"",
			"desc" => "A 404 page is encountered when a user tries to access a page that isn't there. You can configure your 404 page title and content here.",
			"parent" => "404-page",
			"type" => "blurb"
		),

	array("name" => "Title of the 404 Page",
			"desc" => "You can set the title for the 404 page here. You can use short codes.
				While using short codes remember that not all short codes maybe available on a 404 page. E.g. [suffusion-the-year] will be available, but not [suffusion-the-author]",
			"id" => $shortname."_404_title",
			"parent" => "404-page",
			"type" => "text",
			"std" => $suffusion_404_title),

	array("name" => "Content of the 404 Page",
			"desc" => "You can set the content for the 404 page here. You can use short codes.
				While using short codes remember that not all short codes maybe available on a 404 page. E.g. [suffusion-the-year] will be available, but not [suffusion-the-author]",
			"id" => $shortname."_404_content",
			"parent" => "404-page",
			"type" => "textarea",
			"std" => $suffusion_404_content),

	);

function create_title($value) {
	echo '<h2 class="suf-header-1">'.$value['name']."</h2>\n";
}

function create_suf_header_2($value) {
	echo '<h3 class="suf-header-2">'.$value['name']."</h3>\n";
}

function create_suf_header_3($value) {
	echo '<h3 class="suf-header-3">'.$value['name']."</h3>\n";
}

function create_opening_tag($value) {
	if ($value['grouping'] != null) {
		$group_class = "suf-grouping-{$value['grouping']} suf-grouping ";
	}
	echo '<div class="'.$group_class.'suf-section fix">'."\n";
	echo "<h3>".$value['name']."</h3>\n";
	echo $value['desc']."<br/>";
	if (isset($value['note'])) {
		echo "<span class=\"note\">".$value['note']."</span><br/>";
	}
}

function create_closing_tag() {
	echo "</div><!-- suf-section -->\n";
}

function create_suf_grouping($value) {
	echo "<div class='{$value['category']}-grouping suf-section fix'>\n";
	echo "<h3 class='suf-group-handler'>".$value['name']."</h3>\n";
	echo "<div class='fix'>\n";
	echo "<div class='{$value['category']}-lhs suf-grouping-lhs'>\n";
	echo $value['desc']."<br/>";
	echo "</div>\n";
	echo "<div class='{$value['category']}-rhs suf-grouping-rhs'>\n";
	echo "</div>\n";
	echo "</div>\n";
	echo "</div>\n";
}

function create_section_for_text($value) {
	global $suffusion_options;
	create_opening_tag($value);
	$text = "";
	if (!isset($suffusion_options[$value['id']])) {
		$text = $value['std'];
	}
	else {
		$text = esc_html($suffusion_options[$value['id']]);
		$text = stripslashes($text);
	}

	echo '<input type="text" id="'.$value['id'].'" name="'.$value['id'].'" value="'.$text.'" />'."\n";
	if ($value['hint'] != null) {
		echo " &laquo; ".$value['hint']."<br/>\n";
	}
	create_closing_tag();
}

function create_section_for_textarea($value) {
	global $suffusion_options;
	create_opening_tag($value);
	echo '<textarea name="'.$value['id'].'" type="textarea" cols="" rows="">'."\n";
	if ($suffusion_options[$value['id']] != "") {
		echo stripslashes($suffusion_options[$value['id']]);
	}
	else {
		echo $value['std'];
	}
	echo '</textarea>';
	if ($value['hint'] != null) {
		echo " &laquo; ".$value['hint']."<br/>\n";
	}
	create_closing_tag();
}

function create_section_for_select($value) {
	global $suffusion_options;
	create_opening_tag($value);
	echo '<select name="'.$value['id'].'" id="'.$value['id'].'">'."\n";
	foreach ($value['options'] as $option_value => $option_text) {
		echo "<option ";
		if ($suffusion_options[$value['id']] == $option_value) {
			echo ' selected="selected"';
		}
		elseif (!isset($suffusion_options[$value['id']])&& $option_value == $value['std']) {
			echo ' selected="selected"';
		}
		echo " value='$option_value' >".$option_text."</option>\n";
	}
	echo "</select>\n";
	create_closing_tag();
}

function create_section_for_multi_select($value) {
	global $suffusion_options;
	create_opening_tag($value);
	echo '<ul class="suf-checklist" id="'.$value['id'].'-chk" >'."\n";
	$consolidated_value = $suffusion_options[$value['id']];
	if ($consolidated_value === FALSE || !isset($consolidated_value)) {
		$consolidated_value = $value['std'];
	}
	$consolidated_value = trim($consolidated_value);
	if ($consolidated_value != '') {
		$exploded = explode(',', $consolidated_value);
	}
	foreach ($value['options'] as $option_value => $option_list) {
		$checked = " ";
		if ($consolidated_value) {
			foreach ($exploded as $idx => $checked_value) {
				if ($checked_value == $option_value) {
					$checked = " checked='checked' ";
					break;
				}
			}
		}
		echo "<li>\n";
		echo '<input type="checkbox" name="'.$value['id']."_".$option_value.'" value="true" '.$checked.' class="depth-'.($option_list['depth']+1).' suf-options-checkbox-'.$value['id'].'" />'.$option_list['title']."\n";
		echo "</li>\n";
	}
	echo "</ul>\n";
	echo "<div class='suf-multi-select-button-panel'>\n";
	echo "<input type='button' name='".$value['id']."-button-all' value='Select All' class='button-all suf-multi-select-button' />\n";
	echo "<input type='button' name='".$value['id']."-button-none' value='Select None' class='button-none suf-multi-select-button' />\n";
	echo "</div>\n";
	echo '<input type="hidden" name="'.$value['id'].'" id="'.$value['id'].'" value="'.$suffusion_options[$value['id']].'"/>'."\n";
	create_closing_tag();
}

function create_section_for_radio($value) {
	global $suffusion_options;
	create_opening_tag($value);
	foreach ($value['options'] as $option_value => $option_text) {
		$checked = ' ';
		if ($suffusion_options[$value['id']] == $option_value) {
			$checked = ' checked="checked" ';
		}
		else if (!isset($suffusion_options[$value['id']]) && $value['std'] == $option_value){
			$checked = ' checked="checked" ';
		}
		else {
			$checked = ' ';
		}
		echo '<div class="suf-radio"><input type="radio" name="'.$value['id'].'" value="'.$option_value.'" '.$checked."/>".$option_text."</div>\n";
	}
	create_closing_tag();
}

function create_section_for_checkbox($value) {
	global $suffusion_options;
	create_opening_tag($value);
	if($suffusion_options[$value['id']]) {
		$checked = "checked=\"checked\"";
	}
	else {
		$checked = "";
	}
	echo '<input type="checkbox" name="'.$value['id'].'" id="'.$value['id'].'" value="true" '.$checked."/>\n";
	create_closing_tag();
}

function create_section_for_color_picker($value) {
	global $suffusion_options;
	create_opening_tag($value);
	$color_value = "";
	if (!isset($suffusion_options[$value['id']])) {
		$color_value = $value['std'];
	}
	else {
		$color_value = $suffusion_options[$value['id']];
	}

	echo '<div class="color-picker">'."\n";
	echo '<input type="text" id="'.$value['id'].'" name="'.$value['id'].'" value="'.$color_value.'" class="color" /> &laquo; Click to select color<br/>'."\n";
	echo "<strong>Default: <font color='".$value['std']."'> ".$value['std']."</font></strong> (You can copy and paste this into the box above)\n";
	echo "</div>\n";
	create_closing_tag();
}

function create_section_for_sortable_list($value) {
	global $suffusion_options;
	create_opening_tag($value);
	if (!isset($suffusion_options[$value['id']])) {
		$list_order = $value['std'];
	}
	else {
		$list_order = $suffusion_options[$value['id']];
	}
	if (is_array($list_order)) { // The order has not been set. These are the default values
		$list_order_array = $list_order;
		$keys = array();
		foreach ($list_order_array as $list_item) {
			$keys[count($keys)] = $list_item['key'];
		}
		$list_order = implode(',',$keys);
	}
	else { // The order may have been set. We need to reconcile any additions / deletions from the standard list.
		$defaults = $value['std'];
		$default_array = array();
		foreach ($defaults as $list_item) {
			$default_array[$list_item['key']] = $list_item;
		}
		$keys = explode(',',$list_order);
		$clean_keys = array();
		$list_order_array = array();
		foreach ($keys as $key) {
			$list_item = $default_array[$key];
			if ($list_item) {
				$clean_keys[count($clean_keys)] = $key;
				$list_order_array[count($list_order_array)] = $list_item;
			}
		}
		$list_order = implode(',', $clean_keys);
	}
?>
	<script type="text/javascript">
	$j = jQuery.noConflict();
	$j(document).ready(function() {
		$j("#<?php echo $value['id']; ?>-ui").sortable({
			update: function(){
				$j('input#<?php echo $value['id']; ?>').val($j("#<?php echo $value['id']; ?>-ui").sortable('toArray'));
			}
		});
		$j("#<?php echo $value['id']; ?>-ui").disableSelection();
	});
	</script>
<?php
	echo "<ul id='".$value['id']."-ui' name='".$value['id']."-ui' class='suf-sort-list'>\n";
	foreach ($list_order_array as $list_item) {
		echo "<li id='".$list_item['key']."' class='suf-sort-list-item'>".$list_item['value']."</li>";
	}
	echo "</ul>\n";
	echo "<input id='".$value['id']."' name='".$value['id']."' type='hidden' value='$list_order'/>";
	create_closing_tag();
}

function create_section_for_slider($value) {
	global $suffusion_options;
	create_opening_tag($value);
	$options = $value['options'];
	if (!isset($suffusion_options[$value['id']])) {
		$default = $value['std'];
	}
	else {
		$default = $suffusion_options[$value['id']];
	}
?>
	<script type="text/javascript">
	$j = jQuery.noConflict();
	$j(document).ready(function() {
		$j("#<?php echo $value['id']; ?>-slider").slider({
			range: "<?php echo $options['range']; ?>",
			value: <?php echo (int)$default; ?>,
			min: <?php echo $options['min']; ?>,
			max: <?php echo $options['max']; ?>,
			step: <?php echo $options['step']; ?>,
			slide: function(event, ui) {
				$j("input#<?php echo $value['id']; ?>").val(ui.value);
			}
		});

	});
	</script>

	<div class='slider'>
		<p>
			<input type="text" id="<?php echo $value['id']; ?>" name="<?php echo $value['id']; ?>" value="<?php echo $default; ?>" class='slidertext' /> <?php echo $options['unit'];?>
		</p>
		<div id="<?php echo $value['id']; ?>-slider"  style="width:<?php echo $options['size'];?>;"></div>
	</div>
<?php
	create_closing_tag();
}

function create_section_for_background($value) {
	global $suffusion_options;
	create_opening_tag($value);
	$options = $value['options'];
	if (!isset($suffusion_options[$value['id']])) {
		$default = $value['std'];
		$default_txt = "";
		foreach ($value['std'] as $opt => $opt_val) {
			$default_txt .= $opt."=".$opt_val.";";
		}
	}
	else {
		$default_txt = $suffusion_options[$value['id']];
		$default = $default_txt;
		$vals = explode(";", $default);
		$default = array();
		foreach ($vals as $val) {
			$pair = explode("=", $val);
			$default[$pair[0]] = $pair[1];
		}
	}
	$repeats = array("repeat" => "Repeat horizontally and vertically",
		"repeat-x" => "Repeat horizontally only",
		"repeat-y" => "Repeat vertically only",
		"no-repeat" => "Do not repeat");

	$positions = array("top left" => "Top left",
		"top center" => "Top center",
		"top right" => "Top right",
		"center left" => "Center left",
		"center center" => "Middle of the page",
		"center right" => "Center right",
		"bottom left" => "Bottom left",
		"bottom center" => "Bottom center",
		"bottom right" => "Bottom right");

	foreach ($value['options'] as $option_value => $option_text) {
		$checked = ' ';
		if ($suffusion_options[$value['id']] == $option_value) {
			$checked = ' checked="checked" ';
		}
		else if (!isset($suffusion_options[$value['id']]) && $value['std'] == $option_value){
			$checked = ' checked="checked" ';
		}
		else {
			$checked = ' ';
		}
		echo '<div class="suf-radio"><input type="radio" name="'.$value['id'].'" value="'.$option_value.'" '.$checked."/>".$option_text."</div>\n";
	}
?>
	<div class='suf-background-options'>
	<table class='opt-sub-table'>
        <col class='opt-sub-table-cols'/>
        <col class='opt-sub-table-cols'/>
		<tr>
			<td valign='top'>
				<div class="color-picker-group">
					<strong>Background Color:</strong><br/>
					<input type="radio" name="<?php echo $value['id']; ?>-colortype" value="transparent" <?php if ($default['colortype'] == 'transparent') { echo ' checked="checked" ';} ?>/> Transparent / No color<br/>
					<input type="radio" name="<?php echo $value['id']; ?>-colortype" value="custom" <?php if ($default['colortype'] == 'custom') { echo ' checked="checked" ';} ?>/> Custom
					<input type="text" id="<?php echo $value['id']; ?>-bgcolor" name="<?php echo $value['id']; ?>-bgcolor" value="<?php echo $default['color']; ?>" class="color" /><br/>
					Default: <span color='<?php echo $default['color']; ?>"'> <?php echo $default['color']; ?> </span>
				</div>
			</td>
			<td valign='top'>
				<strong>Image URL:</strong><br/>
				<input type="text" id="<?php echo $value['id']; ?>-bgimg" name="<?php echo $value['id']; ?>-bgimg" value="<?php echo $default['image']; ?>" />
			</td>
		</tr>

		<tr>
			<td valign='top'>
				<strong>Image Position:</strong><br/>
				<select name="<?php echo $value['id']; ?>-position" id="<?php echo $value['id']; ?>-position" >
			<?php
				foreach ($positions as $option_value => $option_text) {
					echo "<option ";
					if ($default['position'] == $option_value) {
						echo ' selected="selected"';
					}
					echo " value='$option_value' >".$option_text."</option>\n";
				}
			?>
				</select>
			</td>

			<td valign='top'>
				<strong>Image Repeat:</strong><br/>
				<select name="<?php echo $value['id']; ?>-repeat" id="<?php echo $value['id']; ?>-repeat" >
			<?php
				foreach ($repeats as $option_value => $option_text) {
					echo "<option ";
					if ($default['repeat'] == $option_value) {
						echo ' selected="selected"';
					}
					echo " value='$option_value' >".$option_text."</option>\n";
				}
			?>
				</select>
			</td>
		</tr>
		<tr>
			<td valign='top' colspan='2'>
				<script type="text/javascript">
				$j = jQuery.noConflict();
				$j(document).ready(function() {
					$j("#<?php echo $value['id']; ?>-transslider").slider({
						range: "min",
						value: <?php echo (int)$default['trans']; ?>,
						min: 0,
						max: 100,
						step: 1,
						slide: function(event, ui) {
							$j("input#<?php echo $value['id']; ?>-trans").val(ui.value);
							$j("#<?php echo $value['id']; ?>").val('color=' + $j("#<?php echo $value['id']; ?>-bgcolor").val() + ';' +
																   'colortype=' + $j("input[name=<?php echo $value['id']; ?>-colortype]:checked").val() + ';' +
																   'image=' + $j("#<?php echo $value['id']; ?>-bgimg").val() + ';' +
																   'position=' + $j("#<?php echo $value['id']; ?>-position").val() + ';' +
																   'repeat=' + $j("#<?php echo $value['id']; ?>-repeat").val() + ';' +
																   'trans=' + $j("#<?php echo $value['id']; ?>-trans").val() + ';'
									);
						}
					});
				});
				</script>

				<div class='slider'>
					<p>
						<strong>Layer Transparency:</strong>
						<input type="text" id="<?php echo $value['id']; ?>-trans" name="<?php echo $value['id']; ?>-trans" value="<?php echo $default['trans']; ?>" class='slidertext' />
					</p>
					<div id="<?php echo $value['id']; ?>-transslider" class='transslider'></div>
				</div>
			</td>
		</tr>
	</table>
	<input type='hidden' id="<?php echo $value['id']; ?>" name="<?php echo $value['id']; ?>" value="<?php echo $default_txt; ?>" />
	</div>
<?php
	create_closing_tag();
}

function create_section_for_blurb($value) {
	create_opening_tag($value);
	create_closing_tag();
}

function create_section_for_button($value) {
	create_opening_tag($value);
	$category = $value['parent'];
	echo "<input name=\"".$value['id']."\" type=\"button\" value=\"".$value['std']."\" class=\"button\" onclick=\"submit_form(this, document.forms['form-$category'])\" />\n";
	create_closing_tag();
}

function get_option_structure($options) {
	$option_structure = array();
	foreach ($options as $value) {
		switch ($value['type']) {
			case "title":
				$option_structure[$value['category']] = array();
				$option_structure[$value['category']]['slug'] = $value['category'];
				$option_structure[$value['category']]['name'] = $value['name'];
				$option_structure[$value['category']]['children'] = array();
				$option_structure[$value['category']]['parent'] = null;
				break;
			case "sub-section-2":
			case "sub-section-3":
				$option_structure[$value['parent']]['children'][$value['category']] = $value['name'];

				$option_structure[$value['category']] = array();
				$option_structure[$value['category']]['slug'] = $value['category'];
				$option_structure[$value['category']]['name'] = $value['name'];
				$option_structure[$value['category']]['children'] = array();
				$option_structure[$value['category']]['parent'] = $value['parent'];
				$option_structure[$value['category']]['buttons'] = $value['buttons'];
				break;
			default:
				$option_structure[$value['parent']]['children'][$value['name']] = $value['name'];
		}
	}
	return $option_structure;
}

function get_options_html($option_structure, $selected = "theme-selection", $echo = false) {
	echo "<ul class='htabs fix'>\n";
	foreach ($option_structure as $l1) {
		if ($l1['parent'] == null) {
			foreach ($l1['children'] as $l2slug => $l2name) {
				echo "<li class='htab-$l2slug level-2'>".$l2name."</li>\n";
			}
		}
	}
	echo "</ul>\n";
	echo "<div class='content-holder fix'>\n";
	foreach ($option_structure as $l1) {
		if ($l1['parent'] == null) {
			foreach ($l1['children'] as $l2slug => $l2name) {
				get_options_html_for_group($option_structure, 'theme-selection', $l2slug, false);
			}
		}
	}
	echo "</div>\n";
}

function get_options_html_for_group($option_structure, $selected = "theme-selection", $group, $echo = false) {
	global $themename, $shortname, $options, $spawned_options, $theme_name, $suf_theme_definitions;
	echo "<div class='suf-options suf-options-$group'>";
	foreach ($option_structure as $l1) {
		if ($l1['parent'] == null) {
			foreach ($l1['children'] as $l2slug => $l2name) {
				if ($group == $l2slug) {
					echo "<h1>$l2name</h1>\n";
				}
			}
		}
	}
	echo "<ul class='tabs'>";
	foreach ($option_structure as $l1) {
		if ($l1['parent'] == null) {
			foreach ($l1['children'] as $l2slug => $l2name) {
				if ($group == $l2slug) {
					foreach ($option_structure[$l2slug]['children'] as $l3slug => $l3name) {
						echo "<li class='$l3slug'><a class=\"$l3slug level-3\">".$l3name."</a></li>\n";
					}
				}
			}
		}
	}
	echo "</ul>";
	foreach ($option_structure as $option) {
		if ($option['parent'] == null) {
			foreach ($option['children'] as $l2slug => $l2name) {
				if ($group == $l2slug) {
					foreach ($option_structure[$l2slug]['children'] as $category => $l3name) {
						create_form($themename, $shortname, $options, $spawned_options, $theme_name, $suf_theme_definitions, $category);
					}
				}
			}
		}
	}
	echo "</div>";
//	return $ret;
}

function get_options_for_category($options, $category) {
	$ret = array();
	if ($category == "all") {
		return $options;
	}
	foreach ($options as $value) {
		if ($value['parent'] == $category) {
			$ret[count($ret)] = $value;
		}
	}
	return $ret;
}

function get_spawned_options_for_category($options, $spawned_options, $category) {
	$ret = array();
	if ($category == "all") {
		return $spawned_options;
	}
	foreach ($options as $optionvalue) {
		if ($optionvalue['parent'] == $category) {
			foreach ($spawned_options as $value) {
				if ($value['parent'] == $optionvalue['id']) {
					if (!in_array($value, $ret)) {
						$ret[count($ret)] = $value;
					}
				}
			}
		}
	}
	return $ret;
}

function create_form($themename, $shortname, $options, $spawned_options, $theme_name, $suf_theme_definitions, $category = "all") {
	$filtered_options = get_options_for_category($options, $category);
	echo "<div class=\"$category main-content\" id='$category'>\n";
	$option_structure = get_option_structure($options);
	echo '<h3 class="suf-header-2">'.$option_structure[$category]['name']."</h3>\n";
	echo "<form method=\"post\" name=\"form-$category\">\n";
	foreach ($filtered_options as $value) {
		switch ( $value['type'] ) {
			case "title":
				create_title($value);
				break;

			case "sub-section-2":
				create_suf_header_2($value);
				break;

			case "sub-section-3":
				create_suf_header_3($value);
				break;

			case "sub-section-4":
				create_suf_grouping($value);
				break;

			case "text";
				create_section_for_text($value);
				break;

			case "textarea":
				create_section_for_textarea($value);
				break;

			case "select":
				create_section_for_select($value);
				break;

			case "multi-select":
				create_section_for_multi_select($value);
				break;

			case "radio":
				create_section_for_radio($value);
				break;

			case "checkbox":
				create_section_for_checkbox($value);
				break;

			case "color-picker":
				create_section_for_color_picker($value);
				break;

			case "sortable-list":
				create_section_for_sortable_list($value);
				break;

			case "slider":
				create_section_for_slider($value);
				break;

			case "background":
				create_section_for_background($value);
				break;

			case "blurb":
				create_section_for_blurb($value);
				break;

			case "button":
				create_section_for_button($value);
				break;
		}
	}

	if ($option_structure[$category]['buttons'] == 'special-buttons') {
		echo "<input type=\"hidden\" name=\"formaction\" value=\"default\" />\n";
		echo "<input type=\"hidden\" name=\"formcategory\" value=\"$category\" />\n";
	}
	else if ($option_structure[$category]['buttons'] != 'no-buttons') {
		echo "<div class=\"suf-button-bar\">\n";
		echo "<input name=\"save\" type=\"button\" value=\"Save changes\" class=\"button\" onclick=\"submit_form(this, document.forms['form-$category'])\" />\n";
		echo "<input name=\"reset\" type=\"button\" value=\"Reset page to default options\" class=\"button\" onclick=\"submit_form(this, document.forms['form-$category'])\" />\n";
		echo "<input name=\"reset_all\" type=\"button\" value=\"Reset options in all pages to default values\" class=\"button\" onclick=\"submit_form(this, document.forms['form-$category'])\" />\n";
		echo "<input type=\"hidden\" name=\"formaction\" value=\"default\" />\n";
		echo "<input type=\"hidden\" name=\"formcategory\" value=\"$category\" />\n";
		echo "</div><!-- suf-button-bar -->\n";
	}
	echo "</form>\n";

	echo "</div><!-- main content -->\n";
}
?>